<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );	

class JVFrameworkExtensionBootstrap extends JVFrameworkExtension{

	public function beforeRender(){
		if($this['option']->get('global.bootstrap.css', 1)){
			$this->css();
		}
		
		if($this['option']->get('global.bootstrap.responsive-css', 1)){
			$this->css(true);
		}
		
		if($this['option']->get('global.bootstrap.js', 1)){
			$this['asset']->jQuery();
			$this->js();
		}
	}
	
	protected function css($responsive = false) {
		if(constant('JDEBUG')){
			$bootstrap = 'bootstrap.css';
			if ($this ['option']->isRTL ()) {
				$bootstrap = 'bootstrap.rtl.css';
			}
		}else{
			$bootstrap = 'bootstrap.min.css';
			if ($this ['option']->isRTL ()) {
				$bootstrap = 'bootstrap.min.rtl.css';
			}
		}
		$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/$bootstrap") );
			
		if ($responsive && $this['option']->get('global.responsive.enable', 1)) {
			if(constant('JDEBUG')){
				$bootstrap = 'bootstrap-responsive.css';
				if ($this ['option']->isRTL ()) {
					$bootstrap = 'bootstrap-responsive.rtl.css';
				}
			}else{
				$bootstrap = 'bootstrap-responsive.min.css';
				if ($this ['option']->isRTL ()) {
					$bootstrap = 'bootstrap-responsive.min.rtl.css';
				}
			}
			$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/$bootstrap") );
			
			if($this ['option']->get('global.responsive.767', 1)){
				if ($this ['option']->isRTL ()) {
					$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive-rtl/responsive-767px-max.css"), array('media' => 'screen and (max-width: 767px)'));
				}else{
					$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive/responsive-767px-max.css"), array('media' => 'screen and (max-width: 767px)') );
				}				
			}			
			if($this ['option']->get('global.responsive.979', 1)){
				if ($this ['option']->isRTL ()) {
					$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive-rtl/responsive-768px-979px.css"), array('media' => 'screen and (min-width: 767px) and (max-width: 979px)') );
				}else{
					$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive/responsive-768px-979px.css"), array('media' => 'screen and (min-width: 767px) and (max-width: 979px)') );
				}
			}			
			if($this ['option']->get('global.responsive.1900', 1)){
				if($this ['option']->get('global.responsive.1200', 1)){
					if ($this ['option']->isRTL ()) {
						$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive-rtl/responsive-1200px-1899px.css"), array('media' => 'screen and (min-width: 767px) and (max-width: 1899px)') );
					}else{
						$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive/responsive-1200px-1899px.css"), array('media' => 'screen and (min-width: 1200px) and (max-width: 1899px)') );
					}
				}
				if ($this ['option']->isRTL ()) {
					$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive-rtl/responsive-1900px-min.css"), array('media' => 'screen and (min-width: 1900px)') );
				}else{
					$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive/responsive-1900px-min.css"), array('media' => 'screen and (min-width: 1900px)') );
				}
			}else{
				if($this ['option']->get('global.responsive.1200', 1)){
					if ($this ['option']->isRTL ()) {
						$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive-rtl/responsive-1200px-min.css"), array('media' => 'screen and (min-width: 1200px)') );
					}else{
						$this ['asset']->addStyle ( $this ['path']->url ( "extensions::bootstrap/assets/css/responsive/responsive-1200px-min.css"), array('media' => 'screen and (min-width: 1200px)') );
					}
				}
			}
		}
	}
	
	protected function js() {
		if(constant('JDEBUG'))
			$this ['asset']->addScript ( $this ['path']->url ( 'extensions::bootstrap/assets/js/bootstrap.js' ) );
		else
			$this ['asset']->addScript ( $this ['path']->url ( 'extensions::bootstrap/assets/js/bootstrap.min.js' ) );
	}
}