<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );	

class JVFrameworkExtensionMenu extends JVFrameworkExtension{
    protected static $moduleid;

    public function beforeRender(){
        if($this['option']->get('menu.position', 'menu')){
            $this['position']->register('menu', $this['option']->get('menu.position', 'menu'));
        }
    }

    public function html($options = array()) {
        ob_start();?>
        <div class="flexMenuToggle hidden-desktop">
            <a href="#" onClick="jQuery('#<?php echo self::$moduleid; ?>').toggle()">
            </a>
        </div>
        <?php
        return ob_get_clean();
    }

	public function onRenderModule(&$module, &$params) {
		if($module->module != 'mod_menu') return;	
		
		$html = array();
		
		if ($params->get('jvmenutyle') == 'flex' || $params->get('jvmenutyle') == 'flex_df') {
			$module->content = $this->flexMenu( $module, $params );
			
		}
	}
	
	protected function flexMenu($module, JRegistry $params ){
		if(!class_exists('JVCustomParam')){
			JFactory::getApplication()->enqueueMessage('This extension requires JV jQuery Libraries 1.0.8 or newer, please install and enable it first! ', 'error');
			return 'Please install JV jQuery Library!!';
		}
					
		if( $params->get('jvmenutyle') ==  'flex_df'){	
			$params->merge($this['option']->getOptions());
			$params->set ( 'flexmenu_style', 'horizontal');
		}
		// Menu id
		$menu_id = "fxmenu{$module->id}";
		$params->set('menu_id', $menu_id);
        self::$moduleid = $menu_id;
		
		// Menu class
		$menu_class = 'menu fxmenu' . $params->get ( 'class_sfx' ).' cssmenu '.$params->get ( 'flexmenu_style', 'horizontal');
		if($params->get ( 'flexmenu_style') == 'dropline' || $params->get ( 'flexmenu_style') == 'horizontal'){
			$menu_class .= ' dropmenu';
		}
		$params->set('menu_class', $menu_class);

		$p = JVCustomParam::parse($params->get ('flexconfig','{}'));
		
		// Swap direction
		if($this['option']->isRTL()) $this->swap($p);
		
		$this['asset']->addInlineScript("
				jQuery(function($){
					new JVMegaMenu($('#{$menu_id}')," . json_encode ( $p ) . ");
                });"
		);		
		
		$showEff = $p->defaultEff->showEff->effect->{'@selected'};
		$hideEff = $p->defaultEff->hideEff->effect->{'@selected'};	
		
		$this['asset']->jQuery('ui.accordion','effects.' . $showEff, 'effects.' . $hideEff);
		
		foreach ( $p->customEff as $v ) {
			$showEff = $v->showEff->effect->{'@selected'};
			$hideEff = $v->hideEff->effect->{'@selected'};
			JQuery ( 'effects.' . $showEff, 'effects.' . $hideEff );
		}
		
		$this['asset']->addScript ( $this['path']->url('extensions::menu/assets/js/megamenu.js'));		
		if ($this['option']->isRTL ()) {
			$this['asset']->addStyle ( $this['path']->url('extensions::menu/assets/css/flexmenu.rtl.css') );
		} else {
			$this['asset']->addStyle ( $this['path']->url('extensions::menu/assets/css/flexmenu.css') );
		}
		
		require_once dirname ( __FILE__ ) . "/classes/helper.php";
		require_once dirname ( __FILE__ ) . "/classes/flexmenu.php"; 		
		
		$flexmenu = new FlexMenu ( $params );
		
		return $flexmenu->render ();
	}

	public function swap($ob){		
		if (is_object($ob) || is_array($ob)) {			
			foreach ($ob as $key => &$val) {
				if(is_string($val)){
					if($val == 'right'){
						$val = 'left';
					}elseif($val == 'left'){
						$val = 'right';
					}
				}else{
					$this->swap($val);
				}				
			}
		}else{
			return false;
		}
	}
	
	// Add parameter
	public function onContentPrepareForm($form, $data) {
		if ($form->getName() == 'com_menus.item') {
			JHtml::_('behavior.framework');
			$doc = JFactory::getDocument();
			$doc->addStyleSheet($this['path']->url('extensions::menu/assets/admin/css/menu.css'));			
			
			if(version_compare(JVERSION, '3', '>=')){
				$doc->addScript(JUri::root(true).'/media/jui/js/bootstrap.min.js');
				$doc->addScript(JUri::root(true).'/media/jui/js/chosen.jquery.min.js');				
			}else{
				jQuery();
			}
			$doc->addScript($this['path']->url('extensions::menu/assets/admin/js/menu.js'));
			
			JForm::addFieldPath(dirname ( __FILE__ ) .  '/fields');
			$form->loadFile ( dirname ( __FILE__ ) .  '/config/menu.xml' );
		}
	
		if (JFactory::getApplication()->input->get ( 'option' ) == 'com_modules' && JFactory::getApplication()->input->get ( 'layout' ) == 'edit') {
			$postData = JFactory::getApplication()->input->get('jform', '', 'array');
			$isMenu = isset($postData['module']) && $postData['module'] == 'mod_menu' || $data->module == 'mod_menu';
			if(!$isMenu){
				return;
			}
			
			JHtml::_('behavior.framework');
			$doc = JFactory::getDocument();
			if(version_compare(JVERSION, '3', '>=')){
				$doc->addScript(JUri::root(true).'/media/jui/js/bootstrap.min.js');
				$doc->addScript(JUri::root(true).'/media/jui/js/chosen.jquery.min.js');
			}
			$doc->addScript($this['path']->url('extensions::menu/assets/admin/js/module.js'));
			$doc->addStyleSheet($this['path']->url('extensions::menu/assets/admin/css/module.css'));
			$form->addFieldPath(dirname ( __FILE__ ) .  '/fields');
			$form->loadFile ( dirname ( __FILE__ ) .  '/config/module.xml' );
		}
	}
}