<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */

// No direct access to this file
defined ( '_JEXEC' ) or die ( 'Restricted access' );
jimport ( 'joomla.plugin.plugin' );

class plgSystemJVFramework extends JPlugin {	
	
	/**
	 * Init Framework	
	 * Map event
	 */	
	public function onAfterRoute(){
		// Register JV Framework Loader
		if (is_file ( dirname ( __FILE__ ) . '/framework/loader.php')) {
			include_once (dirname ( __FILE__ ) . '/framework/loader.php');
		}

		// Load Framework
		JVFrameworkLoader::import ( 'framework' );
		JV::getInstance ();

        // Fix bug template assign
        JV::helper('event')->fireEvent('onAfterInitialise');

		$app = JFactory::getApplication();
		if($app->isAdmin()){
			$edit = JFactory::getApplication()->input->get('option') == 'com_templates' && JFactory::getApplication()->input->get('task') == 'style.edit';
			if($edit){
				// Check template is support
				$id    = JFactory::getApplication()->input->get('id');
				$db    = JFactory::getDbo();
				$query = $db->getQuery(true);

				$query->select('template')->from('#__template_styles')->where('id='.$id);
				$db->setQuery($query);
				$template = $db->loadResult();

				$path = JPATH_ROOT."/templates/{$template}/version.php";
				if(is_file($path)){
					include_once $path;

					if(isset($framework) && isset($version)){
						$app->redirect("index.php?option=com_jvframework&task=style.edit&id={$id}");
					}
				}
			}

			// Add installer
			if(JFactory::getApplication()->input->get('option') == 'com_installer'){
				//JVFrameworkLoader::import('joomlib.installer.adapters.theme');
				JVFrameworkLoader::import('joomlib.installer.adapters.extension');

				$lang = JFactory::getLanguage();
				$lang->load('plg_system_jvframework', JPATH_ADMINISTRATOR);

				$installer = JInstaller::getInstance();
				$installer->setAdapter('extension', new JInstallerExtension($installer, JFactory::getDbo()));
				//$installer->setAdapter('theme', new JInstallerTheme($installer, JFactory::getDbo()));
			}
		}

		JV::helper('event')->fireEvent('onAfterRoute');
	}
	
	/**
	 * Map event
	 */
	public function onAfterRender(){			
		JV::helper('event')->fireEvent('onAfterRender');
	}
	
	/**
	 * Map event
	 */
	public function onContentPrepareForm($form, $data) {
		JV::helper('event')->fireEvent('onContentPrepareForm', array($form, $data));
	}
	
	/**
	 * Map event
	 */ 
	public function onContentPrepare($context, &$article, &$params, $page = 0) {
		JV::helper('event')->fireEvent('onContentPrepare', array($context, &$article, &$params, $page));
	}
	
	/**
	 * Map event
	 */
	function onPrepareContent( &$article, &$params, $page ){
		return $this->onContentPrepare('content.article', $article, $params, $page);
	}
	
}