<?php
/**
 * @package		Joomla.Site
 * @subpackage	com_search
 * @copyright	Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;
?>
<ul class="search-results<?php echo $this->pageclass_sfx; ?>">
<?php foreach($this->results as $result) : ?>
<li>
	<h4 class="result-title">
		<?php echo $this->pagination->limitstart + $result->count.'. ';?>
		<?php if ($result->href) :?>
			<a href="<?php echo JRoute::_($result->href); ?>"<?php if ($result->browsernav == 1) :?> target="_blank"<?php endif;?>>
				<?php echo $this->escape($result->title);?>
			</a>
		<?php else:?>
			<?php echo $this->escape($result->title);?>
		<?php endif; ?>
	</h4>
	<?php if ($result->section) : ?>
		<div class="article-info">
			<dd class="small<?php echo $this->pageclass_sfx; ?>">
				<strong><?php echo JText::sprintf('JGLOBAL_CATEGORY', '');?>:</strong> <?php echo $this->escape($result->section); ?>
			</dd>
            <?php if ($this->params->get('show_date')) : ?>
            <dd class="result-created<?php echo $this->pageclass_sfx; ?>">
				<strong><?php echo JText::sprintf('JGLOBAL_CREATED_DATE_ON', ''); ?>:</strong> <?php echo $result->created; ?>
			</dd>
			<?php endif; ?>
		</div>
	<?php endif; ?>
	<div class="result-text">
		<?php echo $result->text; ?>
	</div>
</li>
<?php endforeach; ?>
</ul>

<?php if($this->pagination->getPagesLinks()):?>
<div class="pagination">
	<?php echo $this->pagination->getPagesLinks(); ?>
</div>
<?php endif;?>