<?php
/**
 # com_jvframework - JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */

// No direct access to this file
defined ( '_JEXEC' ) or die ( 'Restricted access' );
require_once dirname ( dirname ( __FILE__ ) ) . '/menuitem.php';

class FlexMenuItemComponent extends FlexMenuItem {
	
	function getLink() {
		$flink = $this->item->link;
		
		$router = JSite::getRouter ();
		if ($router->getMode () == JROUTER_MODE_SEF) {
			$flink = 'index.php?Itemid=' . $this->item->id;
		} else {
			$flink .= '&Itemid=' . $this->item->id;
		}
		
		return parent::getLink ( $flink );
	}
	
	function getHtml() {

        $html = $class = $attributes = array ();
		$attributes [] = "href='{$this->getLink()}'";
		
		$this->item->title = htmlspecialchars ( $this->item->title );
        if ($this->item->params->get ( 'menu-anchor_css', '' )) {
            $class [] = htmlspecialchars ( $this->item->params->get ('menu-anchor_css') );
        }
        if ($this->item->params->get ( 'menu_image' )  && $this->item->params->get ( 'menu_image' ) != -1){
            if($this->item->params->get ( 'menu_image_type', 'img' ) == 'img'){
                $class [] = "iconImage";
            }else{
                $class [] = "iconBackground";
            }
        }
        if($class){
            $attributes [] = 'class="' . implode(' ',$class) . '" ';
        }
		
		if ($this->item->params->get ( 'menu-anchor_title', '' )) {
			$attributes [] = 'title="' . htmlspecialchars ( $this->item->params->get ( 'menu-anchor_title' ) ) . '" ';
		}
		
		if ($this->item->browserNav == 1) {
			$attributes [] = 'target="_blank"';
		}
		
		if ($this->item->browserNav == 2) {
			$attributes [] = "onclick=\"window.open(this.href,'targetWindow','toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes');return false;\"";
		}
		
		$html [] = "<a " . implode ( ' ', $attributes ) . ">";
		$html [] = $this->getTitle();			
		$html [] = "</a>";
		
		return implode ( '', $html );
	}
}