<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

class JVFrameworkHelperTemplate extends JVFrameworkHelper {
	protected $_name = 'template';
	protected $_alias = array();
	protected $_unloads = array();
	public    $document = null;
	
	public function __construct() {
		parent::__construct();
		$this->document =& JFactory::getDocument();
	}
	
	public function __get($key){
		switch($key){
			case 'document':
				return $this->document;
			break;
			case 'params':
				return $this['option'];
				break;
			default:
				return isset($this->document->{$key}) ? $this->document->{$key} : '';
				break;
		}
	}
	 
	public function countModules($key){
		return $this['position']->count($key);
	}
	
	public function render($name, $params = array(), $type = 'layouts') {
		if(isset($this->_unloads[$name])){
			return false;
		}
		
		if(isset($this->_alias[$name])){
			$name = $this->_alias[$name];
		}
		
		if (strpos($name, '::')){
			list ( $type, $name ) = explode ( '::', $name );
		}
		if(!$type){
			$type = 'layouts';
		}		
		$path = $this['path']->findPath($name.'.php', $type);
		
		if(is_file($path)){
			ob_start();
			extract($params);
			
			require $path;
			return ob_get_clean();
		}		
	}
	
	public function alias ($name, $alias){
		$this->_alias[$name] = $alias;
	}
	
	public function unLoad ($name){
		if(isset($this->_alias[$name])){
			$name = $this->_alias[$name];
		}
		$this->_unloads[$name] = 1;
	}	
}
?>