-- ----------------------------
-- Table structure for `#__assets`
-- ----------------------------
DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM AUTO_INCREMENT=87 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__assets
-- ----------------------------
INSERT INTO `#__assets` VALUES ('1', '0', '1', '165', '0', 'root.1', 'Root Asset', '{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}');
INSERT INTO `#__assets` VALUES ('2', '1', '1', '2', '1', 'com_admin', 'com_admin', '{}');
INSERT INTO `#__assets` VALUES ('3', '1', '3', '8', '1', 'com_banners', 'com_banners', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('4', '1', '9', '10', '1', 'com_cache', 'com_cache', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}');
INSERT INTO `#__assets` VALUES ('5', '1', '11', '12', '1', 'com_checkin', 'com_checkin', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}');
INSERT INTO `#__assets` VALUES ('6', '1', '13', '14', '1', 'com_config', 'com_config', '{}');
INSERT INTO `#__assets` VALUES ('7', '1', '15', '20', '1', 'com_contact', 'com_contact', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('8', '1', '21', '110', '1', 'com_content', 'com_content', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('9', '1', '111', '112', '1', 'com_cpanel', 'com_cpanel', '{}');
INSERT INTO `#__assets` VALUES ('10', '1', '113', '114', '1', 'com_installer', 'com_installer', '{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}');
INSERT INTO `#__assets` VALUES ('11', '1', '115', '116', '1', 'com_languages', 'com_languages', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('12', '1', '117', '118', '1', 'com_login', 'com_login', '{}');
INSERT INTO `#__assets` VALUES ('13', '1', '119', '120', '1', 'com_mailto', 'com_mailto', '{}');
INSERT INTO `#__assets` VALUES ('14', '1', '121', '122', '1', 'com_massmail', 'com_massmail', '{}');
INSERT INTO `#__assets` VALUES ('15', '1', '123', '124', '1', 'com_media', 'com_media', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}');
INSERT INTO `#__assets` VALUES ('16', '1', '125', '126', '1', 'com_menus', 'com_menus', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('17', '1', '127', '128', '1', 'com_messages', 'com_messages', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}');
INSERT INTO `#__assets` VALUES ('18', '1', '129', '130', '1', 'com_modules', 'com_modules', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('19', '1', '131', '136', '1', 'com_newsfeeds', 'com_newsfeeds', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('20', '1', '137', '138', '1', 'com_plugins', 'com_plugins', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('21', '1', '139', '140', '1', 'com_redirect', 'com_redirect', '{\"core.admin\":{\"7\":1},\"core.manage\":[]}');
INSERT INTO `#__assets` VALUES ('22', '1', '141', '142', '1', 'com_search', 'com_search', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}');
INSERT INTO `#__assets` VALUES ('23', '1', '143', '144', '1', 'com_templates', 'com_templates', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('24', '1', '145', '148', '1', 'com_users', 'com_users', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('25', '1', '149', '156', '1', 'com_weblinks', 'com_weblinks', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('26', '1', '157', '158', '1', 'com_wrapper', 'com_wrapper', '{}');
INSERT INTO `#__assets` VALUES ('27', '8', '22', '33', '2', 'com_content.category.2', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('28', '3', '4', '5', '2', 'com_banners.category.3', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('29', '7', '16', '17', '2', 'com_contact.category.4', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('30', '19', '132', '133', '2', 'com_newsfeeds.category.5', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('31', '25', '150', '151', '2', 'com_weblinks.category.6', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('32', '24', '146', '147', '1', 'com_users.notes.category.7', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('33', '1', '159', '160', '1', 'com_finder', 'com_finder', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}');
INSERT INTO `#__assets` VALUES ('34', '1', '161', '162', '1', 'com_joomlaupdate', 'com_joomlaupdate', '{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('35', '1', '163', '164', '1', 'com_jvframework', 'jvframework', '{}');
INSERT INTO `#__assets` VALUES ('36', '27', '23', '24', '3', 'com_content.article.1', 'Demo', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('39', '8', '34', '55', '2', 'com_content.category.8', 'Blog', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('40', '58', '61', '62', '3', 'com_content.article.4', 'Joomla! Overview', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('41', '58', '59', '60', '3', 'com_content.article.5', 'Joomla! License Guidelines', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('42', '58', '63', '64', '3', 'com_content.article.6', 'More about Joomla', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('43', '58', '57', '58', '3', 'com_content.article.7', 'FAQ', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('44', '58', '65', '66', '3', 'com_content.article.8', 'The News', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('45', '58', '67', '68', '3', 'com_content.article.9', 'Web links', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('48', '39', '35', '36', '3', 'com_content.article.12', 'For Developers', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('46', '39', '43', '44', '3', 'com_content.article.10', 'About JV Framework', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('47', '39', '37', '38', '3', 'com_content.article.11', 'Responsive Web Design and Mobility Support', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('55', '25', '152', '153', '2', 'com_weblinks.category.11', 'JV Framework', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('50', '39', '39', '40', '3', 'com_content.article.13', 'JV Templates', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('51', '39', '41', '42', '3', 'com_content.article.14', 'Beautiful Icons', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('52', '39', '45', '46', '3', 'com_content.article.15', 'JV Extension', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('53', '39', '47', '48', '3', 'com_content.article.16', 'Free Social Icons', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('54', '7', '18', '19', '2', 'com_contact.category.10', 'Contact', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('56', '25', '154', '155', '2', 'com_weblinks.category.12', 'JV Templates', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('57', '3', '6', '7', '2', 'com_banners.category.13', 'Joomla', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('58', '8', '56', '77', '2', 'com_content.category.14', 'Joomla', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('59', '39', '49', '50', '3', 'com_content.article.17', 'About JV Framework (2)', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('60', '58', '69', '70', '3', 'com_content.article.18', 'Joomla', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('61', '58', '71', '72', '3', 'com_content.article.19', 'User Component', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('62', '58', '73', '74', '3', 'com_content.article.20', 'Search Component', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('63', '58', '75', '76', '3', 'com_content.article.21', 'News Feed', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('64', '19', '134', '135', '2', 'com_newsfeeds.category.15', 'Sample Data-Newsfeeds', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('65', '27', '25', '26', '3', 'com_content.article.22', 'Services', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('66', '70', '101', '102', '3', 'com_content.article.23', 'Performance', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('67', '27', '27', '28', '3', 'com_content.article.24', 'Module Position', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('68', '27', '29', '30', '3', 'com_content.article.25', 'Position', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('69', '71', '80', '81', '4', 'com_content.article.26', 'Extensions Tab', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('70', '8', '78', '109', '2', 'com_content.category.16', 'Extensions', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('71', '70', '79', '100', '3', 'com_content.category.17', 'Utilities', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO `#__assets` VALUES ('72', '71', '82', '83', '4', 'com_content.article.27', 'Analytics', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('73', '71', '84', '85', '4', 'com_content.article.28', 'Breadcrumb', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('74', '71', '86', '87', '4', 'com_content.article.29', 'Copyright', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('75', '71', '88', '89', '4', 'com_content.article.30', 'Date', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('76', '71', '90', '91', '4', 'com_content.article.31', 'Font Resizer', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('77', '71', '92', '93', '4', 'com_content.article.32', 'Lazy Loading', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('78', '71', '94', '95', '4', 'com_content.article.33', 'Logo', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('79', '71', '96', '97', '4', 'com_content.article.34', 'System Message', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('80', '71', '98', '99', '4', 'com_content.article.35', 'Back to top', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('81', '70', '103', '104', '3', 'com_content.article.36', 'Layout', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('82', '70', '105', '106', '3', 'com_content.article.37', 'Position layout & Front-end effect', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('83', '70', '107', '108', '3', 'com_content.article.38', 'Typography', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('84', '39', '51', '52', '3', 'com_content.article.39', 'JV Template Group', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('85', '27', '31', '32', '3', 'com_content.article.40', 'Error page', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO `#__assets` VALUES ('86', '39', '53', '54', '3', 'com_content.article.41', 'văn test', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');

-- ----------------------------
-- Table structure for `#__associations`
-- ----------------------------
DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__associations
-- ----------------------------

-- ----------------------------
-- Table structure for `#__banner_clients`
-- ----------------------------
DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__banner_clients
-- ----------------------------
INSERT INTO `#__banner_clients` VALUES ('1', 'Joomlavi', 'ThyTran', 'info@joomlavi.com', '', '1', '0', '0000-00-00 00:00:00', '', '0', '', '-1', '0', '0');

-- ----------------------------
-- Table structure for `#__banner_tracks`
-- ----------------------------
DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__banner_tracks
-- ----------------------------

-- ----------------------------
-- Table structure for `#__banners`
-- ----------------------------
DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__banners
-- ----------------------------
INSERT INTO `#__banners` VALUES ('1', '1', '0', 'Get Framework', 'get-framework', '0', '29886', '26', 'http://www.joomlavi.com/joomla-templates/jv-framework-30.html', '1', '13', '', '', '1', '1', '', '{\"imageurl\":\"images\\/banners\\/get-fw.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomlavi\"}', '0', '', '-1', '0', '0', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2012-07-30 06:44:39', '*');

-- ----------------------------
-- Table structure for `#__categories`
-- ----------------------------
DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the framework_assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__categories
-- ----------------------------
INSERT INTO `#__categories` VALUES ('1', '0', '0', '0', '31', '0', '', 'system', 'ROOT', 'root', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '204', '2009-10-18 16:07:09', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('2', '27', '1', '1', '2', '1', 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '204', '2010-06-28 13:26:37', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('3', '28', '1', '3', '4', '1', 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '204', '2010-06-28 13:27:35', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('4', '29', '1', '5', '6', '1', 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '204', '2010-06-28 13:27:57', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('5', '30', '1', '7', '8', '1', 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '204', '2010-06-28 13:28:15', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('6', '31', '1', '9', '10', '1', 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '204', '2010-06-28 13:28:33', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('7', '32', '1', '11', '12', '1', 'uncategorised', 'com_users.notes', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '204', '2010-06-28 13:28:33', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('8', '39', '1', '13', '14', '1', 'blog', 'com_content', 'Blog', 'blog', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-07-03 07:15:34', '92', '2012-10-01 02:34:32', '0', '*');
INSERT INTO `#__categories` VALUES ('11', '55', '1', '17', '18', '1', 'jv-framework', 'com_weblinks', 'JV Framework', 'jv-framework', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-07-30 03:54:41', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('10', '54', '1', '15', '16', '1', 'contact', 'com_contact', 'Contact', 'contact', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-07-27 03:56:03', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('12', '56', '1', '19', '20', '1', 'jv-templates', 'com_weblinks', 'JV Templates', 'jv-templates', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-07-30 05:03:29', '92', '2012-07-30 05:03:48', '0', '*');
INSERT INTO `#__categories` VALUES ('13', '57', '1', '21', '22', '1', 'joomla', 'com_banners', 'Joomla', 'joomla', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-07-30 06:43:48', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('14', '58', '1', '23', '24', '1', 'joomla', 'com_content', 'Joomla', 'joomla', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-08-08 02:29:06', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('15', '64', '1', '25', '26', '1', 'sample-data-newsfeeds', 'com_newsfeeds', 'Sample Data-Newsfeeds', 'sample-data-newsfeeds', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-08-14 02:21:11', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('16', '70', '1', '27', '30', '1', 'extensions', 'com_content', 'Extensions', 'extensions', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-08-16 08:58:11', '0', '0000-00-00 00:00:00', '0', '*');
INSERT INTO `#__categories` VALUES ('17', '71', '16', '28', '29', '2', 'extensions/utilities', 'com_content', 'Utilities', 'utilities', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '204', '2012-08-16 08:58:40', '92', '2012-08-17 03:23:17', '0', '*');

-- ----------------------------
-- Table structure for `#__contact_details`
-- ----------------------------
DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__contact_details
-- ----------------------------
INSERT INTO `#__contact_details` VALUES ('1', 'Hoang Giang', 'hoang-giang', 'Chief Developer', '', 'HCM', 'TAN PHU', 'VN', '', '', '', '<p>Aenean ultricies mi vitae est. Mauris placerat eleifend leo.</p>', '', null, 'hoanggiang@joomlavi.com', '0', '1', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '10', '1', '84 908 320 131', '', '', '', '', '*', '2012-07-27 04:00:31', '204', '', '2012-08-21 03:46:56', '92', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');
INSERT INTO `#__contact_details` VALUES ('2', 'Dinh Ha', 'dinh-ha', 'Support', '', 'HCM', 'TAN PHU', 'VN', '', '', '', '', '', null, 'ha.le@joomlavi.com', '0', '1', '0', '0000-00-00 00:00:00', '2', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '10', '1', '84 938303837', '', '', '', '', '*', '2012-07-27 04:16:55', '204', '', '2012-07-27 09:06:27', '92', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '1', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- ----------------------------
-- Table structure for `#__content`
-- ----------------------------
DROP TABLE IF EXISTS `#__content`;
CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the framework_assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=42 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__content
-- ----------------------------
INSERT INTO `#__content` VALUES ('1', '36', 'Demo', 'demo', '', '<p>Demo</p>', '', '-2', '0', '0', '2', '2012-07-03 03:37:08', '204', '', '2012-07-03 03:37:13', '92', '0', '0000-00-00 00:00:00', '2012-07-03 03:37:08', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '1', '', '', '1', '941', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('4', '40', 'Joomla! Overview', 'joomla-overview', '', '<p>Joomla is so much more than just a powerful content management system. Here is a list of features \"out of the box,\" but the true power of Joomla is in its extensibility.</p>\r\n', '\r\n<h2>User Management</h2>\r\n<p>Joomla has a registration system that allows users to configure personal options. There are nine user groups with various types of permissions on what users are allowed to access, edit, publish and administrate.<br /> <br /> Authentication is an important part of user management and Joomla support multiple protocols, including LDAP, OpenID, and even Gmail. This allows users to use their existing account information to streamline the registration process.</p>\r\n<h2>Media Manager</h2>\r\n<p>The Media Manager is the tool for easily managing media files or folders and you can configure the MIME type settings to handle any type of file. The Media Manager is integrated into the Article Editor tool so you can grab images and other files at any time.</p>\r\n<h2>Language Manager</h2>\r\n<p>There is international support for many world languages and UTF-8 encoding. If you need your Web site in one language and the administrator panel in another, multiple languages are possible.</p>\r\n<h2>Banner Management</h2>\r\n<p>It\'s easy to set up banners on your Web site using the Banner Manager, starting with creating a client profile. Once you add campaigns and as many banners as you need, you can set impression numbers, special URLs, and more.</p>\r\n<h2>Contact Management</h2>\r\n<p>The Contact Manager helps your users to find the right person and their contact information. It also supports multiple contact forms going to specific individuals as well as groups.</p>\r\n<h2>Polls</h2>\r\n<p>If you want to find out more about your users, it\'s easy to create polls with multiple options.</p>\r\n<h2>Search</h2>\r\n<p>Help navigate users to most popular search items and provide the admin with search statistics.</p>\r\n<h2>Web Link Management</h2>\r\n<p>Providing link resources for site users is simple and you can sort them into categories, even count every click.</p>\r\n<h2>Content Management</h2>\r\n<p>Joomla\'s simplified three-tiered system of articles makes organizing your content a snap. You can organize your content any way you want and not necessarily how it will be on your Web site. Your users can rate articles, e-mail them to a friend, or automatically save a PDF (with UTF-8 support for all languages). Administrators can archive content for safekeeping, hiding it from site visitors.</p>\r\n<p>On public Web sites, built-in e-mail cloaking protects email addresses from spambots.</p>\r\n<p>Creating content is simple with the WYSIWYG editor, giving even novice users the ability to combine text, images in an attractive way. Once you\'ve created your articles, there are a number of pre-installed modules to show the most popular articles, latest new items, newsflashes, related articles, and more.</p>\r\n<h2>Syndication and Newsfeed Management</h2>\r\n<p>With Joomla, it\'s easy to syndicate your site content, allowing your users to subscribe to new content in their favorite RSS reader. It\'s equally easy to integrate RSS feeds from other sources and aggregate them all on your site.</p>\r\n<h2>Menu Manager</h2>\r\n<p>The Menu Manager allows you to create as many menus and menu items as you need. You can structure your menu hierarchy (and nested menu items) completely independent of your content structure. Put one menu in multiple places and in any style you want; use rollovers, dropdown, flyouts and just about any other navigation system you can think of. Also automatic breadcrumbs are generated to help navigate your site users.</p>\r\n<h2>Template Management</h2>\r\n<p>Templates in Joomla are a powerful way to make your site look exactly the way you want and either use a single template for the entire site or a separate template for each site section. The level of visual control goes a step further with powerful template overrides, allowing you to customize each part of your pages.</p>\r\n<h2>Integrated Help System</h2>\r\n<p>Joomla has a built-in help section to assist users with finding what they need. A glossary explains the terms in plain English, a version checker makes sure you\'re using the latest version, a system information tool helps you troubleshoot, and, if all else fails, links to a wealth of online resources for additional help and support.</p>\r\n<h2>System Features</h2>\r\n<p>Speedy page loads are possible with page caching, granular-level module caching, and GZIP page compression.</p>\r\n<p>If your system administrator needs to troubleshoot an issue, debugging mode and error reporting are invaluable.</p>\r\n<p>The FTP Layer allows file operations (like installing Extensions) without having to make all the folders and files writable, making your site administrator\'s life easier and increasing the security of your site.</p>\r\n<p>Administators quickly and efficiently communicate with users one-on-one through private messaging or all site users via the mass mailing system.</p>\r\n<h2>Web Services</h2>\r\n<p>With Web services, you can use Remote Procedure Calls (via HTTP and XML). You can also integrate XML-RPC services with the Blogger and Joomla APIs.</p>\r\n<h2>Powerful Extensibility</h2>\r\n<p>These are just some of the basic Joomla features and the real power is in the way you customize Joomla. Visit the Joomla Extensions Directory to see thousands of ways to enhance Joomla to suit your needs.</p>', '1', '0', '0', '14', '2012-07-03 07:16:39', '204', '', '2012-08-24 03:10:17', '92', '0', '0000-00-00 00:00:00', '2012-07-03 07:16:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '4', '', '', '1', '44', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('5', '41', 'Joomla! License Guidelines', 'joomla-license-guidelines', '', '<p>This Web site is powered by Joomla. The software and default templates on which it runs are copyright Open Source Matters. All other content and data, including data entered into this Web site and templates added after installation, are copyrighted by their respective copyright owners.</p>\r\n', '\r\n<p>If you want to distribute, copy or modify Joomla, you are welcome to do so under the terms of the GNU General Public License. If you are unfamiliar with this license, you might want to read How To Apply These Terms To Your Program and the GNU General Public License FAQ.</p>', '1', '0', '0', '14', '2012-07-03 07:16:39', '204', '', '2012-08-24 03:10:01', '92', '0', '0000-00-00 00:00:00', '2012-07-03 07:16:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '5', '', '', '1', '56', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('6', '42', 'More about Joomla', 'more-about-joomla', '', '<div id=\"description\">\r\n<p>Joomla is an award-winning content management system (CMS), which enables you to build Web sites and powerful online applications. Many aspects, including its ease-of-use and extensibility, have made Joomla the most popular Web site software available. Best of all, Joomla is an open source solution that is freely available to everyone.</p>\r\n', '\r\n<h2>What\'s a content management system (CMS)?</h2>\r\n<p>A content management system is software that keeps track of every piece of content on your Web site, much like your local public library keeps track of books and stores them. Content can be simple text, photos, music, video, documents, or just about anything you can think of. A major advantage of using a CMS is that it requires almost no technical skill or knowledge to manage. Since the CMS manages all your content, you don\'t have to.</p>\r\n<div> </div>\r\n<h2>What are some real world examples of what Joomla! can do?</h2>\r\n<p>Joomla is used all over the world to power Web sites of all shapes and sizes. For example:</p>\r\n<ul>\r\n<li>Corporate Web sites or portals</li>\r\n<li>Corporate intranets and extranets</li>\r\n<li>Online magazines, newspapers, and publications</li>\r\n<li>E-commerce and online reservations</li>\r\n<li>Government applications</li>\r\n<li>Small business Web sites</li>\r\n<li>Non-profit and organizational Web sites</li>\r\n<li>Community-based portals</li>\r\n<li>School and church Web sites</li>\r\n<li>Personal or family homepages</li>\r\n</ul>\r\n<div> </div>\r\n<h2>Who uses Joomla?</h2>\r\n<p>Here are just a few examples of Web sites that use Joomla:</p>\r\n<ul>\r\n<li>MTV Networks Quizilla (Social networking) - <a href=\"http://www.quizilla.com\" target=\"_blank\">http://www.quizilla.com</a></li>\r\n<li>IHOP (Restaurant chain) - <a href=\"http://www.ihop.com\" target=\"_blank\">http://www.ihop.com</a></li>\r\n<li>Harvard University (Educational) - <a href=\"http://gsas.harvard.edu\" target=\"_blank\"> http://gsas.harvard.edu</a></li>\r\n<li>Citibank (Financial institution intranet) - Not publicly accessible</li>\r\n<li>The Green Maven (Eco-resources) - <a href=\"http://www.greenmaven.com\" target=\"_blank\"> http://www.greenmaven.com</a></li>\r\n<li>Outdoor Photographer (Magazine) - <a href=\"http://www.outdoorphotographer.com\" target=\"_blank\">http://www.outdoorphotographer.com</a></li>\r\n<li>PlayShakespeare.com (Cultural) - <a href=\"http://www.playshakespeare.com\" target=\"_blank\">http://www.playshakespeare.com</a></li>\r\n<li>Senso Interiors (Furniture design) - <a href=\"http://www.sensointeriors.co.za\" target=\"_blank\">http://www.sensointeriors.co.za</a></li>\r\n</ul>\r\n<p>More examples of companies using Joomla can be found in the <a href=\"http://community.joomla.org/showcase\">Joomla Community Site Showcase</a>.</p>\r\n<div> </div>\r\n<h2>I need to build a site for a client. How will Joomla! help me?</h2>\r\n<p>Joomla is designed to be easy to install and set up even if you\'re not an advanced user. Many Web hosting services offer a single-click install, getting your new site up and running in just a few minutes.</p>\r\n<p>Since Joomla is so easy to use, as a Web designer or developer, you can quickly build sites for your clients. Then, with a minimal amount of instruction, you can empower your clients to easily manage their own sites themselves.</p>\r\n<p>If your clients need specialized functionality, Joomla is highly extensible and thousands of extensions (most for free under the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html\" target=\"_blank\">GPL license</a>) are available in the <a href=\"http://extensions.joomla.org/\">Joomla Extensions Directory</a>.</p>\r\n<div> </div>\r\n<h2>How can I be sure there will be Joomla! support in the future?</h2>\r\n<p>Joomla is the most popular open source CMS currently available as evidenced by a vibrant and growing community of friendly users and talented developers. Joomla\'s roots go back to 2000 and, with over 200,000 community users and contributors, the future looks bright for the award-winning Joomla Project.</p>\r\n<div> </div>\r\n<h2>I\'m a developer. What are some advanced ways I can use Joomla?</h2>\r\n<p>Many companies and organizations have requirements that go beyond what is available in the basic Joomla package. In those cases, Joomla\'s powerful application framework makes it easy for developers to create sophisticated add-ons that extend the power of Joomla into virtually unlimited directions.</p>\r\n<p>The core Joomla framework enables developers to quickly and easily build:</p>\r\n<ul>\r\n<li>Inventory control systems</li>\r\n<li>Data reporting tools</li>\r\n<li>Application bridges</li>\r\n<li>Custom product catalogs</li>\r\n<li>Integrated e-commerce systems</li>\r\n<li>Complex business directories</li>\r\n<li>Reservation systems</li>\r\n<li>Communication tools</li>\r\n</ul>\r\n<p>Since Joomla is based on PHP and MySQL, you\'re building powerful applications on an open platform anyone can use, share, and support. To find out more information on leveraging the Joomla framework, visit the <a href=\"http://developer.joomla.org/\">Joomla Developer Network.</a></p>\r\n<div> </div>\r\n<h2>Joomla! seems the right solution for me. How do I get started?</h2>\r\n<p>Joomla is free, open, and available to anyone under the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html\" target=\"_blank\">GPL license</a>. Read <a href=\"http://www.joomla.org/about-joomla/getting-started.html\">Getting Started with Joomla</a> to find out the basics then try out our <a href=\"http://demo.joomla.org\">online demo</a> and you\'ll quickly discover how simple Joomla is. If you\'re ready to install Joomla, <a href=\"http://www.joomla.org/download.html\">download the latest version here</a> you\'ll be up and running in no time.</p>\r\n</div>', '1', '0', '0', '14', '2012-07-03 07:16:39', '204', '', '2012-08-24 03:06:31', '92', '0', '0000-00-00 00:00:00', '2012-07-03 07:16:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '6', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('7', '43', 'FAQ', 'faq', '', '<p>Joomla is so much more than just a powerful content management system. Here is a list of features \"out of the box,\" but the true power of Joomla is in its extensibility.</p>\r\n', '\r\n<h2>User Management</h2>\r\n<p>Joomla has a registration system that allows users to configure personal options. There are nine user groups with various types of permissions on what users are allowed to access, edit, publish and administrate.<br /> <br /> Authentication is an important part of user management and Joomla support multiple protocols, including LDAP, OpenID, and even Gmail. This allows users to use their existing account information to streamline the registration process.</p>\r\n<h2>Media Manager</h2>\r\n<p>The Media Manager is the tool for easily managing media files or folders and you can configure the MIME type settings to handle any type of file. The Media Manager is integrated into the Article Editor tool so you can grab images and other files at any time.</p>\r\n<h2>Language Manager</h2>\r\n<p>There is international support for many world languages and UTF-8 encoding. If you need your Web site in one language and the administrator panel in another, multiple languages are possible.</p>\r\n<h2>Banner Management</h2>\r\n<p>It\'s easy to set up banners on your Web site using the Banner Manager, starting with creating a client profile. Once you add campaigns and as many banners as you need, you can set impression numbers, special URLs, and more.</p>\r\n<h2>Contact Management</h2>\r\n<p>The Contact Manager helps your users to find the right person and their contact information. It also supports multiple contact forms going to specific individuals as well as groups.</p>\r\n<h2>Polls</h2>\r\n<p>If you want to find out more about your users, it\'s easy to create polls with multiple options.</p>\r\n<h2>Search</h2>\r\n<p>Help navigate users to most popular search items and provide the admin with search statistics.</p>\r\n<h2>Web Link Management</h2>\r\n<p>Providing link resources for site users is simple and you can sort them into categories, even count every click.</p>\r\n<h2>Content Management</h2>\r\n<p>Joomla\'s simplified three-tiered system of articles makes organizing your content a snap. You can organize your content any way you want and not necessarily how it will be on your Web site. Your users can rate articles, e-mail them to a friend, or automatically save a PDF (with UTF-8 support for all languages). Administrators can archive content for safekeeping, hiding it from site visitors.</p>\r\n<p>On public Web sites, built-in e-mail cloaking protects email addresses from spambots.</p>\r\n<p>Creating content is simple with the WYSIWYG editor, giving even novice users the ability to combine text, images in an attractive way. Once you\'ve created your articles, there are a number of pre-installed modules to show the most popular articles, latest new items, newsflashes, related articles, and more.</p>\r\n<h2>Syndication and Newsfeed Management</h2>\r\n<p>With Joomla, it\'s easy to syndicate your site content, allowing your users to subscribe to new content in their favorite RSS reader. It\'s equally easy to integrate RSS feeds from other sources and aggregate them all on your site.</p>\r\n<h2>Menu Manager</h2>\r\n<p>The Menu Manager allows you to create as many menus and menu items as you need. You can structure your menu hierarchy (and nested menu items) completely independent of your content structure. Put one menu in multiple places and in any style you want; use rollovers, dropdown, flyouts and just about any other navigation system you can think of. Also automatic breadcrumbs are generated to help navigate your site users.</p>\r\n<h2>Template Management</h2>\r\n<p>Templates in Joomla are a powerful way to make your site look exactly the way you want and either use a single template for the entire site or a separate template for each site section. The level of visual control goes a step further with powerful template overrides, allowing you to customize each part of your pages.</p>\r\n<h2>Integrated Help System</h2>\r\n<p>Joomla has a built-in help section to assist users with finding what they need. A glossary explains the terms in plain English, a version checker makes sure you\'re using the latest version, a system information tool helps you troubleshoot, and, if all else fails, links to a wealth of online resources for additional help and support.</p>\r\n<h2>System Features</h2>\r\n<p>Speedy page loads are possible with page caching, granular-level module caching, and GZIP page compression.</p>\r\n<p>If your system administrator needs to troubleshoot an issue, debugging mode and error reporting are invaluable.</p>\r\n<p>The FTP Layer allows file operations (like installing Extensions) without having to make all the folders and files writable, making your site administrator\'s life easier and increasing the security of your site.</p>\r\n<p>Administators quickly and efficiently communicate with users one-on-one through private messaging or all site users via the mass mailing system.</p>\r\n<h2>Web Services</h2>\r\n<p>With Web services, you can use Remote Procedure Calls (via HTTP and XML). You can also integrate XML-RPC services with the Blogger and Joomla APIs.</p>\r\n<h2>Powerful Extensibility</h2>\r\n<p>These are just some of the basic Joomla features and the real power is in the way you customize Joomla. Visit the Joomla Extensions Directory to see thousands of ways to enhance Joomla to suit your needs.</p>', '1', '0', '0', '14', '2012-07-03 07:16:39', '204', '', '2012-08-24 03:09:39', '92', '0', '0000-00-00 00:00:00', '2012-07-03 07:16:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '7', '', '', '1', '10', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('8', '44', 'The News', 'the-news', '', '<div id=\"description\">\r\n<p>Joomla is an award-winning content management system (CMS), which enables you to build Web sites and powerful online applications. Many aspects, including its ease-of-use and extensibility, have made Joomla the most popular Web site software available. Best of all, Joomla is an open source solution that is freely available to everyone.</p>\r\n', '\r\n<h2>What\'s a content management system (CMS)?</h2>\r\n<p>A content management system is software that keeps track of every piece of content on your Web site, much like your local public library keeps track of books and stores them. Content can be simple text, photos, music, video, documents, or just about anything you can think of. A major advantage of using a CMS is that it requires almost no technical skill or knowledge to manage. Since the CMS manages all your content, you don\'t have to.</p>\r\n<div> </div>\r\n<h2>What are some real world examples of what Joomla! can do?</h2>\r\n<p>Joomla is used all over the world to power Web sites of all shapes and sizes. For example:</p>\r\n<ul>\r\n<li>Corporate Web sites or portals</li>\r\n<li>Corporate intranets and extranets</li>\r\n<li>Online magazines, newspapers, and publications</li>\r\n<li>E-commerce and online reservations</li>\r\n<li>Government applications</li>\r\n<li>Small business Web sites</li>\r\n<li>Non-profit and organizational Web sites</li>\r\n<li>Community-based portals</li>\r\n<li>School and church Web sites</li>\r\n<li>Personal or family homepages</li>\r\n</ul>\r\n<div> </div>\r\n<h2>Who uses Joomla?</h2>\r\n<p>Here are just a few examples of Web sites that use Joomla:</p>\r\n<ul>\r\n<li>MTV Networks Quizilla (Social networking) - <a href=\"http://www.quizilla.com\" target=\"_blank\">http://www.quizilla.com</a></li>\r\n<li>IHOP (Restaurant chain) - <a href=\"http://www.ihop.com\" target=\"_blank\">http://www.ihop.com</a></li>\r\n<li>Harvard University (Educational) - <a href=\"http://gsas.harvard.edu\" target=\"_blank\"> http://gsas.harvard.edu</a></li>\r\n<li>Citibank (Financial institution intranet) - Not publicly accessible</li>\r\n<li>The Green Maven (Eco-resources) - <a href=\"http://www.greenmaven.com\" target=\"_blank\"> http://www.greenmaven.com</a></li>\r\n<li>Outdoor Photographer (Magazine) - <a href=\"http://www.outdoorphotographer.com\" target=\"_blank\">http://www.outdoorphotographer.com</a></li>\r\n<li>PlayShakespeare.com (Cultural) - <a href=\"http://www.playshakespeare.com\" target=\"_blank\">http://www.playshakespeare.com</a></li>\r\n<li>Senso Interiors (Furniture design) - <a href=\"http://www.sensointeriors.co.za\" target=\"_blank\">http://www.sensointeriors.co.za</a></li>\r\n</ul>\r\n<p>More examples of companies using Joomla can be found in the <a href=\"http://community.joomla.org/showcase\">Joomla Community Site Showcase</a>.</p>\r\n<div> </div>\r\n<h2>I need to build a site for a client. How will Joomla! help me?</h2>\r\n<p>Joomla is designed to be easy to install and set up even if you\'re not an advanced user. Many Web hosting services offer a single-click install, getting your new site up and running in just a few minutes.</p>\r\n<p>Since Joomla is so easy to use, as a Web designer or developer, you can quickly build sites for your clients. Then, with a minimal amount of instruction, you can empower your clients to easily manage their own sites themselves.</p>\r\n<p>If your clients need specialized functionality, Joomla is highly extensible and thousands of extensions (most for free under the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html\" target=\"_blank\">GPL license</a>) are available in the <a href=\"http://extensions.joomla.org/\">Joomla Extensions Directory</a>.</p>\r\n<div> </div>\r\n<h2>How can I be sure there will be Joomla! support in the future?</h2>\r\n<p>Joomla is the most popular open source CMS currently available as evidenced by a vibrant and growing community of friendly users and talented developers. Joomla\'s roots go back to 2000 and, with over 200,000 community users and contributors, the future looks bright for the award-winning Joomla Project.</p>\r\n<div> </div>\r\n<h2>I\'m a developer. What are some advanced ways I can use Joomla?</h2>\r\n<p>Many companies and organizations have requirements that go beyond what is available in the basic Joomla package. In those cases, Joomla\'s powerful application framework makes it easy for developers to create sophisticated add-ons that extend the power of Joomla into virtually unlimited directions.</p>\r\n<p>The core Joomla framework enables developers to quickly and easily build:</p>\r\n<ul>\r\n<li>Inventory control systems</li>\r\n<li>Data reporting tools</li>\r\n<li>Application bridges</li>\r\n<li>Custom product catalogs</li>\r\n<li>Integrated e-commerce systems</li>\r\n<li>Complex business directories</li>\r\n<li>Reservation systems</li>\r\n<li>Communication tools</li>\r\n</ul>\r\n<p>Since Joomla is based on PHP and MySQL, you\'re building powerful applications on an open platform anyone can use, share, and support. To find out more information on leveraging the Joomla framework, visit the <a href=\"http://developer.joomla.org/\">Joomla Developer Network.</a></p>\r\n<div> </div>\r\n<h2>Joomla! seems the right solution for me. How do I get started?</h2>\r\n<p>Joomla is free, open, and available to anyone under the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html\" target=\"_blank\">GPL license</a>. Read <a href=\"http://www.joomla.org/about-joomla/getting-started.html\">Getting Started with Joomla</a> to find out the basics then try out our <a href=\"http://demo.joomla.org\">online demo</a> and you\'ll quickly discover how simple Joomla is. If you\'re ready to install Joomla, <a href=\"http://www.joomla.org/download.html\">download the latest version here</a> you\'ll be up and running in no time.</p>\r\n</div>', '1', '0', '0', '14', '2012-07-03 07:16:39', '204', '', '2012-08-24 03:07:15', '92', '0', '0000-00-00 00:00:00', '2012-07-03 07:16:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '8', '', '', '1', '86', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('9', '45', 'Web links', 'web-links', '', '<p>Joomla is so much more than just a powerful content management system. Here is a list of features \"out of the box,\" but the true power of Joomla is in its extensibility.</p>\r\n', '\r\n<h2>User Management</h2>\r\n<p>Joomla has a registration system that allows users to configure personal options. There are nine user groups with various types of permissions on what users are allowed to access, edit, publish and administrate.<br /> <br /> Authentication is an important part of user management and Joomla support multiple protocols, including LDAP, OpenID, and even Gmail. This allows users to use their existing account information to streamline the registration process.</p>\r\n<h2>Media Manager</h2>\r\n<p>The Media Manager is the tool for easily managing media files or folders and you can configure the MIME type settings to handle any type of file. The Media Manager is integrated into the Article Editor tool so you can grab images and other files at any time.</p>\r\n<h2>Language Manager</h2>\r\n<p>There is international support for many world languages and UTF-8 encoding. If you need your Web site in one language and the administrator panel in another, multiple languages are possible.</p>\r\n<h2>Banner Management</h2>\r\n<p>It\'s easy to set up banners on your Web site using the Banner Manager, starting with creating a client profile. Once you add campaigns and as many banners as you need, you can set impression numbers, special URLs, and more.</p>\r\n<h2>Contact Management</h2>\r\n<p>The Contact Manager helps your users to find the right person and their contact information. It also supports multiple contact forms going to specific individuals as well as groups.</p>\r\n<h2>Polls</h2>\r\n<p>If you want to find out more about your users, it\'s easy to create polls with multiple options.</p>\r\n<h2>Search</h2>\r\n<p>Help navigate users to most popular search items and provide the admin with search statistics.</p>\r\n<h2>Web Link Management</h2>\r\n<p>Providing link resources for site users is simple and you can sort them into categories, even count every click.</p>\r\n<h2>Content Management</h2>\r\n<p>Joomla\'s simplified three-tiered system of articles makes organizing your content a snap. You can organize your content any way you want and not necessarily how it will be on your Web site. Your users can rate articles, e-mail them to a friend, or automatically save a PDF (with UTF-8 support for all languages). Administrators can archive content for safekeeping, hiding it from site visitors.</p>\r\n<p>On public Web sites, built-in e-mail cloaking protects email addresses from spambots.</p>\r\n<p>Creating content is simple with the WYSIWYG editor, giving even novice users the ability to combine text, images in an attractive way. Once you\'ve created your articles, there are a number of pre-installed modules to show the most popular articles, latest new items, newsflashes, related articles, and more.</p>\r\n<h2>Syndication and Newsfeed Management</h2>\r\n<p>With Joomla, it\'s easy to syndicate your site content, allowing your users to subscribe to new content in their favorite RSS reader. It\'s equally easy to integrate RSS feeds from other sources and aggregate them all on your site.</p>\r\n<h2>Menu Manager</h2>\r\n<p>The Menu Manager allows you to create as many menus and menu items as you need. You can structure your menu hierarchy (and nested menu items) completely independent of your content structure. Put one menu in multiple places and in any style you want; use rollovers, dropdown, flyouts and just about any other navigation system you can think of. Also automatic breadcrumbs are generated to help navigate your site users.</p>\r\n<h2>Template Management</h2>\r\n<p>Templates in Joomla are a powerful way to make your site look exactly the way you want and either use a single template for the entire site or a separate template for each site section. The level of visual control goes a step further with powerful template overrides, allowing you to customize each part of your pages.</p>\r\n<h2>Integrated Help System</h2>\r\n<p>Joomla has a built-in help section to assist users with finding what they need. A glossary explains the terms in plain English, a version checker makes sure you\'re using the latest version, a system information tool helps you troubleshoot, and, if all else fails, links to a wealth of online resources for additional help and support.</p>\r\n<h2>System Features</h2>\r\n<p>Speedy page loads are possible with page caching, granular-level module caching, and GZIP page compression.</p>\r\n<p>If your system administrator needs to troubleshoot an issue, debugging mode and error reporting are invaluable.</p>\r\n<p>The FTP Layer allows file operations (like installing Extensions) without having to make all the folders and files writable, making your site administrator\'s life easier and increasing the security of your site.</p>\r\n<p>Administators quickly and efficiently communicate with users one-on-one through private messaging or all site users via the mass mailing system.</p>\r\n<h2>Web Services</h2>\r\n<p>With Web services, you can use Remote Procedure Calls (via HTTP and XML). You can also integrate XML-RPC services with the Blogger and Joomla APIs.</p>\r\n<h2>Powerful Extensibility</h2>\r\n<p>These are just some of the basic Joomla features and the real power is in the way you customize Joomla. Visit the Joomla Extensions Directory to see thousands of ways to enhance Joomla to suit your needs.</p>', '1', '0', '0', '14', '2012-07-03 07:16:39', '204', '', '2012-08-24 03:07:43', '92', '0', '0000-00-00 00:00:00', '2012-07-03 07:16:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '9', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('10', '46', 'About JV Framework', 'features', '', '<div class=\"thumbnail\"><img class=\"resize\" src=\"images/stories/demo/fw.jpg\" border=\"0\" alt=\"FW\" /></div>\r\n<p>JV Framework is a Joomla! component developed to run and manage themes – templates developed by Joomlavi team, as well as any template club based on JV Framework. <br />While it add an extra step to those templates\' installation process, JV Framework offer the user with several tools, making the process of customizing the layout much easier.</p>\r\n', '\r\n<p>As of version 3.0, JV Framework features:</p>\r\n<ul>\r\n<li>- Responsive web design</li>\r\n<li>- Mobile custom layout</li>\r\n<li>- Support HTML5, CSS3</li>\r\n<li>- Integrated Twitter bootstrap</li>\r\n<li>- Full support for RTL language</li>\r\n<li>- Utilize HTML layout ( will support xml layout in the future)</li>\r\n<li>- Each theme has its individual configurations.</li>\r\n<li>- Allow a theme to inherit layout, style, etc from other themes.</li>\r\n<li>- Allow users to override and custom layout.</li>\r\n<li>- html layout, blocks, modules can be controlled fluidly.</li>\r\n</ul>\r\n<p>  Provide a customization system for JV Framework by allowing users to create and override Extensions</p>', '1', '0', '0', '8', '2012-07-03 04:25:42', '204', '', '2012-09-07 05:00:25', '92', '0', '0000-00-00 00:00:00', '2012-07-03 04:25:42', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '50', '0', '5', '', '', '1', '397', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');
INSERT INTO `#__content` VALUES ('17', '59', 'About JV Framework (2)', 'features-2', '', '<div class=\"thumbnail\"><img class=\"resize\" src=\"images/stories/demo/fw.jpg\" border=\"0\" alt=\"FW\" /></div>\r\n<p>JV Framework is a Joomla! component developed to run and manage themes – templates developed by Joomlavi team, as well as any template club based on JV Framework. <br />While it add an extra step to those templates\' installation process, JV Framework offer the user with several tools, making the process of customizing the layout much easier.</p>\r\n', '\r\n<p>As of version 2.0, JV Framework features: <br /> <br /> - Responsive web design<br /> - Mobile custom layout<br /> - Support HTML5, CSS3<br /> - Integrated Twitter bootstrap<br /> - Full support for RTL language<br /> - Utilize HTML layout ( will support xml layout in the future)<br /> - Each theme has its individual configurations.<br /> - Allow a theme to inherit layout, style, etc from other themes.<br /> - Allow users to override and custom layout.<br /> - html layout, blocks, modules can be controlled fluidly.<br /> - Provide a customization system for JV Framework by allowing users to create and override Extensions</p>', '-2', '0', '0', '8', '2012-07-03 04:25:42', '204', '', '2012-08-15 03:51:03', '92', '0', '0000-00-00 00:00:00', '2012-07-03 04:25:42', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '47', '0', '5', '', '', '1', '217', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');
INSERT INTO `#__content` VALUES ('12', '48', 'For Developers', 'for-developers', '', '<div class=\"thumbnail\"><img src=\"images/stories/demo/developer.jpg\" border=\"0\" alt=\"developer\" /></div>\r\n<p>Have you ever felt the frustration of working with templates that seemed to hate developers?</p>\r\n<p>JV Framework 3.0 is a developer-friendly component. We offer several features that support any developer interested in developing templates that utilize our Framework or extending its functionality:</p>\r\n', '\r\n<p>- A basetheme system that allow Inheriting and Overriding. <br /> - Allow you to config the theme\'s structure flexibly, a function that can be used to expand the library for Framework.<br /> - JV Framework functions by utilizing several different JV FW Extensions, and it allows you to add new ones or customize existing extension. It also provide the necessary library to make this process easier.<br /> These default and custom extensions will help broaden the functions of the theme.</p>', '1', '0', '0', '8', '2012-07-27 02:24:02', '204', '', '2012-08-06 05:07:10', '92', '0', '0000-00-00 00:00:00', '2012-07-27 02:24:02', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '10', '0', '2', '', '', '1', '37', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');
INSERT INTO `#__content` VALUES ('11', '47', 'Responsive Web Design and Mobility Support', 'mobility-support', '', '<div class=\"thumbnail\"><img class=\"img\" src=\"images/stories/demo/mobiles.jpg\" border=\"0\" alt=\"demo-img\" /></div>\r\n<p><strong>What is Responsive Web Design (RWD)?</strong><br />A website with Responsive Web Design means it was designed in a manner which allows the layout to change and fit various screen resolutions accordingly.</p>\r\n', '\r\n<p>For example: Two user, one with a screen 1360 pixel wide, one with a screen 1024 pixel wide, access the same site with Responsive Web Design. The former may see the site with a 4 columns layout while the latter see the site with 2 columns layout, even though the content was the same and the site\'s width never exceeding their browser’s size.<br />Such an effect is achieved thank to the flexible grids and layouts (which work using percentages and EMS instead of the traditional pixels), as well as Media Query.<br /><br /> <strong>Why Responsive Web Design?</strong><br /> Prior to RWD, “Mobile support” means the site has to have at least two different layouts: one for PC/Laptop and one for mobiles. Sometime, it required several: one for PC/Laptop, one for Black Berry, one for iPhone, one for iPad, etc. With time, as more mobile devices are created, the requirement for ‘Mobile support’ will only keep expanding.<br />However, with a Responsive Web Design, most devices accessing the site will be seeing the same content and layout, which fluidly adapted itself to fit their screen solution.  This eliminates the need for an ever-expanding repertoire of alternative layout. <br />Even on PC and laptop, RWS helps make web-browsing more convenient, as the site will change to fit your current resolution and window size, allowing you to avoid scrolling both horizontally and vertically at the same time.<br /><br /><br /></p>', '1', '0', '0', '8', '2012-07-03 04:25:42', '204', '', '2012-08-20 14:49:54', '92', '0', '0000-00-00 00:00:00', '2012-07-03 04:25:42', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '27', '0', '6', '', '', '1', '683', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');
INSERT INTO `#__content` VALUES ('14', '51', 'Beautiful Icons', 'beautiful-icons', '', '<div class=\"thumbnail\"><img src=\"images/stories/demo/beauty-icon.jpg\" border=\"0\" alt=\"beautifull icon\" /></div>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>\r\n', '\r\n<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum tortor quam, feugiat vitae, ultricies eget, tempor sit amet, ante. Donec eu libero sit amet quam egestas semper. Aenean ultricies mi vitae est. Mauris placerat eleifend leo. Quisque sit amet est et sapien ullamcorper pharetra. Vestibulum erat wisi, condimentum sed, commodo vitae, ornare sit amet, wisi. Aenean fermentum, elit eget tincidunt condimentum, eros ipsum rutrum orci, sagittis tempus lacus enim ac dui. Donec non enim in turpis pulvinar facilisis. Ut felis. Praesent dapibus, neque id cursus faucibus, tortor neque egestas augue, eu vulputate magna eros eu erat. Aliquam erat volutpat. Nam dui mi, tincidunt quis, accumsan porttitor, facilisis luctus, metus</p>', '1', '0', '0', '8', '2012-07-27 02:31:11', '204', '', '2012-08-21 01:49:19', '92', '0', '0000-00-00 00:00:00', '2012-07-27 02:31:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '7', '0', '4', '', '', '1', '58', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');
INSERT INTO `#__content` VALUES ('15', '52', 'JV Extension', 'jv-extension', '', '<div class=\"thumbnail\"><img src=\"images/stories/demo/extension.jpg\" border=\"0\" alt=\"extension\" /></div>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>\r\n', '\r\n<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum tortor quam, feugiat vitae, ultricies eget, tempor sit amet, ante. Donec eu libero sit amet quam egestas semper. Aenean ultricies mi vitae est. Mauris placerat eleifend leo. Quisque sit amet est et sapien ullamcorper pharetra. Vestibulum erat wisi, condimentum sed, commodo vitae, ornare sit amet, wisi. Aenean fermentum, elit eget tincidunt condimentum, eros ipsum rutrum orci, sagittis tempus lacus enim ac dui. Donec non enim in turpis pulvinar facilisis. Ut felis. Praesent dapibus, neque id cursus faucibus, tortor neque egestas augue, eu vulputate magna eros eu erat. Aliquam erat volutpat. Nam dui mi, tincidunt quis, accumsan porttitor, facilisis luctus, metus</p>', '1', '0', '0', '8', '2012-07-27 02:31:11', '204', '', '2012-09-18 03:12:01', '92', '0', '0000-00-00 00:00:00', '2012-07-27 02:31:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '6', '0', '7', '', '', '1', '36', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('16', '53', 'Free Social Icons', 'free-social-icons', '', '<p><img src=\"http://placehold.it/720x300\" border=\"0\" alt=\"demo img\" /></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>\r\n', '\r\n<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum tortor quam, feugiat vitae, ultricies eget, tempor sit amet, ante. Donec eu libero sit amet quam egestas semper. Aenean ultricies mi vitae est. Mauris placerat eleifend leo. Quisque sit amet est et sapien ullamcorper pharetra. Vestibulum erat wisi, condimentum sed, commodo vitae, ornare sit amet, wisi. Aenean fermentum, elit eget tincidunt condimentum, eros ipsum rutrum orci, sagittis tempus lacus enim ac dui. Donec non enim in turpis pulvinar facilisis. Ut felis. Praesent dapibus, neque id cursus faucibus, tortor neque egestas augue, eu vulputate magna eros eu erat. Aliquam erat volutpat. Nam dui mi, tincidunt quis, accumsan porttitor, facilisis luctus, metus</p>', '-2', '0', '0', '8', '2012-07-27 02:31:11', '204', '', '2012-07-27 09:22:11', '92', '0', '0000-00-00 00:00:00', '2012-07-27 02:31:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '1', '0', '4', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('37', '82', 'Position layout & Front-end effect', 'pl-frontend', '', '<p><strong>What is Position Layout?</strong></p>\r\n<p><img src=\"images/Layout/Position_Layout.png\" border=\"0\" alt=\"\" /></p>\r\n<p><!--[if gte mso 9]><xml>\r\n <o:OfficeDocumentSettings>\r\n  <o:RelyOnVML/>\r\n  <o:AllowPNG/>\r\n </o:OfficeDocumentSettings>\r\n</xml><![endif]--><!--[if gte mso 9]><xml>\r\n <w:WordDocument>\r\n  <w:View>Normal</w:View>\r\n  <w:Zoom>0</w:Zoom>\r\n  <w:TrackMoves/>\r\n  <w:TrackFormatting/>\r\n  <w:PunctuationKerning/>\r\n  <w:ValidateAgainstSchemas/>\r\n  <w:SaveIfXMLInvalid>false</w:SaveIfXMLInvalid>\r\n  <w:IgnoreMixedContent>false</w:IgnoreMixedContent>\r\n  <w:AlwaysShowPlaceholderText>false</w:AlwaysShowPlaceholderText>\r\n  <w:DoNotPromoteQF/>\r\n  <w:LidThemeOther>EN-US</w:LidThemeOther>\r\n  <w:LidThemeAsian>JA</w:LidThemeAsian>\r\n  <w:LidThemeComplexScript>X-NONE</w:LidThemeComplexScript>\r\n  <w:Compatibility>\r\n   <w:BreakWrappedTables/>\r\n   <w:SnapToGridInCell/>\r\n   <w:WrapTextWithPunct/>\r\n   <w:UseAsianBreakRules/>\r\n   <w:DontGrowAutofit/>\r\n   <w:SplitPgBreakAndParaMark/>\r\n   <w:DontVertAlignCellWithSp/>\r\n   <w:DontBreakConstrainedForcedTables/>\r\n   <w:DontVertAlignInTxbx/>\r\n   <w:Word11KerningPairs/>\r\n   <w:CachedColBalance/>\r\n   <w:UseFELayout/>\r\n  </w:Compatibility>\r\n  <m:mathPr>\r\n   <m:mathFont m:val=\"Cambria Math\"/>\r\n   <m:brkBin m:val=\"before\"/>\r\n   <m:brkBinSub m:val=\"--\"/>\r\n   <m:smallFrac m:val=\"off\"/>\r\n   <m:dispDef/>\r\n   <m:lMargin m:val=\"0\"/>\r\n   <m:rMargin m:val=\"0\"/>\r\n   <m:defJc m:val=\"centerGroup\"/>\r\n   <m:wrapIndent m:val=\"1440\"/>\r\n   <m:intLim m:val=\"subSup\"/>\r\n   <m:naryLim m:val=\"undOvr\"/>\r\n  </m:mathPr></w:WordDocument>\r\n</xml><![endif]--><!--[if gte mso 9]><xml>\r\n <w:LatentStyles DefLockedState=\"false\" DefUnhideWhenUsed=\"true\"\r\n  DefSemiHidden=\"true\" DefQFormat=\"false\" DefPriority=\"99\"\r\n  LatentStyleCount=\"267\">\r\n  <w:LsdException Locked=\"false\" Priority=\"0\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Normal\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"heading 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 7\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 8\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 9\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 7\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 8\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 9\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"35\" QFormat=\"true\" Name=\"caption\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"10\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Title\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"1\" Name=\"Default Paragraph Font\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"11\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Subtitle\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"22\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Strong\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"20\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Emphasis\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"59\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Table Grid\"/>\r\n  <w:LsdException Locked=\"false\" UnhideWhenUsed=\"false\" Name=\"Placeholder Text\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"1\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"No Spacing\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" UnhideWhenUsed=\"false\" Name=\"Revision\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"34\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"List Paragraph\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"29\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Quote\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"30\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Intense Quote\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"19\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Subtle Emphasis\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"21\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Intense Emphasis\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"31\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Subtle Reference\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"32\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Intense Reference\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"33\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Book Title\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"37\" Name=\"Bibliography\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" QFormat=\"true\" Name=\"TOC Heading\"/>\r\n </w:LatentStyles>\r\n</xml><![endif]--><!--[if gte mso 10]>\r\n<style>\r\n /* Style Definitions */\r\n table.MsoNormalTable\r\n	{mso-style-name:\"Table Normal\";\r\n	mso-tstyle-rowband-size:0;\r\n	mso-tstyle-colband-size:0;\r\n	mso-style-noshow:yes;\r\n	mso-style-priority:99;\r\n	mso-style-qformat:yes;\r\n	mso-style-parent:\"\";\r\n	mso-padding-alt:0in 5.4pt 0in 5.4pt;\r\n	mso-para-margin-top:0in;\r\n	mso-para-margin-right:0in;\r\n	mso-para-margin-bottom:10.0pt;\r\n	mso-para-margin-left:0in;\r\n	line-height:115%;\r\n	mso-pagination:widow-orphan;\r\n	font-size:11.0pt;\r\n	font-family:\"Calibri\",\"sans-serif\";\r\n	mso-ascii-font-family:Calibri;\r\n	mso-ascii-theme-font:minor-latin;\r\n	mso-hansi-font-family:Calibri;\r\n	mso-hansi-theme-font:minor-latin;\r\n	mso-bidi-font-family:\"Times New Roman\";\r\n	mso-bidi-theme-font:minor-bidi;}\r\n</style>\r\n<![endif]--><span style=\"font-size: 11.0pt; line-height: 115%; font-family: \'Calibri\',\'sans-serif\'; mso-ascii-theme-font: minor-latin; mso-fareast-font-family: \'MS Mincho\'; mso-fareast-theme-font: minor-fareast; mso-hansi-theme-font: minor-latin; mso-bidi-font-family: \'Times New Roman\'; mso-bidi-theme-font: minor-bidi; mso-ansi-language: EN-US; mso-fareast-language: JA; mso-bidi-language: AR-SA;\">Position layout is a drop-down menu that can be found in JV Framework\'s layout configuration for any block (with the exception of block \"Middle\")<br /></span></p>\r\n<p><span style=\"font-size: 11.0pt; line-height: 115%; font-family: \'Calibri\',\'sans-serif\'; mso-ascii-theme-font: minor-latin; mso-fareast-font-family: \'MS Mincho\'; mso-fareast-theme-font: minor-fareast; mso-hansi-theme-font: minor-latin; mso-bidi-font-family: \'Times New Roman\'; mso-bidi-theme-font: minor-bidi; mso-ansi-language: EN-US; mso-fareast-language: JA; mso-bidi-language: AR-SA;\"> This is where you can select how the site will display multiple modules assigned to the same position. <br /></span></p>\r\n', '\r\n<p> </p>\r\n<p><span style=\"font-size: 11.0pt; line-height: 115%; font-family: \'Calibri\',\'sans-serif\'; mso-ascii-theme-font: minor-latin; mso-fareast-font-family: \'MS Mincho\'; mso-fareast-theme-font: minor-fareast; mso-hansi-theme-font: minor-latin; mso-bidi-font-family: \'Times New Roman\'; mso-bidi-theme-font: minor-bidi; mso-ansi-language: EN-US; mso-fareast-language: JA; mso-bidi-language: AR-SA;\"><strong>The choices that Position Layout offer and front-end effects:</strong><br /></span></p>\r\n<p><span style=\"font-size: 11.0pt; line-height: 115%; font-family: \'Calibri\',\'sans-serif\'; mso-ascii-theme-font: minor-latin; mso-fareast-font-family: \'MS Mincho\'; mso-fareast-theme-font: minor-fareast; mso-hansi-theme-font: minor-latin; mso-bidi-font-family: \'Times New Roman\'; mso-bidi-theme-font: minor-bidi; mso-ansi-language: EN-US; mso-fareast-language: JA; mso-bidi-language: AR-SA;\"><em>Note: We will use a duplication of  the module \"Responsive Design\" assigned to the same position for front end demonstration</em><br /></span></p>\r\n<p><span style=\"font-size: 11.0pt; line-height: 115%; font-family: \'Calibri\',\'sans-serif\'; mso-ascii-theme-font: minor-latin; mso-fareast-font-family: \'MS Mincho\'; mso-fareast-theme-font: minor-fareast; mso-hansi-theme-font: minor-latin; mso-bidi-font-family: \'Times New Roman\'; mso-bidi-theme-font: minor-bidi; mso-ansi-language: EN-US; mso-fareast-language: JA; mso-bidi-language: AR-SA;\"><em> </em></span></p>\r\n<p><!--[if gte mso 9]><xml>\r\n <o:OfficeDocumentSettings>\r\n  <o:RelyOnVML/>\r\n  <o:AllowPNG/>\r\n </o:OfficeDocumentSettings>\r\n</xml><![endif]--><!--[if gte mso 9]><xml>\r\n <w:WordDocument>\r\n  <w:View>Normal</w:View>\r\n  <w:Zoom>0</w:Zoom>\r\n  <w:TrackMoves/>\r\n  <w:TrackFormatting/>\r\n  <w:PunctuationKerning/>\r\n  <w:ValidateAgainstSchemas/>\r\n  <w:SaveIfXMLInvalid>false</w:SaveIfXMLInvalid>\r\n  <w:IgnoreMixedContent>false</w:IgnoreMixedContent>\r\n  <w:AlwaysShowPlaceholderText>false</w:AlwaysShowPlaceholderText>\r\n  <w:DoNotPromoteQF/>\r\n  <w:LidThemeOther>EN-US</w:LidThemeOther>\r\n  <w:LidThemeAsian>JA</w:LidThemeAsian>\r\n  <w:LidThemeComplexScript>X-NONE</w:LidThemeComplexScript>\r\n  <w:Compatibility>\r\n   <w:BreakWrappedTables/>\r\n   <w:SnapToGridInCell/>\r\n   <w:WrapTextWithPunct/>\r\n   <w:UseAsianBreakRules/>\r\n   <w:DontGrowAutofit/>\r\n   <w:SplitPgBreakAndParaMark/>\r\n   <w:DontVertAlignCellWithSp/>\r\n   <w:DontBreakConstrainedForcedTables/>\r\n   <w:DontVertAlignInTxbx/>\r\n   <w:Word11KerningPairs/>\r\n   <w:CachedColBalance/>\r\n   <w:UseFELayout/>\r\n  </w:Compatibility>\r\n  <m:mathPr>\r\n   <m:mathFont m:val=\"Cambria Math\"/>\r\n   <m:brkBin m:val=\"before\"/>\r\n   <m:brkBinSub m:val=\"--\"/>\r\n   <m:smallFrac m:val=\"off\"/>\r\n   <m:dispDef/>\r\n   <m:lMargin m:val=\"0\"/>\r\n   <m:rMargin m:val=\"0\"/>\r\n   <m:defJc m:val=\"centerGroup\"/>\r\n   <m:wrapIndent m:val=\"1440\"/>\r\n   <m:intLim m:val=\"subSup\"/>\r\n   <m:naryLim m:val=\"undOvr\"/>\r\n  </m:mathPr></w:WordDocument>\r\n</xml><![endif]--><!--[if gte mso 9]><xml>\r\n <w:LatentStyles DefLockedState=\"false\" DefUnhideWhenUsed=\"true\"\r\n  DefSemiHidden=\"true\" DefQFormat=\"false\" DefPriority=\"99\"\r\n  LatentStyleCount=\"267\">\r\n  <w:LsdException Locked=\"false\" Priority=\"0\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Normal\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"heading 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 7\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 8\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"9\" QFormat=\"true\" Name=\"heading 9\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 7\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 8\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" Name=\"toc 9\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"35\" QFormat=\"true\" Name=\"caption\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"10\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Title\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"1\" Name=\"Default Paragraph Font\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"11\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Subtitle\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"22\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Strong\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"20\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Emphasis\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"59\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Table Grid\"/>\r\n  <w:LsdException Locked=\"false\" UnhideWhenUsed=\"false\" Name=\"Placeholder Text\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"1\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"No Spacing\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" UnhideWhenUsed=\"false\" Name=\"Revision\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"34\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"List Paragraph\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"29\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Quote\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"30\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Intense Quote\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 1\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 2\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 3\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 4\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 5\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"60\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Shading Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"61\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light List Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"62\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Light Grid Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"63\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 1 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"64\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Shading 2 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"65\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 1 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"66\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium List 2 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"67\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 1 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"68\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 2 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"69\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Medium Grid 3 Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"70\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Dark List Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"71\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Shading Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"72\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful List Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"73\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" Name=\"Colorful Grid Accent 6\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"19\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Subtle Emphasis\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"21\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Intense Emphasis\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"31\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Subtle Reference\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"32\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Intense Reference\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"33\" SemiHidden=\"false\"\r\n   UnhideWhenUsed=\"false\" QFormat=\"true\" Name=\"Book Title\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"37\" Name=\"Bibliography\"/>\r\n  <w:LsdException Locked=\"false\" Priority=\"39\" QFormat=\"true\" Name=\"TOC Heading\"/>\r\n </w:LatentStyles>\r\n</xml><![endif]--><!--[if gte mso 10]>\r\n<style>\r\n /* Style Definitions */\r\n table.MsoNormalTable\r\n	{mso-style-name:\"Table Normal\";\r\n	mso-tstyle-rowband-size:0;\r\n	mso-tstyle-colband-size:0;\r\n	mso-style-noshow:yes;\r\n	mso-style-priority:99;\r\n	mso-style-qformat:yes;\r\n	mso-style-parent:\"\";\r\n	mso-padding-alt:0in 5.4pt 0in 5.4pt;\r\n	mso-para-margin-top:0in;\r\n	mso-para-margin-right:0in;\r\n	mso-para-margin-bottom:10.0pt;\r\n	mso-para-margin-left:0in;\r\n	line-height:115%;\r\n	mso-pagination:widow-orphan;\r\n	font-size:11.0pt;\r\n	font-family:\"Calibri\",\"sans-serif\";\r\n	mso-ascii-font-family:Calibri;\r\n	mso-ascii-theme-font:minor-latin;\r\n	mso-hansi-font-family:Calibri;\r\n	mso-hansi-theme-font:minor-latin;\r\n	mso-bidi-font-family:\"Times New Roman\";\r\n	mso-bidi-theme-font:minor-bidi;}\r\n</style>\r\n<![endif]--></p>\r\n<p class=\"MsoNormal\">- Carousel: The modules will be displayed in a carousel manner, similar to images slides, with forward and previous buttons.</p>\r\n<p class=\"MsoNormal\">Front-end:</p>\r\n<p class=\"MsoNormal\"><img src=\"images/Layout/frontend/Carousel_frontend.png\" border=\"0\" alt=\"\" /></p>\r\n<p class=\"MsoNormal\"> </p>\r\n<p> </p>\r\n<p class=\"MsoNormal\"><span style=\"mso-tab-count: 1;\">- </span>Collapse: When multiple modules are assigned to the same position, they will be displayed as collapsible titles, similar to an accordion menu.</p>\r\n<p class=\"MsoNormal\">Front-end:</p>\r\n<p class=\"MsoNormal\"><img src=\"images/Layout/frontend/collapse_frontend.png\" border=\"0\" alt=\"\" /></p>\r\n<p class=\"MsoNormal\"> </p>\r\n<p> </p>\r\n<p class=\"MsoNormal\"><span style=\"mso-tab-count: 1;\">-</span> Default: When multiples modules are assigned to the same position, they will be displayed vertically while inheriting all styling for that position.</p>\r\n<p class=\"MsoNormal\">Front-end:</p>\r\n<p class=\"MsoNormal\"><img src=\"images/Layout/frontend/Default_frontend.png\" border=\"0\" alt=\"\" /></p>\r\n<p class=\"MsoNormal\"> </p>\r\n<p> </p>\r\n<p class=\"MsoNormal\"><span style=\"mso-tab-count: 1;\">-</span> Equal: When multiples modules are assigned to the same position, they will be displayed horizontally with the same width.</p>\r\n<p class=\"MsoNormal\">Front-end:</p>\r\n<p class=\"MsoNormal\"><img src=\"images/Layout/frontend/Equal_fronend.png\" border=\"0\" alt=\"\" /></p>\r\n<p class=\"MsoNormal\"> </p>\r\n<p> </p>\r\n<p class=\"MsoNormal\"><span style=\"mso-tab-count: 1;\">-</span> Raw: When multiples modules are assigned to the same position, they will be displayed vertically without inheriting the styling for that position.</p>\r\n<p class=\"MsoNormal\">Front-end:</p>\r\n<p class=\"MsoNormal\"><img src=\"images/Layout/frontend/Raw_frontend.png\" border=\"0\" alt=\"\" /></p>\r\n<p class=\"MsoNormal\"> </p>\r\n<p> </p>\r\n<p class=\"MsoNormal\"><span style=\"mso-tab-count: 1;\">-</span> Tab: When multiples modules are assigned to the same position, they will be displayed as tabs.</p>\r\n<p class=\"MsoNormal\">Front-end:</p>\r\n<p class=\"MsoNormal\"><img src=\"images/Layout/frontend/Tabs_frontend.png\" border=\"0\" alt=\"\" /></p>\r\n<p> </p>', '1', '0', '0', '16', '2012-08-18 09:34:52', '204', '', '2012-08-18 09:42:59', '92', '0', '0000-00-00 00:00:00', '2012-08-18 09:34:52', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '1', '', '', '1', '29', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('18', '60', 'Joomla', 'joomla', '', '<p>Joomla! means All Together, and it is a community of people all working and having fun together that makes Joomla! possible. Thousands of people each year participate in the Joomla! community, and we hope you will be one of them.</p>\r\n', '\r\n<p>People with all kinds of skills, of all skill levels and from around the world are welcome to join in. Participate in the <a href=\"http://joomla.org\">Joomla.org</a> family of websites (the<a href=\"http://forum.joomla.org\"> forum </a>is a great place to start). Come to a <a href=\"http://community.joomla.org/events.html\">Joomla! event</a>. Join or start a <a href=\"http://community.joomla.org/user-groups.html\">Joomla! Users Group</a>. Whether you are a developer, site administrator, designer, end user or fan, there are ways for you to participate and contribute.</p>', '1', '0', '0', '14', '2012-08-13 11:20:06', '204', '', '2012-08-24 03:11:18', '92', '0', '0000-00-00 00:00:00', '2012-08-13 11:20:06', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '3', '', '', '1', '971', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('19', '61', 'User Component', 'user-component', '', '<p>The users extension lets your site visitors register, login and logout, change their passwords and other information, and recover lost passwords. In the administrator it allows you to create, block and manage users and create user groups and access levels. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Users_User_Manager\">Help</a></p>\r\n', '\r\n<p>Please note that some of the user views will not display if you are not logged in to the site.</p>', '1', '0', '0', '14', '2012-08-13 11:22:47', '204', '', '2012-08-24 03:12:18', '92', '0', '0000-00-00 00:00:00', '2012-08-13 11:22:47', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '2', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('20', '62', 'Search Component', 'search-component', '', '<p>The search component uses plugins to control which parts of your Joomla! site are searched. You may choose to turn off some areas to improve performance or for other reasons. Many third party Joomla! extensions have search plugins that extend where search takes place.</p>\r\n', '\r\n<p>Default On:</p>\r\n<ul>\r\n<li>Content Help</li>\r\n<li>Contacts Help</li>\r\n<li>Weblinks Help</li>\r\n<li>News Feeds Help</li>\r\n<li>Categories Help</li>\r\n</ul>', '1', '0', '0', '14', '2012-08-14 02:04:29', '204', '', '2012-08-24 03:07:00', '92', '0', '0000-00-00 00:00:00', '2012-08-14 02:04:29', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '1', '', '', '1', '20', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('21', '63', 'News Feed', 'news-feed', '', '<p>News Feeds (com_newsfeeds) provides a way to organize and present news feeds. News feeds are a way that you present information from another site on your site. For example, the joomla.org website has numerous feeds that you can incorporate on your site. You an use menus to present a single feed, a list of feeds in a category, or or a list of all feed categories. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Newsfeeds_Feeds\">Help</a></p>', '', '1', '0', '0', '14', '2012-08-14 02:17:39', '204', '', '2012-08-24 03:06:40', '92', '0', '0000-00-00 00:00:00', '2012-08-14 02:17:39', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '0', '', '', '1', '18', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('22', '65', 'Services', 'services', '', '<div class=\"sv-part\">\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">What can we do for you</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec elementum sem a felis adipiscing ac rutrum massa faucibus. Duis nibh elit, dignissim id tempor in ipsumt consequat a diam. Nullam purus nunc.</p>\r\n</div>\r\n<div id=\"contenttop\">\r\n<div class=\"block eheight row\">\r\n<div class=\"span4\">\r\n<div class=\"jv-module\">\r\n<div class=\"custom-module\">\r\n<p class=\"thumbnail\"><img src=\"images/stories/demo/2.jpg\" border=\"0\" alt=\"\" /></p>\r\n<h3 class=\"title\">Demo title 1</h3>\r\n<ul class=\"arrowbizz\">\r\n<li>Lorem ipsum dolor sit amet, consectetur etiar lorem adipiscing elit etiam lorem eliteo dolor</li>\r\n<li>Lorem ipsum dolor sit amet, consectetur elite lorem adipiscing elit etiam consecteturer elit lorem adipiscing elit etiam</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"span4\">\r\n<div class=\"jv-module\">\r\n<div class=\"custom-module\">\r\n<p class=\"thumbnail\"><img src=\"images/stories/demo/3.jpg\" border=\"0\" alt=\"\" /></p>\r\n<h3 class=\"title\">Demo title 1</h3>\r\n<ul class=\"arrowbizz\">\r\n<li>Lorem ipsum dolor sit amet, consectetur etiar lorem adipiscing elit etiam lorem eliteo dolor</li>\r\n<li>Lorem ipsum dolor sit amet, consectetur elite lorem adipiscing elit etiam consecteturer elit lorem adipiscing elit etiam</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"span4\">\r\n<div class=\"jv-module\">\r\n<div class=\"custom-module\">\r\n<p class=\"thumbnail\"><img src=\"images/stories/demo/4.jpg\" border=\"0\" alt=\"\" /></p>\r\n<h3 class=\"title\">Demo title 1</h3>\r\n<ul class=\"arrowbizz\">\r\n<li>Lorem ipsum dolor sit amet, consectetur etiar lorem adipiscing elit etiam lorem eliteo dolor</li>\r\n<li>Lorem ipsum dolor sit amet, consectetur elite lorem adipiscing elit etiam consecteturer elit lorem adipiscing elit etiam</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sv-part\">\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Our Service Overview</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec elementum sem a felis adipiscing ac rutrum massa faucibus. Duis nibh elit, dignissim id tempor in ipsumt consequat a diam. Nullam purus nunc.</p>\r\n</div>\r\n<div class=\"item-page\">\r\n<p class=\"thumbnail\"><img src=\"images/stories/demo/5.jpg\" border=\"0\" alt=\"\" /></p>\r\n<div class=\"msg\">\r\n<p>\"Lorem ipsum dolor sit amet consectetuer,<br />adipiscing elit. Aenean commodo\"</p>\r\n</div>\r\n<h3 class=\"floatright\">Thy Tran , CEO</h3>\r\n</div>\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Our Speacial Offer</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec elementum sem a felis adipiscing ac rutrum massa faucibus. Duis nibh elit, dignissim id tempor in ipsumt consequat a diam. Nullam purus nunc.</p>\r\n</div>\r\n<div id=\"bottom\">\r\n<div class=\"block eheight row\">\r\n<div class=\"span4\">\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Best Management</h3>\r\n<div class=\"custom\">\r\n<p><img class=\"sv-icon floatleft\" src=\"images/stories/demo/management.png\" border=\"0\" alt=\"management\" />Aenean tincidunt lacusini pharetra leo. Curabitur le euismod sollicitudin sem Donec faucibus lacus</p>\r\n</div>\r\n</div>\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Support</h3>\r\n<div class=\"custom\">\r\n<p><img class=\"sv-icon floatleft\" src=\"images/stories/demo/support.png\" border=\"0\" alt=\"support\" />Aenean tincidunt lacusini pharetra leo. Curabitur le euismod sollicitudin sem Donec faucibus lacus</p>\r\n<div class=\"custom\"> </div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"span4\">\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Easy Setup</h3>\r\n<div class=\"custom\">\r\n<p><img class=\"sv-icon floatleft\" src=\"images/stories/demo/set-up.png\" border=\"0\" alt=\"set-up\" />Aenean tincidunt lacusini pharetra leo. Curabitur le euismod sollicitudin sem Donec faucibus lacus</p>\r\n</div>\r\n</div>\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Security</h3>\r\n<div class=\"custom\">\r\n<p><img class=\"sv-icon floatleft\" src=\"images/stories/demo/security.png\" border=\"0\" alt=\"security\" />Aenean tincidunt lacusini pharetra leo. Curabitur le euismod sollicitudin sem Donec faucibus lacus</p>\r\n<div class=\"custom\"> </div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"span4\">\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Well documentation</h3>\r\n<div class=\"custom\">\r\n<p><img class=\"sv-icon floatleft\" src=\"images/stories/demo/documentation.png\" border=\"0\" alt=\"documentation\" />Aenean tincidunt lacusini pharetra leo. Curabitur le euismod sollicitudin sem Donec faucibus lacus</p>\r\n</div>\r\n</div>\r\n<div class=\"jv-module\">\r\n<h3 class=\"title\">Help</h3>\r\n<div class=\"custom\">\r\n<p><img class=\"sv-icon floatleft\" src=\"images/stories/demo/help.png\" border=\"0\" alt=\"help\" />Aenean tincidunt lacusini pharetra leo. Curabitur le euismod sollicitudin sem Donec faucibus lacus</p>\r\n<div class=\"custom\"> </div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>', '', '1', '0', '0', '2', '2012-08-14 02:48:35', '204', '', '2012-08-14 07:00:39', '92', '0', '0000-00-00 00:00:00', '2012-08-14 02:48:35', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '11', '0', '3', '', '', '1', '349', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('23', '66', 'Performance', 'performance', '', '<p><span style=\"text-decoration: underline;\">Introduction</span><br />There are several factors that will slow down your site. For example, the number of request, the lack of support for caching, and the size of the data transmitted from the site to visiting user.<br />Among its default functions, JV Framework offers you the ability to optimize and speed up your site through the use of the \"Performance\" extension.</p>\r\n', '\r\n<p><br /><span style=\"text-decoration: underline;\">To access this extension:</span> <br />- Open JV Framework (Component --&gt; JV Framework).</p>\r\n<p><img src=\"images/performance/jvframework_component.png\" border=\"0\" alt=\"\" /></p>\r\n<p><br />- In style tab, enter \"Edit Style\" by clicking on the thumbnail/title of the style correspond to the page you want to optimize.</p>\r\n<p><img src=\"images/performance/jvframework_style.png\" border=\"0\" alt=\"\" /></p>\r\n<p><br />- In \"Edit Style\", select the tab Performance, then select either \"Compression\" or \"Flexible Image\" to set up the respective optimization methods.</p>\r\n<p>Compression (Image A)</p>\r\n<p><img src=\"images/performance/jvframework_performance-compress.png\" border=\"0\" alt=\"\" /></p>\r\n<p>Flexible Image (Image B)</p>\r\n<p><img src=\"images/performance/jvframework_performance-fleximage.png\" border=\"0\" alt=\"\" /></p>\r\n<p> </p>\r\n<p> </p>\r\n<p><span style=\"text-decoration: underline;\">Features</span></p>\r\n<p><br /><em>Compression </em><em>(Image A)</em><em>: </em></p>\r\n<p>This is where you can enable/disable various mode of compression to reduce the size of transmitted data. These modes also utilize a smart compression process to avoid interfering with the site loading speed.</p>\r\n<p>The compression modes available are:</p>\r\n<ul>\r\n<li>- CSS Compression: All the CSS files on your site will be combined into one then compressed. All users who enter the site will load this compressed file once. For all subsequent visits, the file will be loaded from their browser cache instead. <br /> Please remember to clear cache before making change to the setting in order to apply the new setting immediately. Otherwise, the new setting will take effect after 24 hours due to the cache.</li>\r\n<li>- JS Compression: All the JS files on your site will be combined into one then compressed. All users who enter the site will load this compressed file once. For all subsequent visits, the file will be loaded from their browser cache instead. <br /> Please remember to clear cache before making change to the setting in order to apply the new setting immediately. Otherwise, the new setting will take effect after 24 hours due to the cache.</li>\r\n<li>- Deferring loading: Deferring loading of JavaScript functions that are not called at startup reduces the initial download size, allowing other resources to be downloaded in parallel, and speeding up execution and rendering time.</li>\r\n<li>- GZIP Page Compression: The entire page will be compressed by GZip before it is sent to the user\'s browser, which will uncompress it. This will reduce the amount of transmitted data between the site and visiting users, resulting in faster loading.</li>\r\n</ul>\r\n<p><br /><em>Flexible Image </em><em>(Image B)</em><em>:</em></p>\r\n<p>Allow you to enable and disable Flexible image. This is a function that will automatically detect your screen size and resize the image to fit it better.</p>\r\n<p>For each screen size, there are 3 parameters:</p>\r\n<ul>\r\n<li>- Enable: Enable/disable flexible image support for that screen size</li>\r\n- Current size percentage: When this screen size is detected, the image will be resized to the percentage set in this field. - Min width (px): After the image was resized according to \"current size percentage\", if its width was smaller than the limit you set here, the percentage that fit this width will be used instead.</ul>\r\n<p>Please note that if an image\'s width at 100% is still smaller than \"min width\", the site will disregard min width for that image.</p>\r\n<p>The sizes we support include:</p>\r\n<ul>\r\n<li>- Full HD: 1900px and up</li>\r\n<li>- Large display: 1200px and 1899px</li>\r\n<li>- Standard Screen: 980px and 1199px</li>\r\n<li>- Smart phones to tablets: 768px to 979px</li>\r\n<li>- Smart phones: 767px and below</li>\r\n</ul>\r\n<p><br /><br /><span style=\"text-decoration: underline;\">Result:</span><br />A few sample result of utilizing our Performance Extension:</p>\r\n<p><br />Original site (before enabling any Performance function):</p>\r\n<p><img src=\"images/performance/jvframework_without_compress.png\" border=\"0\" alt=\"\" /><br /><br />After enabling compression:</p>\r\n<p><img src=\"images/performance/jvframework_compress_minify.png\" border=\"0\" alt=\"\" /><br /><br />After enabling compression and deferring loading:</p>\r\n<p><img src=\"images/performance/jvframework_compress_minify_deferloading.png\" border=\"0\" alt=\"\" /><br /><br />After enabling compression, deferring loading and flexible image:<br /><img src=\"images/performance/jvframework_compress_minify_deferloading_flexble_image.png\" border=\"0\" alt=\"\" /></p>\r\n<p>Without Flexible Image on Mobile</p>\r\n<p><img src=\"images/performance/jvframework_without_flexible_image_mobile.png\" border=\"0\" alt=\"\" /></p>\r\n<p>With Flexible Image on Mobile</p>\r\n<p><img src=\"images/performance/jvframework_flexible_image_mobile.png\" border=\"0\" alt=\"\" /></p>', '1', '0', '0', '16', '2012-08-14 03:41:41', '204', '', '2012-08-17 03:24:27', '92', '0', '0000-00-00 00:00:00', '2012-08-14 03:41:41', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '7', '0', '3', '', '', '1', '178', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('13', '50', 'JV Templates', 'jv-templates', '', '<div class=\"thumbnail\"><img src=\"images/stories/demo/templates.jpg\" border=\"0\" alt=\"templates\" /></div>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>\r\n', '\r\n<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum tortor quam, feugiat vitae, ultricies eget, tempor sit amet, ante. Donec eu libero sit amet quam egestas semper. Aenean ultricies mi vitae est. Mauris placerat eleifend leo. Quisque sit amet est et sapien ullamcorper pharetra. Vestibulum erat wisi, condimentum sed, commodo vitae, ornare sit amet, wisi. Aenean fermentum, elit eget tincidunt condimentum, eros ipsum rutrum orci, sagittis tempus lacus enim ac dui. Donec non enim in turpis pulvinar facilisis. Ut felis. Praesent dapibus, neque id cursus faucibus, tortor neque egestas augue, eu vulputate magna eros eu erat. Aliquam erat volutpat. Nam dui mi, tincidunt quis, accumsan porttitor, facilisis luctus, metus</p>', '1', '0', '0', '8', '2012-07-27 02:31:11', '204', '', '2012-08-18 09:38:24', '92', '0', '0000-00-00 00:00:00', '2012-07-27 02:31:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '3', '', '', '1', '212', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');
INSERT INTO `#__content` VALUES ('24', '67', 'Module Position', 'module-position', '', '<p style=\"text-align: center;\"><img src=\"images/stories/demo/position.jpg\" border=\"0\" alt=\"img\" /></p>', '', '1', '0', '0', '2', '2012-08-14 09:27:05', '204', '', '2012-08-15 03:37:21', '92', '0', '0000-00-00 00:00:00', '2012-08-14 09:27:05', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '7', '0', '2', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('25', '68', 'Position', 'position', '', '<p><img src=\"images/stories/demo/position.png\" alt=\"position\" /></p>', '', '1', '0', '0', '2', '2012-08-15 03:05:34', '204', '', '2012-10-02 02:45:55', '92', '0', '0000-00-00 00:00:00', '2012-08-15 03:05:34', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '1', '', '', '1', '221', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('26', '69', 'Extensions Tab', 'extensions-tab', '', '<p><strong>Intro:</strong><br />This is the tab where unclassified extensions for JV Framework will be placed.<br />With JV Framework default setting, this tab contain the following extensions:</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Extensions in this tab:</strong><br /><span style=\"text-decoration: underline;\"><br /></span>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=27&amp;Itemid=185\">Analytic</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=28&amp;Itemid=192\">Breadcrumb</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=29&amp;Itemid=224\">Copyright</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=30&amp;Itemid=186\">Date</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=31&amp;Itemid=187\">Font Resizer</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=32&amp;Itemid=188\">Lazy Loading</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=33&amp;Itemid=189\">Logo</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=34&amp;Itemid=191\">System Message</a></p>\r\n<p>- <a href=\"index.php?option=com_content&amp;view=article&amp;id=35&amp;Itemid=190\">Back to Top</a></p>\r\n<p> </p>', '-2', '0', '0', '17', '2012-08-16 08:33:51', '204', '', '2012-08-18 09:51:49', '92', '0', '0000-00-00 00:00:00', '2012-08-16 08:33:51', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '8', '', '', '1', '18', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('38', '83', 'Typography', 'typography', '', '<p><strong>Introduction:</strong><br />A new feature offered by JV Framework, Typography provides BBCode style macro functionality for Joomla, allowing the user to easily add complex HTML with a simple BBCode macro by changing the pre¬set syntax to the pre-defined HTML code when rendering a Joomla! article.<br />The user can also define complex HTML as simple macros, making the creating of articles with complex contents much easier.<br />An example of what can be done with this function would be creating tags similar to those usually found on forums.</p>\r\n', '\r\n<p><br /><strong>How to enter Typography Manager:</strong><br />- Open JV Framework (Component – JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /><br />- In Control Panel, click on Typography Manager.</p>\r\n<p><img src=\"images/Typography/Controlpanel_enter.png\" border=\"0\" alt=\"\" /></p>\r\n<p><br /><strong>How to setup a new Typography or edit an old one</strong><br />In the Typography Manager:</p>\r\n<p><img src=\"images/Typography/Typographymanager.png\" border=\"0\" alt=\"\" /><br />- Click new to setup a new Typography<br />- Check the check-box in front of an existing Typography, then click on “Edit” button to edit it. Alternatively, click on the existing Typography’s name.<br /><br />In both case (New and edit), the user will be directed to Edit Typography page.</p>\r\n<p><img src=\"images/Typography/EditTypography.png\" border=\"0\" alt=\"\" /><br />The fields that you will find in this page are:<br />- Title: Title of the new typography<br />- Tag: This is where you define the tag. <br />- Replacement: The HTML code that the tag will replace<br />- Example: This is where you give an example of how the tag should be used.<br />- Published: Enable/disable this Typography.<br /><br />Click on “Save” or “Save &amp; Close” to create the New Typography or to save the change to existing ones. <br />Click on “Back” to return to Typography Manager without saving.</p>\r\n<p> </p>\r\n<p>For examples of existing typographies, please <a href=\"index.php?option=com_jvframework&amp;view=typographies&amp;Itemid=156\">click here</a></p>', '1', '0', '0', '16', '2012-08-18 10:31:01', '204', '', '2012-08-18 10:38:56', '92', '0', '0000-00-00 00:00:00', '2012-08-18 10:31:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '0', '', '', '1', '44', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('36', '81', 'Layout', 'layout', '', '<p><strong>Layout Tab</strong><br />This is where the user can change the style’s layout, configure the grid of a block, as well as choose how modules assigned to the same position will be displayed.</p>\r\n', '\r\n<p><br /><strong>Opening Layout tab</strong><br />- Open JV Framework (Component---&gt; JV Framework).</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /><br />- Go to style manager and open the style whose layout you want to customize.</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /><br />- In the “Edit style” page, click on Layout tab.</p>\r\n<p><img src=\"images/Layout/Editstyle_layout.png\" border=\"0\" alt=\"\" /></p>\r\n<p> </p>\r\n<p><strong>Layout Options:</strong></p>\r\n<p><br /><span style=\"text-decoration: underline;\">Layout:</span><br />This is where you can select the general layout for your site</p>\r\n<p><img src=\"images/Layout/Layout.png\" border=\"0\" alt=\"\" /></p>\r\n<p><br /><br /><span style=\"text-decoration: underline;\">Block layout customization:</span><br />The blocks that can be customized include: <br /><em>Top</em>: This is where you can configure the layout of the Top block.<br /><em>Content Top</em>: This is where you can configure the layout of the Content Top block.<br /><em>Middle</em>: This is where you can adjust the width of the side bars and the page’s main body. From left to right, the sections of this grid are: Sidebar A – Main – Sidebar B.<br /><em>Content Bottom</em>: This is where you can configure the layout of the Content Bottom block.<br /><em>Bottom</em>: This is where you can configure the layout of the Bottom block.</p>\r\n<p><br /><em>With the exception of Middle, the parameters found in these blocks are as follow:</em></p>\r\n<p><img src=\"images/Layout/Top.png\" border=\"0\" alt=\"\" /></p>\r\n<p> </p>\r\n<p><br />- Block layout:</p>\r\n<p><img src=\"images/Layout/Block_layout.png\" border=\"0\" alt=\"\" /></p>\r\n<p>This is where you can select the layout for this block. The choices include:<br />    + Custom grid: This choice allows you to use the custom grid below for Block layout <br />    + Double right: The first position from the right will have double the width of other positions.<br />    + Double: The first position from the left will have double the width of other positions.<br />    + Equalize: All positions in this block will have the same width<br />    + Raw: All the positions will be placed vertically, without inheriting any styling from block.<br />    + Stack: All the positions will be placed vertically, but still inherit the block’s styling.</p>\r\n<p><br />- Position layout:</p>\r\n<p><img src=\"images/Layout/Position_Layout.png\" border=\"0\" alt=\"\" /></p>\r\n<p>This is where you can select how the site will display multiple modules assigned to the same position. The choices include:<br />    + Carousel: The modules will be displayed in a carousel similar to images slides, with forward and previous buttons.<br />    + Collapse: When multiple modules are assigned to the same position, they will be displayed as collapsible titles, similar to an accordion menu.<br />    + Default: When multiples modules are assigned to the same position, they will be displayed vertically while inheriting all styling for that position.<br />    + Equal: When multiples modules are assigned to the same position, they will be displayed horizontally with the same width.<br />    + Raw: When multiples modules are assigned to the same position, they will be displayed vertically without inheriting the styling for that position.<br />    + Tab: When multiples modules are assigned to the same position, they will be displayed as tabs.</p>\r\n<p>Effect of position layout on the front-end can be seen <a href=\"index.php?option=com_content&amp;view=article&amp;id=37&amp;Itemid=226\">here</a>.</p>\r\n<p><br />- Module style:</p>\r\n<p><img src=\"images/Layout/Module_style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>This is where you can select the style for your modules. The choices here are mostly from Joomla, except for:<br />    +Jvxhtml: the styling of the theme this style is based on<br />    +Raw: the equivalent of none in Joomla.</p>\r\n<p><br />- Class:</p>\r\n<p><img src=\"images/Layout/Class.png\" border=\"0\" alt=\"\" /></p>\r\n<p>This field allows you to give the entire block a div class.</p>\r\n<p><br />- Custom grid:</p>\r\n<p><img src=\"images/Layout/Custom_grid.png\" border=\"0\" alt=\"\" /></p>\r\n<p>Allowing user to customize the block\'s grid. Only applicable when \"custom-grid\" was selected as Block layout.</p>\r\n<p><br />Middle: Unlike other block, middle block only parameter is the \"Sidebar A - Main - Sidebar B\" grid.</p>\r\n<p><img src=\"images/Layout/Middle.png\" border=\"0\" alt=\"\" /></p>', '1', '0', '0', '16', '2012-08-18 08:07:38', '204', '', '2012-08-20 11:53:38', '92', '0', '0000-00-00 00:00:00', '2012-08-18 08:07:38', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '2', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('27', '72', 'Analytics', 'analytics', '', '<p><strong>Introduction:</strong></p>\r\n<p>This extension allows you to enable and disable the two popular web analytic service (Google Analytics and Yahoo Analytics) for you site.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Analytic extension:<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose analytic you want to disable/enable</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Analytic</p>\r\n<p><strong> </strong></p>\r\n<p><strong>Analytic back-end:<br /></strong></p>\r\n<p><img src=\"images/extensions_tab/Analytic.png\" border=\"0\" alt=\"\" /><br /><br /></p>', '1', '0', '0', '17', '2012-08-16 10:06:37', '204', '', '2012-08-18 09:50:26', '92', '0', '0000-00-00 00:00:00', '2012-08-16 10:06:37', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '7', '0', '9', '', '', '1', '17', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('28', '73', 'Breadcrumb', 'breadcrumb', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>This extension allows you to assign the breadcrumb to a position you want on the site.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Breadcrumb extension:<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose breadcrumb you want to reassign</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Breadcrumb</p>\r\n<p><span style=\"text-decoration: underline;\"> </span></p>\r\n<p><strong>Breadcrumb back-end:<br /></strong></p>\r\n<p><img src=\"images/extensions_tab/Breadcrumb.png\" border=\"0\" alt=\"\" /></p>\r\n<p> </p>\r\n<p> </p>\r\n<p><strong>Breadcrumb front-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/Breadcrumb_frontend.png\" border=\"0\" alt=\"\" /></p>\r\n<p> </p>', '1', '0', '0', '17', '2012-08-16 10:15:05', '204', '', '2012-08-20 12:05:15', '92', '0', '0000-00-00 00:00:00', '2012-08-16 10:15:05', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '7', '', '', '1', '73', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('29', '74', 'Copyright', 'copyright', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>An extension that disables/enables copyrights, including Joomla copyright, JV Framework copyright and user’s copyright.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Copyright extension:<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose copyright you want to change or disable/enable</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Copyright</p>\r\n<p><br /><br /><strong>Copyright back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/Copyright.png\" border=\"0\" alt=\"\" /><br />The parameters of this extension are:<br />- Enable Copyright: Enable/disable copyright in general.<br />- Joomla Copyright: Enable/disable Joomla’s copyright.<br />- JV Framework Copyright: Enable/disable JV Framework Copyright.<br />- Copyright: This is where you enter the copyright of your site.</p>\r\n<p> </p>\r\n<p><strong>Copyright front-end</strong>:<br /><img src=\"images/extensions_tab/Copyright_frontend.png\" border=\"0\" alt=\"\" /><br /><br /></p>\r\n<p> </p>', '1', '0', '0', '17', '2012-08-16 10:22:54', '204', '', '2012-08-20 12:05:19', '92', '0', '0000-00-00 00:00:00', '2012-08-16 10:22:54', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '8', '0', '6', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('30', '75', 'Date', 'date', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>An extension that display the current day on the site according to the format and parameter set by user.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Date extension:<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose date notifier you want to configure</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Date</p>\r\n<p><strong> </strong></p>\r\n<p><strong> </strong></p>\r\n<p><strong>Date back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/date_backend.png\" border=\"0\" alt=\"\" /><br />The parameters in this extension are:<br />- Enable: Enable/disable date display<br />- Text: The text before the date (for example: Today)<br />- Type: Allows you to choose between server time and client time<br />- Position: The position where the date will be displayed.<br />- Format: The format of the date (ex: d-m-y)</p>\r\n<p> </p>\r\n<p><strong>Date front-end</strong></p>\r\n<p><em><img src=\"images/extensions_tab/Date_frontend.png\" border=\"0\" alt=\"\" /></em></p>\r\n<p> </p>', '1', '0', '0', '17', '2012-08-16 10:25:48', '204', '', '2012-08-20 12:04:04', '92', '0', '0000-00-00 00:00:00', '2012-08-16 10:25:48', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '8', '0', '5', '', '', '1', '96', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('31', '76', 'Font Resizer', 'font-resizer', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>This extension allows the users to change the site’s font size from its front end.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Font Resizer extension:<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose font resizer you want to configure.</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Font Resizer</p>\r\n<p><strong> </strong></p>\r\n<p><strong>Font Resizer back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/Font_resizer.png\" border=\"0\" alt=\"\" /><br />The parameters in this extension are:<br />- Enable: Turning Font resize on and off<br />- Position: This is where you select the position for Font resize.<br />- Zoom level: This is where you set the zoom level whenever the font is enlarged or shrunk.<br />- CSS selector: The CSS selector that you want to apply the effect of font resizer to</p>\r\n<p> </p>\r\n<p><strong>Font Resizer front-end:</strong></p>\r\n<p><em><img src=\"images/extensions_tab/Fontresizer_frontend.png\" border=\"0\" alt=\"\" /></em></p>\r\n<p> </p>', '1', '0', '0', '17', '2012-08-16 10:28:30', '204', '', '2012-08-20 12:01:13', '92', '0', '0000-00-00 00:00:00', '2012-08-16 10:28:30', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '4', '', '', '1', '30', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('32', '77', 'Lazy Loading', 'lazy-loading', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>An extension that allows the users to enable/disable lazy-loading.<br />When enabled, lazy-loading mode allows your site’s visitor to download and view images from the portion of the page they are focusing upon only, instead of downloading image from the entire page.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Lazy Loading extension<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose lazy loading mode you want to configure or disable/enable</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Lazy Loading</p>\r\n<p><strong> </strong></p>\r\n<p><strong>Lazy Loading back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/lazy_loading.png\" border=\"0\" alt=\"lazy_loading\" /><br />The parameters of this extension:<br />- Enable: Turning Lazy loading on or off.<br />- CSS selector: The CSS selector that you want to apply Lazy Load to</p>', '1', '0', '0', '17', '2012-08-16 10:31:10', '204', '', '2012-08-20 11:57:14', '92', '0', '0000-00-00 00:00:00', '2012-08-16 10:31:10', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '3', '', '', '1', '11', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('33', '78', 'Logo', 'logo', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>An extension that lets you change and manage the logo of your site.</p>\r\n<p>Note: If you use this extension to change the logo, it will be superimposed. That mean switching the theme color will not change the color.If you want different logos for different theme colors, please use the theme manager to override the default corresponding logos.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Logo extension:<br /></strong></p>\r\n<p>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose logo you want to change.</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Logo</p>\r\n<p><strong> </strong></p>\r\n<p><strong>Logo back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/Logo.png\" border=\"0\" alt=\"\" /><br />The parameters in this extension are:<br />-  Logo Type: Allows you to choose between using image or text as your logo.<br />- Logo Position: Allows you to assign your logo to a position on the site.<br />- Select an image: If you chose to use an image as logo, this is where you select the image.<br />-  Your text logo: If you chose to use text as logo, this is where you enter the text.<br />- Your slogan: Only available for text logo. What you enter into this field will be used as your slogan.<br />- Width: Allows you to set the width of your logo<br />- Height: Allows you to set the height of your logo<br />- Padding: Allows you to set the padding of your logo.</p>', '1', '0', '0', '17', '2012-08-17 02:49:05', '204', '', '2012-08-20 09:47:35', '92', '0', '0000-00-00 00:00:00', '2012-08-17 02:49:05', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '2', '', '', '1', '1087', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('34', '79', 'System Message', 'system-message', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>An extension that allows the users to assign system messages to a position.</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening System Message extension:</strong></p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose system message you want to move/reassign</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; System Message</p>\r\n<p><strong> </strong></p>\r\n<p><strong>System Message back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/System_message.png\" border=\"0\" alt=\"\" /><br /><br /></p>', '1', '0', '0', '17', '2012-08-17 03:01:28', '204', '', '2012-08-20 11:55:54', '92', '0', '0000-00-00 00:00:00', '2012-08-17 03:01:28', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '6', '0', '1', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('35', '80', 'Back to top', 'back-to-top', '', '<p><strong>Introduction:<br /></strong></p>\r\n<p>An extension that enable/disable the “Go to top” button</p>\r\n', '\r\n<p> </p>\r\n<p><strong>Opening Go to top extension:<br /></strong>- Open JV Framework (Component---&gt; JV Framework)</p>\r\n<p><img src=\"images/extensions_tab/Component.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Go to style manager and open the style whose back-to-top button you want to disable/enable</p>\r\n<p><img src=\"images/extensions_tab/Style.png\" border=\"0\" alt=\"\" /></p>\r\n<p>- Click on Extension tab ---&gt; Go to top</p>\r\n<p> </p>\r\n<p><br /><strong>Go to top back-end:</strong></p>\r\n<p><img src=\"images/extensions_tab/Gototop.png\" border=\"0\" alt=\"\" /><br /><br /></p>\r\n<p> </p>\r\n<p> </p>\r\n<p><strong>Go to top front-end:</strong></p>\r\n<p><em><img src=\"images/extensions_tab/Backtotopfrontend.png\" border=\"0\" alt=\"\" /></em></p>', '1', '0', '0', '17', '2012-08-17 03:05:00', '204', '', '2012-08-18 09:50:38', '92', '0', '0000-00-00 00:00:00', '2012-08-17 03:05:00', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '0', '', '', '1', '27', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('39', '84', 'JV Template Group', 'jv-template', '', '<p><strong>JV Templates introduction:</strong><br />JV Templates is a Joomla template club, found and developed by team Joomlavi – A group of developers experienced in Joomla related projects. <br />With the use of our Framework, we intend to make thing easier for our template users, casual users and developers alike, all while striving to provide better and more beautiful templates. You don’t have to be an IT specialist to use, manage and customize our templates. If you are one of those specialists, however, we offer to you the ability to easily add and override the very functions of our Framework.</p>\r\n', '\r\n<p><br />The templates we provided (also called themes) are usually designed around certain activities to help the user choose what they need easier, but at the same time, they are flexible enough to be adapted for sites with different purposes. <br />Aside from templates, we also offer several Joomla extensions which can be used in conjunction with our templates or integrated to a totally unrelated site. What’s more, most of them are free as well.<br />With the release of JV Framework 3.0, we will strive to bring you even better and more up-to-date Products. <br />Don’t hesitate, now is a good time to join us.<br /><br /><strong>Pay once and gain access to all we have to offer.</strong> <br />Instead of having to pay for each commercial template or extension, by subscribing to one of our packages, you will gain access to all of our products during the membership period. <br />Even after the membership period has ended, you still retain the right to use any template/extension you have downloaded from our side, including whatever product-related privileges the expired package offered (like removing our copyright or using a template on more than 3 domains).<br /><br /><strong>Free users contents:</strong><br />If you cannot afford to pay, or want a taste of what we have to offer before paying, don’t hesitate to sign up. There are a lot of things you can grab as a free user.<br />Most of the extensions we have developed are free and can be integrated easily in website that does not use our template at all. <br />Even our main project - JV Framework is free, and depend on the installer you chose to download, may come with a free and versatile template (JV Melody for the older versions, and JV Basic for 3.0).<br />Sometime, we also release new free templates for JV Framework, so don’t forget to check back once in a while.<br /><br /><strong>Support and custom service:</strong> <br />We are well-aware of the importance of customer support. Thus, Joomlavi template group always strive to give our customers better support.<br />If there is any problem, you can contact us either via our ticket system or our email (info@joomlavi.com).<br />We also provide our customers, free and commercial alike, with the custom service. With a fee, we will customize the extension or template you downloaded according to your specification.</p>', '1', '0', '0', '8', '2012-08-28 09:48:11', '204', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-08-28 09:48:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '1', '0', '1', '', '', '1', '49', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('40', '85', 'Error page', 'error-page', '', '<p>Error page</p>', '', '0', '0', '0', '2', '2012-09-06 02:03:43', '204', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-09-06 02:03:43', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '1', '0', '0', '', '', '1', '17', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');
INSERT INTO `#__content` VALUES ('41', '86', 'văn test', 'văn-test', '', '<p>demo img <img src=\"images/stories/menu/home.png\" border=\"0\" alt=\"\" /><img src=\"images/gallery/cooking.jpg\" border=\"0\" alt=\"\" width=\"495\" height=\"601\" /></p>', '', '-2', '0', '0', '8', '2012-09-11 03:03:46', '204', '', '2012-09-11 03:05:49', '92', '0', '0000-00-00 00:00:00', '2012-09-11 03:03:46', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '0', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');

-- ----------------------------
-- Table structure for `#__content_frontpage`
-- ----------------------------
DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__content_frontpage
-- ----------------------------
INSERT INTO `#__content_frontpage` VALUES ('2', '7');
INSERT INTO `#__content_frontpage` VALUES ('10', '3');
INSERT INTO `#__content_frontpage` VALUES ('12', '6');
INSERT INTO `#__content_frontpage` VALUES ('11', '1');
INSERT INTO `#__content_frontpage` VALUES ('17', '4');
INSERT INTO `#__content_frontpage` VALUES ('14', '2');
INSERT INTO `#__content_frontpage` VALUES ('13', '5');

-- ----------------------------
-- Table structure for `#__content_rating`
-- ----------------------------
DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__content_rating
-- ----------------------------
INSERT INTO `#__content_rating` VALUES ('11', '5', '1', '127.0.0.1');

-- ----------------------------
-- Table structure for `#__core_log_searches`
-- ----------------------------
DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__core_log_searches
-- ----------------------------

-- ----------------------------
-- Table structure for `#__extensions`
-- ----------------------------
DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10136 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__extensions
-- ----------------------------
INSERT INTO `#__extensions` VALUES ('1', 'com_mailto', 'component', 'com_mailto', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('2', 'com_wrapper', 'component', 'com_wrapper', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('3', 'com_admin', 'component', 'com_admin', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('4', 'com_banners', 'component', 'com_banners', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('5', 'com_cache', 'component', 'com_cache', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('6', 'com_categories', 'component', 'com_categories', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('7', 'com_checkin', 'component', 'com_checkin', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('8', 'com_contact', 'component', 'com_contact', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"contact_layout\":\"_:default\",\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"plain\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"images\\/stories\\/demo\\/icons\\/phone.png\",\"icon_fax\":\"\",\"icon_misc\":\"images\\/stories\\/demo\\/icons\\/information.png\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"0\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"0\",\"show_mobile_headings\":\"1\",\"show_fax_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"initial_sort\":\"ordering\",\"captcha\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_feed_link\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('9', 'com_cpanel', 'component', 'com_cpanel', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10', 'com_installer', 'component', 'com_installer', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('11', 'com_languages', 'component', 'com_languages', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('12', 'com_login', 'component', 'com_login', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('13', 'com_media', 'component', 'com_media', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}', '{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('14', 'com_menus', 'component', 'com_menus', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('15', 'com_messages', 'component', 'com_messages', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('16', 'com_modules', 'component', 'com_modules', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('17', 'com_newsfeeds', 'component', 'com_newsfeeds', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('18', 'com_plugins', 'component', 'com_plugins', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('19', 'com_search', 'component', 'com_search', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}', '{\"enabled\":\"0\",\"show_date\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('20', 'com_templates', 'component', 'com_templates', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"template_positions_display\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('21', 'com_weblinks', 'component', 'com_weblinks', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"target\":\"0\",\"count_clicks\":\"1\",\"icons\":1,\"link_icons\":\"images\\/stories\\/demo\\/Globe.png\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_num_links\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_links_cat\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"0\",\"show_link_description\":\"1\",\"show_link_hits\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('22', 'com_content', 'component', 'com_content', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"0\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"0\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"left\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"feed_show_readmore\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('23', 'com_config', 'component', 'com_config', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}', '{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('24', 'com_redirect', 'component', 'com_redirect', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('25', 'com_users', 'component', 'com_users', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"useractivation\":\"1\",\"frontend_userparams\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('27', 'com_finder', 'component', 'com_finder', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}', '{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('28', 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"updatesource\":\"sts\",\"customurl\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('100', 'PHPMailer', 'library', 'phpmailer', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2001\",\"author\":\"PHPMailer\",\"copyright\":\"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2011, Jim Jagielski. All Rights Reserved.\",\"authorEmail\":\"jimjag@gmail.com\",\"authorUrl\":\"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/\",\"version\":\"5.2\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('101', 'SimplePie', 'library', 'simplepie', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('102', 'phputf8', 'library', 'phputf8', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('103', 'Joomla! Platform', 'library', 'joomla', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"Joomla! Platform\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"11.4\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('200', 'mod_articles_archive', 'module', 'mod_articles_archive', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('201', 'mod_articles_latest', 'module', 'mod_articles_latest', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('202', 'mod_articles_popular', 'module', 'mod_articles_popular', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('203', 'mod_banners', 'module', 'mod_banners', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('204', 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('205', 'mod_custom', 'module', 'mod_custom', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('206', 'mod_feed', 'module', 'mod_feed', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('207', 'mod_footer', 'module', 'mod_footer', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('208', 'mod_login', 'module', 'mod_login', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('209', 'mod_menu', 'module', 'mod_menu', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('210', 'mod_articles_news', 'module', 'mod_articles_news', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('211', 'mod_random_image', 'module', 'mod_random_image', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('212', 'mod_related_items', 'module', 'mod_related_items', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('213', 'mod_search', 'module', 'mod_search', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('214', 'mod_stats', 'module', 'mod_stats', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('215', 'mod_syndicate', 'module', 'mod_syndicate', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('216', 'mod_users_latest', 'module', 'mod_users_latest', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('217', 'mod_weblinks', 'module', 'mod_weblinks', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('218', 'mod_whosonline', 'module', 'mod_whosonline', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('219', 'mod_wrapper', 'module', 'mod_wrapper', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('220', 'mod_articles_category', 'module', 'mod_articles_category', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('221', 'mod_articles_categories', 'module', 'mod_articles_categories', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('222', 'mod_languages', 'module', 'mod_languages', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('223', 'mod_finder', 'module', 'mod_finder', '', '0', '1', '0', '0', '{\"legacy\":false,\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('300', 'mod_custom', 'module', 'mod_custom', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('301', 'mod_feed', 'module', 'mod_feed', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('302', 'mod_latest', 'module', 'mod_latest', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('303', 'mod_logged', 'module', 'mod_logged', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('304', 'mod_login', 'module', 'mod_login', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('305', 'mod_menu', 'module', 'mod_menu', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('307', 'mod_popular', 'module', 'mod_popular', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('308', 'mod_quickicon', 'module', 'mod_quickicon', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('309', 'mod_status', 'module', 'mod_status', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('310', 'mod_submenu', 'module', 'mod_submenu', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('311', 'mod_title', 'module', 'mod_title', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('312', 'mod_toolbar', 'module', 'mod_toolbar', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('313', 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"cache\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('314', 'mod_version', 'module', 'mod_version', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}', '{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('400', 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}', '{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('401', 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('402', 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}', '{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}', '', '', '0', '0000-00-00 00:00:00', '3', '0');
INSERT INTO `#__extensions` VALUES ('404', 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}', '{\"mode\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('405', 'plg_content_geshi', 'plugin', 'geshi', 'content', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0');
INSERT INTO `#__extensions` VALUES ('406', 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"style\":\"xhtml\"}', '', '', '0', '2011-09-18 15:22:50', '0', '0');
INSERT INTO `#__extensions` VALUES ('407', 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}', '{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '4', '0');
INSERT INTO `#__extensions` VALUES ('408', 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}', '{\"position\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '5', '0');
INSERT INTO `#__extensions` VALUES ('409', 'plg_content_vote', 'plugin', 'vote', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '6', '0');
INSERT INTO `#__extensions` VALUES ('410', 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('411', 'plg_editors_none', 'plugin', 'none', 'editors', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"2.5.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0');
INSERT INTO `#__extensions` VALUES ('412', 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2012\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.5.4.1\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}', '{\"mode\":\"1\",\"skin\":\"0\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"resizing\":\"true\",\"resize_horizontal\":\"false\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '3', '0');
INSERT INTO `#__extensions` VALUES ('413', 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('414', 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0');
INSERT INTO `#__extensions` VALUES ('415', 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '3', '0');
INSERT INTO `#__extensions` VALUES ('416', 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '4', '0');
INSERT INTO `#__extensions` VALUES ('417', 'plg_search_categories', 'plugin', 'categories', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('418', 'plg_search_contacts', 'plugin', 'contacts', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('419', 'plg_search_content', 'plugin', 'content', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('420', 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('421', 'plg_search_weblinks', 'plugin', 'weblinks', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('422', 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('423', 'plg_system_p3p', 'plugin', 'p3p', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}', '{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}', '', '', '0', '0000-00-00 00:00:00', '2', '0');
INSERT INTO `#__extensions` VALUES ('424', 'plg_system_cache', 'plugin', 'cache', 'system', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"browsercache\":\"0\",\"cachetime\":\"15\"}', '', '', '0', '0000-00-00 00:00:00', '9', '0');
INSERT INTO `#__extensions` VALUES ('425', 'plg_system_debug', 'plugin', 'debug', 'system', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}', '{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '4', '0');
INSERT INTO `#__extensions` VALUES ('426', 'plg_system_log', 'plugin', 'log', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '5', '0');
INSERT INTO `#__extensions` VALUES ('427', 'plg_system_redirect', 'plugin', 'redirect', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '6', '0');
INSERT INTO `#__extensions` VALUES ('428', 'plg_system_remember', 'plugin', 'remember', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '7', '0');
INSERT INTO `#__extensions` VALUES ('429', 'plg_system_sef', 'plugin', 'sef', 'system', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '8', '0');
INSERT INTO `#__extensions` VALUES ('430', 'plg_system_logout', 'plugin', 'logout', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '3', '0');
INSERT INTO `#__extensions` VALUES ('431', 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('432', 'plg_user_joomla', 'plugin', 'joomla', 'user', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{\"autoregister\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '2', '0');
INSERT INTO `#__extensions` VALUES ('433', 'plg_user_profile', 'plugin', 'profile', 'user', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('434', 'plg_extension_joomla', 'plugin', 'joomla', 'extension', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('435', 'plg_content_joomla', 'plugin', 'joomla', 'content', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('436', 'plg_system_languagecode', 'plugin', 'languagecode', 'system', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '10', '0');
INSERT INTO `#__extensions` VALUES ('437', 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('438', 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('439', 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}', '{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('440', 'plg_system_highlight', 'plugin', 'highlight', 'system', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '7', '0');
INSERT INTO `#__extensions` VALUES ('441', 'plg_content_finder', 'plugin', 'finder', 'content', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('442', 'plg_finder_categories', 'plugin', 'categories', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0');
INSERT INTO `#__extensions` VALUES ('443', 'plg_finder_contacts', 'plugin', 'contacts', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0');
INSERT INTO `#__extensions` VALUES ('444', 'plg_finder_content', 'plugin', 'content', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '3', '0');
INSERT INTO `#__extensions` VALUES ('445', 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '4', '0');
INSERT INTO `#__extensions` VALUES ('446', 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '5', '0');
INSERT INTO `#__extensions` VALUES ('500', 'atomic', 'template', 'atomic', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"2.5.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('502', 'bluestork', 'template', 'bluestork', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}', '{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('503', 'beez_20', 'template', 'beez_20', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('504', 'hathor', 'template', 'hathor', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"2.5.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('505', 'beez5', 'template', 'beez5', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('600', 'English (United Kingdom)', 'language', 'en-GB', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.5\",\"description\":\"en-GB site language\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('601', 'English (United Kingdom)', 'language', 'en-GB', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.5\",\"description\":\"en-GB administrator language\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('700', 'files_joomla', 'file', 'joomla', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"September 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.7\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('800', 'PKG_JOOMLA', 'package', 'pkg_joomla', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"PKG_JOOMLA\",\"type\":\"package\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PKG_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10000', 'JV-Framework', 'template', 'jv-framework', '', '0', '1', '1', '0', '{\"name\":\"JV-Framework\",\"type\":\"template\",\"creationDate\":\"June 2011\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"www.joomlavi.com\",\"version\":\"1.0.2\",\"description\":\"\\n  <style type=\\\"text\\/css\\\">\\n  \\t.icon-wrapper {width: auto; height: auto}\\n\\t.adminform {text-align: left}\\n  \\t.edit-template { display: none}\\n  \\t#template-manager .edit-template {  display: block}\\n  \\t#template-manager > ul {  float: left; list-style: none; margin: 0;}\\n  \\t#template-manager .pull-left {margin-right: 10px}\\n  \\t#adminForm .adminform > a > img {border: 1px solid #CCC; margin-right: 20px}\\n  \\t#adminForm h2 {text-transform: uppercase; color: #7FB11F}\\n  \\t#adminForm ul li {padding: 2px}\\n  \\t#style-form > div, .width-40, .width-60 {width: 100% !important}\\n  \\tfieldset.adminform > label { display: none}\\n  \\t#style-form .mod-desc {margin-left: 0 !important}\\n  \\t\\n  \\t#controlpanel {background: #FFF; overflow: hidden; padding: 30px 0; clear: both}\\n\\t#controlpanel div.icon a{ text-align: center; height: inherit; text-decoration: none; width: 125px; float: left; margin-right: 15px; border: 1px solid #CCC; background: #FFF}\\n\\t\\n\\t#controlpanel img {padding: 0; float: none;}\\n\\t#controlpanel span { display: block; height: 25px; background: #2c2c2c; color: #FFF; line-height: 25px; text-align: center;}\\n\\t\\n\\t#controlpanel .about { line-height:20px; border: medium none; clear: both; }\\n\\t#controlpanel .about h3 {margin: 0 0 10px; color: #7fb11f; font-size: 18px}\\n\\t#controlpanel .about .about-inner { }\\n\\t#controlpanel .about .about-inner > div { padding:15px}\\n\\t#controlpanel .about .cpanel-inner { border-bottom: 1px solid #CCC; padding: 20px 0 !important;}\\n\\t\\n\\t#controlpanel .about p { margin: 10px 0 0; font-size: 12px;}\\n\\t#controlpanel .about ul { padding-left:0; color:#909090}\\n\\t#controlpanel .about ul li { list-style-type:none; padding: 0}\\n\\t\\n\\t.company-info a { display:block; padding-top:10px; text-align:right; float:right}\\n  <\\/style>\\n  <script type=\\\"text\\/javascript\\\">\\n  \\tfunction getUrlVars() {var vars = {}; var parts = window.location.href.replace(\\/[?&]+([^=&]+)=([^&]*)\\/gi, function(m,key,value) { vars[key] = value; }); return vars; }\\n\\t \\n\\t window.addEvent(\'domready\', function(){\\n\\t\\t var btn_edit = $(\'edit-template\');  \\t  \\n\\t  \\t btn_edit.set(\'href\',  btn_edit.get(\'href\')  + \'&id=\' + getUrlVars()[\\\"id\\\"] );\\n\\t }); \\n  <\\/script>\\n\\t <ul>\\n\\t\\t<li><em>Version: 3.0<\\/em><\\/li>\\n\\t\\t<li><em>Release date: 08\\/08\\/2012<\\/em><\\/li>\\n\\t    <li><em>Contact us: <a href=\\\"mailto:info@joomlavi.com\\\">info@joomlavi.com<\\/a><\\/em><\\/li>\\n\\t<\\/ul>\\n\\t  <div id=\\\"controlpanel\\\">\\n\\t<form name=\\\"adminForm\\\" method=\\\"post\\\" action=\\\"\\/jv-framework\\/administrator\\/index.php?option=com_jvframework\\\">\\n\\t<div class=\\\"width-60 fltlft\\\">\\n\\t\\t<div class=\\\"cpanel-icon\\\">\\n\\t\\t\\t<div class=\\\"icon-wrapper edit-template\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t\\t<a title=\\\"Edit template::Edit template using JV Framework template editor\\\" id=\\\"edit-template\\\" class=\\\"modal hasTip\\\" rel=\\\"{handler: \'iframe\', size: {x: 875, y: 550}, onClose: function() {}}\\\" href=\\\"index.php?option=com_jvframework&view=theme&layout=edit&tmpl=component\\\">\\n\\t\\t\\t\\t\\t\\t<img alt=\\\"\\\" src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/thememanager.png\\\">\\n\\t\\t\\t\\t\\t\\t<span>Edit template<\\/span>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t\\t<a title=\\\"Typographies::The \\u201cTypography\\u201d manager allows you to set up, edit and delete the typographies that will be used on your site.\\\" class=\\\"hasTip\\\" href=\\\"index.php?option=com_jvframework&amp;view=typographies\\\">\\n\\t\\t\\t\\t\\t\\t<img src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/typographies.png\\\" alt=\\\"\\\">\\n\\t\\t\\t\\t\\t\\t<span>Typographies<\\/span>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t\\t<a title=\\\"Extensions::This manager list all the JV Framework extensions that were installed on your site.\\\" class=\\\"hasTip\\\" href=\\\"index.php?option=com_jvframework&amp;view=extensions\\\">\\n\\t\\t\\t\\t\\t\\t<img src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/extension.png\\\" alt=\\\"\\\">\\n\\t\\t\\t\\t\\t\\t<span>Extensions<\\/span>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t<a title=\\\"Install::Use Joomla\'s Installer to install JV-Framework\'s Extension.\\\" class=\\\"hasTip\\\" href=\\\"index.php?option=com_installer\\\">\\n\\t\\t\\t\\t\\t<img src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/install.png\\\" alt=\\\"\\\">\\n\\t\\t\\t\\t\\t<span>Install<\\/span>\\n\\t\\t\\t\\t<\\/a>\\t\\t\\t\\t\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t<div class=\\\"width-60 about\\\">\\n    \\t<div class=\\\"about-inner\\\">\\n\\t\\t<div class=\\\"cpanel-inner\\\">\\n\\t\\t\\t<h3>\\/\\/\\/\\/ JV Framework<\\/h3>\\n\\t\\t\\t\\n\\t\\t\\t<p>Flexible, customizable, high performance and developer-friendly.\\nJV Framework 3.0 is a steep improvemence over our old Framework. While dropping some functions like drag and drop, it had gained several new ones, more up-to-date functions like a Grid layout control, a Responsive Design and a modular nature, allowing developers to improve or create new features with ease.\\n<br>Try it out and experience the improvemence.<\\/p>\\n\\t\\t<\\/div>\\n        <div class=\\\"cpanel-logo\\\"><a href=\\\"http:\\/\\/joomlavi.com\\\" target=\\\"_blank\\\"><img alt=\\\"Logo\\\" src=\\\"components\\/com_jvframework\\/assets\\/images\\/logo2.png\\\"><\\/a><\\/div>\\n        <\\/div>\\n\\t<\\/div>\\t\\n\\t<div>\\n    \\t<input type=\\\"hidden\\\" value=\\\"\\\" name=\\\"task\\\">\\t\\n        <input type=\\\"hidden\\\" value=\\\"styles\\\" name=\\\"view\\\">\\n    <\\/div>\\n\\t<\\/form>\\t\\n<\\/div>\\n  \",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10001', 'System - JVFramework ', 'plugin', 'jvframework', 'system', '0', '1', '1', '0', '{\"name\":\"System - JVFramework \",\"type\":\"plugin\",\"creationDate\":\"Feb 2011\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"www.joomlavi.com\",\"version\":\"3.0.5\",\"description\":\"\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10043', 'System - JV JQuery Libraries ', 'plugin', 'jvjquerylib', 'system', '0', '1', '1', '0', '{\"name\":\"System - JV JQuery Libraries \",\"type\":\"plugin\",\"creationDate\":\"Match 2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"www.joomlavi.com\",\"version\":\"1.2.0\",\"description\":\"\\n    \\n        jQuery, jQuery ui and Customfield for all version Joomla.\\n    \\n    \",\"group\":\"\"}', '{\"drops\":\"\",\"define\":\"[]\",\"configs\":\"[{\\\"@data\\\":{\\\"name\\\":\\\"jquery\\\",\\\"scripts\\\":\\\"{jspath}\\/jquery.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"a=b&c=d,f=g\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"ui\\\",\\\"scripts\\\":\\\"\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[{\\\"@data\\\":{\\\"name\\\":\\\"core\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/ui\\/jquery.ui.core.min.js\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.core.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"widget\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/ui\\/jquery.ui.widget.min.js\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.theme.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"position\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/ui\\/jquery.ui.position.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"mouse\\\",\\\"scripts\\\":\\\"ui.core,ui.widget,{jspath}\\/ui\\/jquery.ui.mouse.min.js%20\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"draggable\\\",\\\"scripts\\\":\\\"ui.mouse,{jspath}\\/ui\\/jquery.ui.draggable.min.js%20\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"droppable\\\",\\\"scripts\\\":\\\"ui.draggable,{jspath}\\/ui\\/jquery.ui.droppable.min.js%20\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"resizable\\\",\\\"scripts\\\":\\\"ui.mouse,{jspath}\\/ui\\/jquery.ui.resizable.min.js%20\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.resizable.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"sortable\\\",\\\"scripts\\\":\\\"ui.mouse,{jspath}\\/ui\\/jquery.ui.sortable.min.js%20\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"accordion\\\",\\\"scripts\\\":\\\"ui.core,ui.widget,{jspath}\\/ui\\/jquery.ui.accordion.min.js%20\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.accordion.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"autocomplete\\\",\\\"scripts\\\":\\\"ui.core,ui.widget,ui.position,{jspath}\\/ui\\/jquery.ui.autocomplete.min.js%20\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.autocomplete.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"button\\\",\\\"scripts\\\":\\\"ui.core,ui.widget,{jspath}\\/ui\\/jquery.ui.button.min.js%20\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.button.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"dialog\\\",\\\"scripts\\\":\\\"ui.button,ui.position,ui.draggable,ui.resizable,{jspath}\\/ui\\/jquery.ui.dialog.min.js%20\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.dialog.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"slider\\\",\\\"scripts\\\":\\\"ui.mouse,{jspath}\\/ui\\/jquery.ui.slider.min.js%20\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.slider.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"tabs\\\",\\\"scripts\\\":\\\"ui.core,ui.widget,{jspath}\\/ui\\/jquery.ui.tabs.min.js\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.tabs.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"datepicker\\\",\\\"scripts\\\":\\\"ui.core,{jspath}\\/ui\\/jquery.ui.datepicker.min.js\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.datepicker.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"progressbar\\\",\\\"scripts\\\":\\\"ui.core,ui.widget,{jspath}\\/ui\\/jquery.ui.progressbar.min.js\\\",\\\"styles\\\":\\\"{jspath}\\/ui\\/themes\\/base\\/jquery.ui.progressbar.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"combobox\\\",\\\"scripts\\\":\\\"ui.core,ui.button,ui.autocomplete,{jspath}\\/ui\\/jquery.ui.combobox.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"numericbox\\\",\\\"scripts\\\":\\\"ui.core,ui.button,ui.autocomplete,ui.slider,{jspath}\\/ui\\/jquery.ui.numericbox.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}}]}},{\\\"@data\\\":{\\\"name\\\":\\\"effects\\\",\\\"scripts\\\":\\\"\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[{\\\"@data\\\":{\\\"name\\\":\\\"core\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/effects\\/jquery.effects.core.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"blind\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.blind.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"bounce\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.bounce.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"box\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.box.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"clip\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.clip.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"drop\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.drop.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"explode\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.explode.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"fade\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.fade.min.js%20\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"fold\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.fold.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"highlight\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.highlight.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"pulsate\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.pulsate.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"scale\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.scale.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"shake\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.shake.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"slide\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.slide.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"transfer\\\",\\\"scripts\\\":\\\"effects.core,{jspath}\\/effects\\/jquery.effects.transfer.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}}]}},{\\\"@data\\\":{\\\"name\\\":\\\"plugins\\\",\\\"scripts\\\":\\\"\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[{\\\"@data\\\":{\\\"name\\\":\\\"colorpicker\\\",\\\"scripts\\\":\\\"ui.widget,{jspath}\\/plugins\\/jquery.colorpicker.js\\\",\\\"styles\\\":\\\"{jspath}\\/plugins\\/colorpicker\\/style.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"customfield\\\",\\\"scripts\\\":\\\"ui.button,ui.sortable,ui.tabs,ui.autocomplete,ui.datepicker,ui.combobox,ui.numericbox,plugins.colorpicker,plugins.validate,{jspath}\\/plugins\\/customfield.js\\\",\\\"styles\\\":\\\"{jspath}\\/plugins\\/customfield\\/style.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"mousewheel\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/plugins\\/jquery.mousewheel.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"transform\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/plugins\\/transformjs.1.0.beta.2.min.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"hotkey\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/plugins\\/jquery.hotkey.js\\\",\\\"styles\\\":\\\"\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}},{\\\"@data\\\":{\\\"name\\\":\\\"validate\\\",\\\"scripts\\\":\\\"jquery,{jspath}\\/plugins\\/jquery.validate.min.js\\\",\\\"styles\\\":\\\"{jspath}\\/plugins\\/validate\\/style.css\\\",\\\"deny\\\":\\\"\\\",\\\"childs\\\":[]}}]}}]\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10018', 'JV Framework - Analytic', 'extension', 'analytic', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Analytic\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Analytic extension for JV Framework \",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10012', 'jvframework', 'component', 'com_jvframework', '', '1', '1', '0', '0', '{\"name\":\"JVFRAMEWORK\",\"type\":\"component\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved.\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"www.joomlavi.com\",\"version\":\"3.0.5\",\"description\":\"\\n\\t\\n\\t<style type=\\\"text\\/css\\\">\\n\\t.icon-wrapper {width: auto; height: auto}\\n\\t.adminform {text-align: left}\\n  \\t.edit-template { display: none}\\n  \\t#template-manager #adminForm .edit-template {  display: block}\\n  \\t#adminForm .adminform > a > img {border: 1px solid #CCC; margin-right: 20px}\\n  \\t#adminForm h2 {text-transform: uppercase; color: #7FB11F}\\n  \\t#adminForm ul li {padding: 2px}\\n  \\t#style-form > div, .width-40, .width-60 {width: 100% !important; text-align: left}\\n  \\tfieldset.adminform > label { display: none}\\n  \\t#style-form .mod-desc {margin-left: 0 !important}\\n  \\t\\n  \\t#controlpanel {background: #FFF; overflow: hidden; padding: 30px 0; clear: both}\\n\\t#controlpanel div.icon a{ text-align: center; height: inherit; text-decoration: none; width: 125px; float: left; margin-right: 15px; border: 1px solid #CCC; background: #FFF}\\n\\t\\n\\t#controlpanel img {padding: 0; float: none;}\\n\\t#controlpanel span { display: block; height: 25px; background: #2c2c2c; color: #FFF; line-height: 25px; text-align: center;}\\n\\t\\n\\t#controlpanel .about { line-height:20px; border: medium none; clear: both; }\\n\\t#controlpanel .about h3 {margin: 0 0 10px; color: #7fb11f; font-size: 18px}\\n\\t#controlpanel .about .about-inner { }\\n\\t#controlpanel .about .about-inner > div { padding:15px}\\n\\t#controlpanel .about .cpanel-inner { border-bottom: 1px solid #CCC; padding: 20px 0 !important;}\\n\\t\\n\\t#controlpanel .about p { margin: 10px 0 0; font-size: 12px;}\\n\\t#controlpanel .about ul { padding-left:0; color:#909090}\\n\\t#controlpanel .about ul li { list-style-type:none; padding: 0}\\n\\t\\n\\t.company-info a { display:block; padding-top:10px; text-align:right; float:right}\\n  <\\/style>\\n  <script type=\\\"text\\/javascript\\\">\\n  \\tfunction getUrlVars() {var vars = {}; var parts = window.location.href.replace(\\/[?&]+([^=&]+)=([^&]*)\\/gi, function(m,key,value) { vars[key] = value; }); return vars; }\\n\\t \\n\\t window.addEvent(\'domready\', function(){\\n\\t\\tvar btn_edit = $(\'edit-template\');  \\n\\t\\tif(btn_edit)\\t\\t \\n\\t\\t\\tbtn_edit.set(\'href\',  btn_edit.get(\'href\')  + \'&id=\' + getUrlVars()[\\\"id\\\"] );\\n\\t }); \\n  <\\/script>\\n\\t <ul>\\n\\t\\t<li><em>Version: 3.0<\\/em><\\/li>\\n\\t\\t<li><em>Release date: 08\\/08\\/2012<\\/em><\\/li>\\n\\t    <li><em>Contact us: <a href=\\\"mailto:info@joomlavi.com\\\">info@joomlavi.com<\\/a><\\/em><\\/li>\\n\\t<\\/ul>\\n\\t  <div id=\\\"controlpanel\\\">\\n\\t<div class=\\\"width-60 fltlft\\\">\\n\\t\\t<div class=\\\"cpanel-icon\\\">\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t\\t<a href=\\\"index.php?option=com_templates&view=styles\\\" class=\\\"hasTip\\\" title=\\\"Style::The \\u201cStyle\\u201d manager allows you to create, delete and edit styles \\u2013 instances of the theme with their own setting, which you can apply to the entire site or a single page.\\\">\\n\\t\\t\\t\\t\\t\\t<img alt=\\\"\\\" src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/style.png\\\">\\n\\t\\t\\t\\t\\t\\t<span>Style<\\/span>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t\\t<a title=\\\"Typographies::The \\u201cTypography\\u201d manager allows you to set up, edit and delete the typographies that will be used on your site.\\\" class=\\\"hasTip\\\" href=\\\"index.php?option=com_jvframework&amp;view=typographies\\\">\\n\\t\\t\\t\\t\\t\\t<img src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/typographies.png\\\" alt=\\\"\\\">\\n\\t\\t\\t\\t\\t\\t<span>Typographies<\\/span>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t\\t<a title=\\\"Extensions::This manager list all the JV Framework extensions that were installed on your site.\\\" class=\\\"hasTip\\\" href=\\\"index.php?option=com_jvframework&amp;view=extensions\\\">\\n\\t\\t\\t\\t\\t\\t<img src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/extension.png\\\" alt=\\\"\\\">\\n\\t\\t\\t\\t\\t\\t<span>Extensions<\\/span>\\n\\t\\t\\t\\t\\t<\\/a>\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<div class=\\\"icon-wrapper\\\">\\n\\t\\t\\t\\t<div class=\\\"icon\\\">\\n\\t\\t\\t\\t<a title=\\\"Install::Use Joomla\'s Installer to install JV-Framework\'s Extension.\\\" class=\\\"hasTip\\\" href=\\\"index.php?option=com_installer\\\">\\n\\t\\t\\t\\t\\t<img src=\\\"components\\/com_jvframework\\/assets\\/images\\/cpanel\\/install.png\\\" alt=\\\"\\\">\\n\\t\\t\\t\\t\\t<span>Install<\\/span>\\n\\t\\t\\t\\t<\\/a>\\t\\t\\t\\t\\n\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t<div class=\\\"width-60 about\\\">\\n    \\t<div class=\\\"about-inner\\\">\\n\\t\\t<div class=\\\"cpanel-inner\\\">\\n\\t\\t\\t<h3>\\/\\/\\/\\/ JV Framework<\\/h3>\\n\\t\\t\\t\\n\\t\\t\\t<p>Flexible, customizable, high performance and developer-friendly.\\nJV Framework 3.0 is a steep improvemence over our old Framework. While dropping some functions like drag and drop, it had gained several new ones, more up-to-date functions like a Grid layout control, a Responsive Design and a modular nature, allowing developers to improve or create new features with ease.\\n<br>Try it out and experience the improvemence.<\\/p>\\n\\t\\t<\\/div>\\n        <div class=\\\"cpanel-logo\\\"><a href=\\\"http:\\/\\/joomlavi.com\\\" target=\\\"_blank\\\"><img alt=\\\"Logo\\\" src=\\\"components\\/com_jvframework\\/assets\\/images\\/logo2.png\\\"><\\/a><\\/div>\\n        <\\/div>\\n\\t<\\/div>\\t\\t\\n<\\/div>\\n\\t\\t\\n\\t\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10015', 'System - JV Gallery', 'plugin', 'jvgallery', 'system', '0', '1', '1', '0', '{\"name\":\"System - JV Gallery\",\"type\":\"plugin\",\"creationDate\":\"05\\/10\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"www.joomlavi.com\",\"version\":\"2.0\",\"description\":\"<strong>JV Gallery For Joomla<\\/strong><br\\/>Please install JV Gallery editor plugin for \\\"insert gallery\\\" button in custom HTML type modules and articles\",\"group\":\"\"}', '{\"theme\":\"1\",\"width\":\"120\",\"height\":\"100\",\"cols\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10016', 'Button - JVGallery', 'plugin', 'jvgallery', 'editors-xtd', '0', '1', '1', '0', '{\"name\":\"Button - JVGallery\",\"type\":\"plugin\",\"creationDate\":\"05\\/10\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"www.joomlavi.com\",\"version\":\"2.0\",\"description\":\"JV Gallery editor plugin for Joomla\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10120', 'isis', 'template', 'isis', '', '1', '1', '1', '0', '{\"name\":\"isis\",\"type\":\"template\",\"creationDate\":\"3\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_ISIS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"templateColor\":\"\",\"logoFile\":\"\",\"admin_menus\":\"1\",\"displayHeader\":\"1\",\"statusFixed\":\"1\",\"stickyToolbar\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10121', 'JV Framework - Bootstrap', 'extension', 'bootstrap', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Bootstrap\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Bootstrap extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10122', 'JV Framework - Breadcrumb', 'extension', 'breadcrumb', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Breadcrumb\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Breadcrumb extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10123', 'JV Framework - Copyright', 'extension', 'copyright', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Copyright\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Copyright extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10124', 'JV Framework - Date', 'extension', 'date', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Date\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Date extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10125', 'JV Framework - Fontsizer', 'extension', 'fontsizer', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Fontsizer\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Fontsizer extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10126', 'JV Framework - Layout Manager', 'extension', 'layout', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Layout Manager\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Layout Manager For JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10127', 'JV Framework - Lazyload', 'extension', 'lazyload', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Lazyload\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Lazyload for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10128', 'JV Framework - Logo', 'extension', 'logo', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Logo\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Site logo extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10129', 'JV Framework - Menu System', 'extension', 'menu', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Menu System\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Menu System Feature\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10130', 'JV Framework - Message', 'extension', 'message', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Message\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"System message extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10131', 'JV Framework - Mobile', 'extension', 'mobile', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Mobile\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Mobile Support for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10132', 'JV Framework - Performance', 'extension', 'performance', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Performance\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Performance Optimizing For JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10133', 'JV Framework - Style', 'extension', 'style', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Style\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Style \",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10134', 'JV Framework - Totop', 'extension', 'totop', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Totop\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Totop extension for JV Framework\",\"group\":\"\"}', '[]', '', '', '0', '0000-00-00 00:00:00', '0', '0');
INSERT INTO `#__extensions` VALUES ('10135', 'JV Framework - Typography', 'extension', 'typo', '', '0', '1', '0', '0', '{\"name\":\"JV Framework - Typography\",\"type\":\"extension\",\"creationDate\":\"14\\/7\\/2012\",\"author\":\"JoomlaVi! Project\",\"copyright\":\"Copyright (C) JoomlaVi. All rights reserved\",\"authorEmail\":\"info@joomlavi.com\",\"authorUrl\":\"http:\\/\\/www.joomlavi.com\",\"version\":\"1.0\",\"description\":\"Typography extension for JV Framework\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');

-- ----------------------------
-- Table structure for `#__jv_typos`
-- ----------------------------
DROP TABLE IF EXISTS `#__jv_typos`;
CREATE TABLE `#__jv_typos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `tag` varchar(100) NOT NULL,
  `replacement` text NOT NULL,
  `example` text,
  `ordering` int(11) NOT NULL DEFAULT '1',
  `published` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=28 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__jv_typos
-- ----------------------------
INSERT INTO `#__jv_typos` VALUES ('1', 'h3', 'h3', '<h3>{param}</h3>', '[h3]H3[/h3]', '1', '1');
INSERT INTO `#__jv_typos` VALUES ('2', 'h2', 'h2', '<h2 class=\"{option}\">{param}</h2>', '[h2=hidden1]abc1[/h2]', '2', '1');
INSERT INTO `#__jv_typos` VALUES ('3', 'Blocknumber 1', 'blocknumber1', '<p class=\"blocknumber\"><span class=\"bignumber-1\">{option}</span>{param}</p>', '[blocknumber1=01]Your content goes here![/blocknumber1]', '5', '1');
INSERT INTO `#__jv_typos` VALUES ('4', 'notice', 'notice', '<p class=\"error bg1\"><span class=\"icon\"> </span>{param}</p>', '[notice]Notice[/notice]', '11', '1');
INSERT INTO `#__jv_typos` VALUES ('5', 'url', 'url', '<a href=\"{option}\">{param}</a>', '[url=http://joomlavi.com]joomlavi.com[/url]', '3', '1');
INSERT INTO `#__jv_typos` VALUES ('6', 'Paragraph Style - Message', 'message', '<p class=\"message bg2\"><span class=\"icon\"></span>{param}</p>', '[message]Your text here[/message]', '12', '1');
INSERT INTO `#__jv_typos` VALUES ('7', 'Box Style - Sticky', 'sticky', '<p class=\"box-sticky\">{param}</p>', '[sticky]Your clip note goes here![/sticky]', '4', '1');
INSERT INTO `#__jv_typos` VALUES ('8', 'Paragraph Style - Photo', 'photo', '<p class=\"photo bg3\"><span class=\"icon\"> </span>{param}</p>', '[photo]Your message goes here![/photo]', '18', '1');
INSERT INTO `#__jv_typos` VALUES ('9', 'Blocknumber 2', 'blocknumber2', '<p class=\"blocknumber\"><span class=\"bignumber-2\">{option}</span>{param}</p>', '[blocknumber2=01]Your content goes here![/blocknumber2]', '6', '1');
INSERT INTO `#__jv_typos` VALUES ('10', 'Blocknumber 3', 'blocknumber3', '<p class=\"blocknumber\"><span class=\"bignumber-3\">{option}</span>{param}</p>', '[blocknumber3=01]Your content goes here![/blocknumber3]', '7', '1');
INSERT INTO `#__jv_typos` VALUES ('11', 'Tips', 'tips', '<p class=\"tips bg1\"><span class=\"icon\"> </span>{param}</p>', '[tips]Your content goes here![/tips]', '19', '1');
INSERT INTO `#__jv_typos` VALUES ('12', 'Key', 'key', '<p class=\"key bg2\"><span class=\"icon\"> </span>{param}</p>', '[key]Your content goes here![/key]', '20', '1');
INSERT INTO `#__jv_typos` VALUES ('13', 'Tag', 'tag', '<p class=\"tag bg4\"><span class=\"icon\"> </span>{param}</p>', '[tag]Your content goes here![/tag]', '17', '1');
INSERT INTO `#__jv_typos` VALUES ('14', 'Cart', 'cart', '<p class=\"cart bg1\"><span class=\"icon\"> </span>{param}</p>', '[cart]Your content goes here![/cart]', '15', '1');
INSERT INTO `#__jv_typos` VALUES ('15', 'Doc', 'doc', '<p class=\"doc bg5\"><span class=\"icon\"> </span>{param}</p>', '[doc]Your content goes here![/doc]', '14', '1');
INSERT INTO `#__jv_typos` VALUES ('16', 'Note', 'note', '<p class=\"note bg3\"><span class=\"icon\"> </span>{param}</p>', '[note]Your content goes here![/note]', '10', '1');
INSERT INTO `#__jv_typos` VALUES ('17', 'Mobi', 'mobi', '<p class=\"mobi bg2\"><span class=\"icon\"> </span>{param}</p>', '[mobi]Your content goes here![/mobi]', '16', '1');
INSERT INTO `#__jv_typos` VALUES ('18', 'Download', 'download', '<p class=\"download bg4\"><span class=\"icon\"></span>{param}</p>', '[download]Your content goes here![/download]', '13', '1');
INSERT INTO `#__jv_typos` VALUES ('19', 'Box Grey', 'box-grey', '<p class=\"box-grey\">{param}</p>', '[box-grey]Your content goes here![/box-grey]', '8', '1');
INSERT INTO `#__jv_typos` VALUES ('20', 'Box Hilite', 'box-hilite', '<p class=\"box-hilite\">{param}</p>', '[box-hilite]Your content goes here![/box-hilite]', '9', '1');
INSERT INTO `#__jv_typos` VALUES ('21', 'Legend', 'legend', '<div class=\"legend\"><h3 class=\"legend-title\">{option}</h3><p>{param}</p></div>', '[legend=Legend style]Your content goes here![/legend]', '26', '1');
INSERT INTO `#__jv_typos` VALUES ('22', 'Legend-Hilite', 'legend-hilite', '<div class=\"legend-hilite\"><h3 class=\"legend-title\">{option}</h3><p>{param}</p></div>', '[legend-hilite=style highlight]Your content goes here![/legend-hilite]', '27', '1');
INSERT INTO `#__jv_typos` VALUES ('23', 'badge', 'badge', '<div class=\"jv-module module-badge badge-{option}\"><span class=\"badge\"></span>{param}</div>', '[badge=top]<div style=\"padding: 30px 25px;\">Use module suffix: <strong>_badge badge-top</strong> to put this badge on any module you like!</div>[/badge]\r\n[badge=new]<div style=\"padding: 30px 25px;\">Use module suffix: <strong>_badge badge-new</strong> to put this badge on any module you like!</div>[/badge]\r\n[badge=hot]<div style=\"padding: 30px 25px;\">Use module suffix: <strong>_badge badge-hot</strong> to put this badge on any module you like!</div>[/badge]\r\n[badge=pick]<div style=\"padding: 30px 25px;\">Use module suffix: <strong>_badge badge-pick</strong> to put this badge on any module you like!</div>[/badge]', '22', '1');
INSERT INTO `#__jv_typos` VALUES ('24', 'Youtube', 'youtube', '<a class=\"btn\" data-toggle=\"modal\" href=\"#md{param}\">Watch Video</a>\r\n<div class=\"btmodal fade hide\" id=\"md{param}\">\r\n    <div class=\"modal-body\">\r\n        <iframe {option} src=\"http://www.youtube.com/embed/{param}\" frameborder=\"0\" allowfullscreen></iframe>\r\n    </div>\r\n</div>\r\n', '[youtube=width=\"530\" height=\"350\"]DgwtRpf60xI[/youtube]', '23', '1');
INSERT INTO `#__jv_typos` VALUES ('25', 'Vimeo', 'vimeo', '<a class=\"btn\" data-toggle=\"modal\" href=\"#md{param}\">Watch Video</a>\r\n<div class=\"btmodal fade hide\" id=\"md{param}\">\r\n    <div class=\"modal-body\">\r\n       <iframe {option} src=\"http://player.vimeo.com/video/{param}\" frameborder=\"0\" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>\r\n    </div>\r\n</div>\r\n', '[vimeo=width=\"500\" height=\"281\"]46497874[/vimeo]', '24', '1');
INSERT INTO `#__jv_typos` VALUES ('26', 'Alerts ', 'alert', '<div class=\"alert {option}\">\r\n	<button class=\"close\" data-dismiss=\"alert\">×</button>\r\n	{param}\r\n</div>', '[alert=alert-block]<h4 class=\"alert-heading\">Warning!</h4> Best check yo self, you\'re not looking too good.[/alert]\r\n[alert=alert-error alert-block]<h4 class=\"alert-heading\">Oh snap!</h4> Change a few things up and try submitting again.[/alert]\r\n[alert=alert-success alert-block]<h4 class=\"alert-heading\">Well done!</h4> You successfully read this important alert message.[/alert]\r\n[alert=alert-info alert-block]<h4 class=\"alert-heading\">Heads up!</h4> This alert needs your attention, but it\'s not super important.[/alert]', '25', '1');
INSERT INTO `#__jv_typos` VALUES ('27', 'Icon', 'icon', '<i class=\"icon-{option}\">{param}</i>', '[icon=search][/icon]Graciously provided by Glyphicons\r\n<div class=\"input-prepend\"><span class=\"add-on\">[icon=envelope][/icon]</span><input type=\"text\" id=\"inputIcon\" class=\"span2\"></div>\r\n<a href=\"#\" class=\"btn btn-large\">[icon=comment][/icon] Comment</a>\r\n<a href=\"#\" class=\"btn btn-primary\">[icon=user icon-white][/icon] User</a>', '21', '1');

-- ----------------------------
-- Table structure for `#__languages`
-- ----------------------------
DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__languages
-- ----------------------------
INSERT INTO `#__languages` VALUES ('1', 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', '1', '0', '1');

-- ----------------------------
-- Table structure for `#__menu`
-- ----------------------------
DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to framework_menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to framework_extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to framework_users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=286 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__menu
-- ----------------------------
INSERT INTO `#__menu` VALUES ('1', '', 'Menu_Item_Root', 'root', '', '', '', '', '1', '0', '0', '0', '0', '0', '0000-00-00 00:00:00', '0', '0', '', '0', '', '0', '191', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('2', 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', '0', '1', '1', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners', '0', '', '1', '10', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('3', 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', '0', '2', '2', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners', '0', '', '2', '3', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('4', 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', '0', '2', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners-cat', '0', '', '4', '5', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('5', 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', '0', '2', '2', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners-clients', '0', '', '6', '7', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('6', 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', '0', '2', '2', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners-tracks', '0', '', '8', '9', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('7', 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', '0', '1', '1', '8', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:contact', '0', '', '11', '16', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('8', 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', '0', '7', '2', '8', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:contact', '0', '', '12', '13', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('9', 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', '0', '7', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:contact-cat', '0', '', '14', '15', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('10', 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', '0', '1', '1', '15', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:messages', '0', '', '17', '22', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('11', 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', '0', '10', '2', '15', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:messages-add', '0', '', '18', '19', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('12', 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', '0', '10', '2', '15', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:messages-read', '0', '', '20', '21', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('13', 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', '0', '1', '1', '17', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:newsfeeds', '0', '', '23', '28', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('14', 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', '0', '13', '2', '17', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:newsfeeds', '0', '', '24', '25', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('15', 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', '0', '13', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:newsfeeds-cat', '0', '', '26', '27', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('16', 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', '0', '1', '1', '24', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:redirect', '0', '', '41', '42', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('17', 'menu', 'com_search', 'Basic Search', '', 'Basic Search', 'index.php?option=com_search', 'component', '0', '1', '1', '19', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:search', '0', '', '33', '34', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('18', 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', '0', '1', '1', '21', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:weblinks', '0', '', '35', '40', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('19', 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', '0', '18', '2', '21', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:weblinks', '0', '', '36', '37', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('20', 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', '0', '18', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:weblinks-cat', '0', '', '38', '39', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('21', 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', '0', '1', '1', '27', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:finder', '0', '', '31', '32', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('22', 'menu', 'com_joomlaupdate', 'Joomla! Update', '', 'Joomla! Update', 'index.php?option=com_joomlaupdate', 'component', '0', '1', '1', '28', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:joomlaupdate', '0', '', '43', '44', '0', '*', '1');
INSERT INTO `#__menu` VALUES ('101', 'mainmenu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=featured', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"info_bloc_position\":\"0\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"images\\/stories\\/menu\\/home.png\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"Welcome to JV Framework\",\"pageclass_sfx\":\" blog\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"menu_image_type\":\"bgr\",\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"Welcome\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '29', '30', '1', '*', '0');
INSERT INTO `#__menu` VALUES ('285', 'main', 'COM_JVFRAMEWORK_MENU', 'com-jvframework-menu', '', 'com-jvframework-menu', 'index.php?option=com_jvframework', 'component', '0', '1', '1', '10012', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_jvframework/assets/images/jv.ico', '0', '', '189', '190', '0', '', '1');
INSERT INTO `#__menu` VALUES ('103', 'mainmenu', 'Feature', 'feature', '', 'feature', '', 'separator', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"images\\/stories\\/menu\\/extension.png\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"JV Framework Extension\",\"fxmenu_column\":\"2\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"440px\",\"fxmenu_module_style\":\"jvxhtml\"}', '45', '94', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('192', 'mainmenu', 'Breadcrumb', 'breadcrumb', '', 'feature/utilities/breadcrumb', 'index.php?option=com_content&view=article&id=28', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '65', '66', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('105', 'joomla', 'Joomla! Overview', 'joomla-overview', '', 'joomla-overview', 'index.php?option=com_content&view=article&id=4', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '95', '100', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('106', 'joomla', 'Joomla! License', 'joomla-license', '', 'joomla-license', 'index.php?option=com_content&view=article&id=5', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '101', '102', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('107', 'joomla', 'More about Joomla', 'more-about-joomla', '', 'more-about-joomla', 'index.php?option=com_content&view=article&id=6', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '103', '104', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('108', 'joomla', 'FAQ', 'faq', '', 'faq', 'index.php?option=com_content&view=article&id=7', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '105', '106', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('109', 'joomla', 'The News', 'the-news', '', 'the-news', 'index.php?option=com_content&view=article&id=8', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '107', '108', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('110', 'joomla', 'Web links', 'web-links', '', 'web-links', 'index.php?option=com_content&view=article&id=9', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '109', '110', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('111', 'mainmenu', 'Joomla', 'joomla', '', 'joomla', 'index.php?option=com_content&view=article&id=18', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"images\\/stories\\/menu\\/joomla.png\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"Joomla Component\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '111', '170', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('126', 'mainmenu', 'Weblinks Component', 'weblinks-component', '', 'joomla/weblinks-component', '', 'separator', '1', '111', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\"]}', '136', '143', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('183', 'mainmenu', 'Flexible Menu', 'flexible-menu', '', 'feature/menu/flexible-menu', 'index.php?option=com_content&view=article&id=23', 'component', '1', '198', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '75', '76', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('184', 'mainmenu', 'Mobility', 'mobility', '', 'feature/features/mobility', 'index.php?option=com_content&view=article&id=11', 'component', '1', '197', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '51', '52', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('124', 'joomla', 'The News', 'the-news', '', 'joomla-overview/the-news', 'index.php?option=com_content&view=article&id=8', 'component', '1', '105', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '96', '97', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('125', 'joomla', 'Web links', 'web-links', '', 'joomla-overview/web-links', 'index.php?option=com_content&view=article&id=9', 'component', '1', '105', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_subwidth\":\"\",\"fxmenu_subwidth_colwidth\":\"\",\"fxmenu_group\":\"0\",\"fxmenu_submenu\":\"submenu\"}', '98', '99', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('130', 'mainmenu', 'Content Component', 'content-component', '', 'joomla/content-component', 'index.php?option=com_content&view=article&id=18', 'component', '1', '111', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '112', '125', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('131', 'mainmenu', 'Contact Component', 'contact-component', '', 'joomla/contact-component', '', 'separator', '1', '111', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"94\"]}', '126', '135', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('134', 'mainmenu', 'Article Featured', 'article-featured', '', 'joomla/content-component/article-featured', 'index.php?option=com_content&view=featured', 'component', '1', '130', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '113', '114', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('180', 'mainmenu', 'Performance Optimization', 'performance-optimization', '', 'feature/features/performance-optimization', 'index.php?option=com_content&view=article&id=23', 'component', '1', '197', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '49', '50', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('136', 'mainmenu', 'Article Category List', 'article-category-list', '', 'joomla/content-component/article-category-list', 'index.php?option=com_content&view=category&id=8', 'component', '1', '130', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '121', '122', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('135', 'mainmenu', 'List All Category', 'list-all-category', '', 'joomla/content-component/list-all-category', 'index.php?option=com_content&view=categories&id=0', 'component', '1', '130', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '119', '120', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('137', 'mainmenu', 'Contact Category', 'contact-category', '', 'joomla/contact-component/contact-category', 'index.php?option=com_contact&view=category&id=10', 'component', '1', '131', '3', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"initial_sort\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"94\"]}', '127', '128', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('138', 'mainmenu', 'Single Contact', 'single-contact', '', 'joomla/contact-component/single-contact', 'index.php?option=com_contact&view=contact&id=1', 'component', '1', '131', '3', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"presentation_style\":\"plain\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"94\"]}', '131', '132', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('140', 'mainmenu', 'Article Single', 'article-single', '', 'joomla/content-component/article-single', 'index.php?option=com_content&view=article&id=10', 'component', '1', '130', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '115', '116', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('185', 'mainmenu', 'Analytics', 'analytics', '', 'feature/utilities/analytics', 'index.php?option=com_content&view=article&id=27', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '67', '68', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('186', 'mainmenu', 'Date Notifier', 'date-time', '', 'feature/utilities/date-time', 'index.php?option=com_content&view=article&id=30', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '55', '56', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('187', 'mainmenu', 'Font Resizer', 'font-sizer', '', 'feature/utilities/font-sizer', 'index.php?option=com_content&view=article&id=31', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '57', '58', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('188', 'mainmenu', 'Lazy Loading', 'lazy-loading', '', 'feature/utilities/lazy-loading', 'index.php?option=com_content&view=article&id=32', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '59', '60', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('189', 'mainmenu', 'Logo', 'logo', '', 'feature/utilities/logo', 'index.php?option=com_content&view=article&id=33', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '61', '62', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('190', 'mainmenu', 'To Top Button', 'to-top-button', '', 'feature/utilities/to-top-button', 'index.php?option=com_content&view=article&id=35', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '63', '64', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('191', 'mainmenu', 'System Message', 'system-message', '', 'feature/utilities/system-message', 'index.php?option=com_content&view=article&id=34', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '69', '70', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('229', 'hidden', 'Extensions', 'extensions', '', 'extensions', 'index.php?option=com_content&view=category&layout=blog&id=16', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"0\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '183', '184', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('195', 'mainmenu', 'Module Position', 'module-position', '', 'page/module-position', 'index.php?option=com_content&view=article&id=25', 'component', '1', '193', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_module_pos\":[\"search\"],\"fxmenu_modules\":[\"98\"]}', '178', '179', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('196', 'mainmenu', 'Utilities', 'utilities', '', 'feature/utilities', 'index.php?option=com_content&view=category&id=17', 'component', '1', '103', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"group\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '54', '73', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('224', 'mainmenu', 'Copyright', 'copyright', '', 'feature/utilities/copyright', 'index.php?option=com_content&view=article&id=29', 'component', '1', '196', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '71', '72', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('198', 'mainmenu', 'Menu', 'menu', '', 'feature/menu', '', 'separator', '1', '103', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"group\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '74', '79', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('225', 'mainmenu', 'Dropline menu', 'dropline-menu', '', 'feature/menu/dropline-menu', 'index.php?option=com_content&view=article&id=18', 'component', '1', '198', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_module_pos\":[\"color\"]}', '77', '78', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('199', 'mainmenu', 'Layout', 'layout', '', 'feature/layout', 'index.php?option=com_content&view=article&id=36', 'component', '1', '103', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":0,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"group\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"200px\",\"fxmenu_module_style\":\"jvxhtml\"}', '80', '93', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('197', 'mainmenu', 'System', 'features', '', 'feature/features', '', 'separator', '1', '103', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"\",\"menu_text\":0,\"fxmenu_item\":\"group\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '46', '53', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('201', 'mainmenu', 'Sidebar A - Content - Sidebar B', 'performance-optimization', '', 'feature/layout/performance-optimization', '?l=sb-c-sb', 'url', '1', '199', '3', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '81', '82', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('209', 'mainmenu', 'Sidebar A - Content', 'performance-optimization-2', '', 'feature/layout/performance-optimization-2', '?l=sb-c', 'url', '1', '199', '3', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '83', '84', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('159', 'mainmenu', 'Services', 'services', '', 'page/services', 'index.php?option=com_content&view=article&id=22', 'component', '1', '193', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_module_pos\":[\"search\"],\"fxmenu_modules\":[\"98\"]}', '176', '177', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('156', 'mainmenu', 'Typographies', 'typographies', '', 'feature/features/typographies', 'index.php?option=com_jvframework&view=typographies', 'component', '1', '197', '3', '10012', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '47', '48', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('160', 'mainmenu', 'Article Category Blog', 'article-category-blog', '', 'joomla/content-component/article-category-blog', 'index.php?option=com_content&view=category&layout=blog&id=8', 'component', '1', '130', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '123', '124', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('167', 'mainmenu', 'Users Component', 'users-component', '', 'joomla/users-component', 'index.php?option=com_content&view=article&id=19', 'component', '1', '111', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '144', '157', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('161', 'mainmenu', 'Article Archived', 'article-archived', '', 'joomla/content-component/article-archived', 'index.php?option=com_content&view=archive', 'component', '1', '130', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '117', '118', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('162', 'mainmenu', 'Featured Contact', 'featured-contact', '', 'joomla/contact-component/featured-contact', 'index.php?option=com_contact&view=featured', 'component', '1', '131', '3', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"94\"]}', '133', '134', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('163', 'mainmenu', 'Contact Categories', 'contact-categories', '', 'joomla/contact-component/contact-categories', 'index.php?option=com_contact&view=categories&id=0', 'component', '1', '131', '3', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"94\"]}', '129', '130', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('164', 'mainmenu', 'Submit weblink', 'submit-weblink', '', 'joomla/weblinks-component/submit-weblink', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', '1', '126', '3', '21', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\"]}', '137', '138', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('165', 'mainmenu', 'Weblink Single Category', 'weblink-single-category', '', 'joomla/weblinks-component/weblink-single-category', 'index.php?option=com_weblinks&view=category&id=11', 'component', '1', '126', '3', '21', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\"]}', '139', '140', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('166', 'mainmenu', 'Weblink Categories', 'weblink-categories', '', 'joomla/weblinks-component/weblink-categories', 'index.php?option=com_weblinks&view=categories&id=0', 'component', '1', '126', '3', '21', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"1\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\"]}', '141', '142', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('193', 'mainmenu', 'Page', 'page', '', 'page', '', 'separator', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"images\\/stories\\/menu\\/page.png\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_module_pos\":[\"search\"],\"fxmenu_modules\":[\"98\"]}', '175', '182', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('194', 'mainmenu', 'Error Page', 'error-page', '', 'page/error-page', 'index/error', 'url', '1', '193', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_module_pos\":[\"search\"],\"fxmenu_modules\":[\"98\"],\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '180', '181', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('168', 'mainmenu', 'Login Form', 'login-form', '', 'joomla/users-component/login-form', 'index.php?option=com_users&view=login', 'component', '1', '167', '3', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '145', '146', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('169', 'mainmenu', 'User Profile', 'user-profile', '', 'joomla/users-component/user-profile', 'index.php?option=com_users&view=profile', 'component', '1', '167', '3', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '147', '148', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('170', 'mainmenu', 'Edit User Profile', 'edit-user-profile', '', 'joomla/users-component/edit-user-profile', 'index.php?option=com_users&view=profile&layout=edit', 'component', '1', '167', '3', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '149', '150', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('171', 'mainmenu', 'Registration Form', 'registration-form', '', 'joomla/users-component/registration-form', 'index.php?option=com_users&view=registration', 'component', '1', '167', '3', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '151', '152', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('172', 'mainmenu', 'User Reminder Request', 'user-reminder-request', '', 'joomla/users-component/user-reminder-request', 'index.php?option=com_users&view=remind', 'component', '1', '167', '3', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '153', '154', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('173', 'mainmenu', 'Password Reset', 'password-reset', '', 'joomla/users-component/password-reset', 'index.php?option=com_users&view=reset', 'component', '1', '167', '3', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '155', '156', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('174', 'mainmenu', 'Search Component', 'search-component', '', 'joomla/search-component', 'index.php?option=com_content&view=article&id=20', 'component', '1', '111', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '158', '161', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('175', 'mainmenu', 'Search', 'search', '', 'joomla/search-component/search', 'index.php?option=com_finder&view=search&q=theme&f=', 'component', '1', '174', '3', '27', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_date_filters\":\"\",\"show_advanced\":\"\",\"expand_advanced\":\"\",\"show_description\":\"\",\"description_length\":255,\"show_url\":\"\",\"show_pagination_limit\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"allow_empty_query\":\"0\",\"sort_order\":\"\",\"sort_direction\":\"\",\"show_feed\":\"0\",\"show_feed_text\":\"0\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"200px\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '159', '160', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('176', 'mainmenu', 'News Feed', 'news-feed', '', 'joomla/news-feed', 'index.php?option=com_content&view=article&id=21', 'component', '1', '111', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '162', '169', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('177', 'mainmenu', 'Single News Feed', 'single-news-feed', '', 'joomla/news-feed/single-news-feed', 'index.php?option=com_newsfeeds&view=newsfeed&id=1', 'component', '1', '176', '3', '17', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '165', '166', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('178', 'mainmenu', 'News Feed Categories', 'news-feed-categories', '', 'joomla/news-feed/news-feed-categories', 'index.php?option=com_newsfeeds&view=categories&id=0', 'component', '1', '176', '3', '17', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '163', '164', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('179', 'mainmenu', 'News Feed Category', 'news-feed-category', '', 'joomla/news-feed/news-feed-category', 'index.php?option=com_newsfeeds&view=category&id=15', 'component', '1', '176', '3', '17', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"93\",\"94\",\"95\",\"96\"]}', '167', '168', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('213', 'mainmenu', 'Sidebar A - Sidebar B - Content', 'performance-optimization-4', '', 'feature/layout/performance-optimization-4', '?l=sb-sb-c', 'url', '1', '199', '3', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '87', '88', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('218', 'mainmenu', 'Content - Sidebar A - Sidebar B', 'performance-optimization-5', '', 'feature/layout/performance-optimization-5', '?l=c-sb-sb', 'url', '1', '199', '3', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '89', '90', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('221', 'mainmenu', 'Content - Sidebar B', 'performance-optimization-6', '', 'feature/layout/performance-optimization-6', '?l=c-sb', 'url', '1', '199', '3', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"1\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_modules\":[\"16\"]}', '85', '86', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('222', 'mainmenu', 'Style', 'style', '', 'style', '#', 'url', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"images\\/stories\\/menu\\/style.png\",\"menu_text\":1,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"Change theme style\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"565px\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_module_pos\":[\"color\"]}', '171', '174', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('223', 'mainmenu', 'Theme Color', 'theme-color', '', 'style/theme-color', '', 'separator', '1', '222', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"menu_image\":\"\",\"menu_text\":1,\"fxmenu_item\":\"position\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\",\"fxmenu_module_pos\":[\"color\"]}', '172', '173', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('226', 'mainmenu', 'Position layout effects', 'poslayef', '', 'feature/layout/poslayef', 'index.php?option=com_content&view=article&id=37', 'component', '1', '199', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '91', '92', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('277', 'hidden', 'Uncategorised', 'uncategorised', '', 'uncategorised', 'index.php?option=com_content&view=category&layout=blog&id=2', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"0\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '185', '186', '0', '*', '0');
INSERT INTO `#__menu` VALUES ('278', 'hidden', 'Joomla Cate', 'joomla-cate', '', 'joomla-cate', 'index.php?option=com_content&view=category&layout=blog&id=14', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"0\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"fxmenu_item\":\"0\",\"fxmenu_title\":\"1\",\"fxmenu_titlelink\":\"0\",\"fxmenu_description\":\"\",\"fxmenu_column\":\"1\",\"fxmenu_width\":\"\",\"fxmenu_subwidth\":\"\",\"fxmenu_module_style\":\"jvxhtml\"}', '187', '188', '0', '*', '0');

-- ----------------------------
-- Table structure for `#__menu_types`
-- ----------------------------
DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__menu_types
-- ----------------------------
INSERT INTO `#__menu_types` VALUES ('1', 'mainmenu', 'Main Menu', 'The main menu for the site');
INSERT INTO `#__menu_types` VALUES ('2', 'joomla', 'Joomla', '');
INSERT INTO `#__menu_types` VALUES ('3', 'hidden', 'Hidden', '');

-- ----------------------------
-- Table structure for `#__messages`
-- ----------------------------
DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__messages
-- ----------------------------

-- ----------------------------
-- Table structure for `#__messages_cfg`
-- ----------------------------
DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__messages_cfg
-- ----------------------------

-- ----------------------------
-- Table structure for `#__modules`
-- ----------------------------
DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=134 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__modules
-- ----------------------------
INSERT INTO `#__modules` VALUES ('1', 'Main Menu (Dropdown)', '', '', '1', 'menu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"jvmenutyle\":\"flex\",\"flexmenu_style\":\"horizontal\",\"flexconfig\":\"{\\\"defaultEff\\\":{\\\"showEff\\\":{\\\"duration\\\":500,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"slide\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":500,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}},\\\"customEff\\\":[{\\\"@data\\\":{\\\"level\\\":\\\"2\\\",\\\"showEff\\\":{\\\"duration\\\":250,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"slide\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"left\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":500,\\\"delay\\\":300,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}}},{\\\"@data\\\":{\\\"level\\\":\\\"3\\\",\\\"showEff\\\":{\\\"duration\\\":250,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"blind\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":200,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}}}]}\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('2', 'Login', '', '', '1', 'login', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_login', '1', '1', '', '1', '*');
INSERT INTO `#__modules` VALUES ('3', 'Popular Articles', '', '', '3', 'cpanel', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_popular', '3', '1', '{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', '1', '*');
INSERT INTO `#__modules` VALUES ('4', 'Recently Added Articles', '', '', '4', 'cpanel', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_latest', '3', '1', '{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', '1', '*');
INSERT INTO `#__modules` VALUES ('8', 'Toolbar', '', '', '1', 'toolbar', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_toolbar', '3', '1', '', '1', '*');
INSERT INTO `#__modules` VALUES ('9', 'Quick Icons', '', '', '1', 'icon', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_quickicon', '3', '1', '', '1', '*');
INSERT INTO `#__modules` VALUES ('10', 'Logged-in Users', '', '', '2', 'cpanel', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_logged', '3', '1', '{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', '1', '*');
INSERT INTO `#__modules` VALUES ('12', 'Admin Menu', '', '', '1', 'menu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '3', '1', '{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}', '1', '*');
INSERT INTO `#__modules` VALUES ('13', 'Admin Submenu', '', '', '1', 'submenu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_submenu', '3', '1', '', '1', '*');
INSERT INTO `#__modules` VALUES ('14', 'User Status', '', '', '2', 'status', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_status', '3', '1', '', '1', '*');
INSERT INTO `#__modules` VALUES ('15', 'Title', '', '', '1', 'title', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_title', '3', '1', '', '1', '*');
INSERT INTO `#__modules` VALUES ('16', 'Login', '', '', '1', 'login', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_login', '1', '1', '{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('124', 'test', '', '<p>teset tendjhtrhtdnf kjieuhtrjjf ndihj ei rjekfj doljte</p>', '0', 'left-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('79', 'Multilanguage status', '', '', '1', 'status', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_multilangstatus', '3', '1', '{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '1', '*');
INSERT INTO `#__modules` VALUES ('86', 'Joomla Version', '', '', '1', 'footer', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_version', '3', '1', '{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '1', '*');
INSERT INTO `#__modules` VALUES ('88', 'slide', '', '<div class=\"custom-slide\">\r\n<div class=\"items\"><img src=\"images/stories/banner/banner1.jpg\" border=\"0\" alt=\"banner1\" /></div>\r\n<div class=\"description\">\r\n<h1>JV Framework 3.0</h1>\r\n<h4>Compatible with many devices</h4>\r\n<div class=\"desc\">Thank to a flexible responsive layout and mobile-exclusive layout, JV Framework is compatible with a wide variety of devices of devices, from PCs to Tablets and Mobiles.</div>\r\n<div class=\"readmore\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=11:mobility-support&amp;catid=8&amp;Itemid=184\"><img src=\"images/stories/banner/readmore.png\" border=\"0\" alt=\"read more\" /></a></div>\r\n</div>\r\n</div>', '1', 'slide', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('89', 'slide 2', '', '<div class=\"custom-slide\">\r\n<div class=\"items\"><img src=\"images/stories/banner/banner2.jpg\" border=\"0\" alt=\"banner2\" /></div>\r\n<div class=\"description\">\r\n<h1>JV Framework 3.0</h1>\r\n<h4>Making it easier</h4>\r\n<div class=\"desc\">Faster and lighter, more customizable, new menu type, better mobile support, and more...<br /> JV Framework always strive to make itself easier, for casual users and developers alike.</div>\r\n<div class=\"readmore\"><a href=\"index.php?option=com_content&amp;view=category&amp;id=16&amp;Itemid=135\"><img src=\"images/stories/banner/find-more.png\" border=\"0\" alt=\"img\" /></a></div>\r\n</div>\r\n</div>', '1', 'slide', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('108', 'Pathway', '', '', '1', 'breadcrumb', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_breadcrumbs', '1', '1', '{\"showHere\":\"0\",\"showHome\":\"1\",\"homeText\":\"\",\"showLast\":\"1\",\"separator\":\"\\/\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('91', 'Customizability', '', '<p><img src=\"images/stories/demo/customizable.png\" border=\"0\" alt=\"img\" style=\"display: block; margin-left: auto; margin-right: auto;\" /></p>\r\n<p>JV Framework itself is customizable, allowing users and 3rd parties to expand the component\'s functions via Extensions, as well as overriding the default Extensions.</p>', '1', 'top-2', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('92', 'Easy to style', '', '<p><img src=\"images/stories/demo/easy-style.png\" border=\"0\" alt=\"img\" style=\"display: block; margin-left: auto; margin-right: auto;\" /></p>\r\n<p>With JV Framework, various visual aspect of your site like font, text color, background can be changed and applied to different parts of your page like menu, module and body rather easily.</p>', '1', 'top-3', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('93', 'Bottom 1', '', '<p>Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Etiam porta sem malesuada magna mollis euismod. Donec sed odio dui.</p>', '1', 'bottom-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('94', 'Bottom 2', '', '<p>Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Etiam porta sem malesuada magna mollis euismod. Donec sed odio dui.</p>', '1', 'bottom-2', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('110', 'Get JV Framework', '', '', '3', 'right-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_banners', '1', '0', '{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"13\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('95', 'Bottom 3', '', '<p>Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Etiam porta sem malesuada magna mollis euismod. Donec sed odio dui.</p>', '1', 'bottom-3', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('107', 'Responsive Design', '', '<p><img src=\"images/stories/demo/respons-design.png\" border=\"0\" alt=\"img\" style=\"display: block; margin-left: auto; margin-right: auto;\" /></p>\r\n<p>JV Framework feature a fluid and responsive layout, capable of adapting itself to fit different window sizes and device solutions, from desktops to tablets and mobiles.</p>', '1', 'top-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('96', 'Bottom 4', '', '<p>Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Etiam porta sem malesuada magna mollis euismod. Donec sed odio dui.</p>', '1', 'bottom-4', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('112', 'Typographies', '', '<ul>\r\n<li>[note]Your content goes here![/note]</li>\r\n<li>[notice]Notice[/notice]</li>\r\n<li>[message]Your text here[/message]</li>\r\n</ul>', '1', 'typography', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('97', 'Joomla', '', '', '1', 'right-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"joomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" mobile-collpase\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"jvmenutyle\":\"flex\",\"flexmenu_style\":\"accordion\",\"flexconfig\":\"{\\\"defaultEff\\\":{\\\"showEff\\\":{\\\"duration\\\":500,\\\"delay\\\":300,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"slide\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"right\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":500,\\\"delay\\\":300,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}},\\\"customEff\\\":[]}\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('121', 'Main Menu (Dropline)', '', '', '1', 'menu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"jvmenutyle\":\"flex\",\"flexmenu_style\":\"dropline\",\"flexconfig\":\"{\\\"defaultEff\\\":{\\\"showEff\\\":{\\\"duration\\\":250,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"blind\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":250,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}},\\\"customEff\\\":[{\\\"@data\\\":{\\\"level\\\":\\\"2\\\",\\\"showEff\\\":{\\\"duration\\\":250,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"slide\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":500,\\\"delay\\\":300,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}}},{\\\"@data\\\":{\\\"level\\\":\\\"3\\\",\\\"showEff\\\":{\\\"duration\\\":250,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"blind\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}},\\\"hideEff\\\":{\\\"duration\\\":200,\\\"delay\\\":100,\\\"easing\\\":\\\"linear\\\",\\\"effect\\\":{\\\"@selected\\\":\\\"fade\\\",\\\"blind\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"clip\\\":{\\\"direction\\\":\\\"vertical\\\"},\\\"drop\\\":{\\\"direction\\\":\\\"up\\\"},\\\"fold\\\":{\\\"horizFirst\\\":false,\\\"size\\\":\\\"15\\\"},\\\"slide\\\":{\\\"direction\\\":\\\"up\\\",\\\"distance\\\":\\\"\\\"},\\\"fade\\\":\\\"\\\"}}}}]}\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('98', 'Search', '', '', '1', 'search', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_search', '1', '1', '{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('99', 'Text widget', '', '<ul class=\"introduction\">\r\n<li class=\"well\">\r\n<h3 class=\"subtitle\">Latest works</h3>\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla lectus mauris, fringilla eget dignissim sed, commodo non nisl. Integer ac massa est, non posuere dui. In hac habitasse platea dictumst</div>\r\n</li>\r\n<li>\r\n<h3 class=\"subtitle\">Our products</h3>\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla lectus mauris, fringilla eget dignissim sed, commodo non nisl. Integer ac massa est, non posuere dui. In hac habitasse platea dictumst</div>\r\n</li>\r\n</ul>', '4', 'right-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('100', 'Gallery', '', '<div> [JVGALLERY]{\"images\":[ {\"img\":\"images/gallery/cooking.jpg\",\"title\":\"JV Cooking\",\"desc\":\"\"},{\"img\":\"images/gallery/deal.jpg\",\"title\":\"JV Deal\",\"desc\":\"\"},{\"img\":\"images/gallery/photo.jpg\",\"title\":\"JV Photo\",\"desc\":\"\"},{\"img\":\"images/gallery/hotel.jpg\",\"title\":\"JV Hotel\",\"desc\":\"\"},{\"img\":\"images/gallery/videoHD.jpg\",\"title\":\"JV Video\",\"desc\":\"\"},{\"img\":\"images/gallery/style.jpg\",\"title\":\"JV Style\",\"desc\":\"\"},{\"img\":\"images/gallery/joomlavi.jpg\",\"title\":\"Joomlavi\",\"desc\":\"\"},{\"img\":\"images/gallery/interior.jpg\", \"title\":\"JV Interior\",\"desc\":\"\"}],\"options\":{\"theme\":\"style6\",\"lightbox\":\"fancybox\",\"width\":\"75\",\"height\":\"75\", \"gutter\": \"5\", \"showtitle\":\"0\",\"showdesc\":\"0\"}}[/JVGALLERY]</div>', '1', 'right-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', '0', '*');
INSERT INTO `#__modules` VALUES ('132', 'footer', '', '', '0', 'footer', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_footer', '1', '0', '{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');

-- ----------------------------
-- Table structure for `#__modules_menu`
-- ----------------------------
DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__modules_menu
-- ----------------------------
INSERT INTO `#__modules_menu` VALUES ('1', '-225');
INSERT INTO `#__modules_menu` VALUES ('2', '0');
INSERT INTO `#__modules_menu` VALUES ('3', '0');
INSERT INTO `#__modules_menu` VALUES ('4', '0');
INSERT INTO `#__modules_menu` VALUES ('6', '0');
INSERT INTO `#__modules_menu` VALUES ('7', '0');
INSERT INTO `#__modules_menu` VALUES ('8', '0');
INSERT INTO `#__modules_menu` VALUES ('9', '0');
INSERT INTO `#__modules_menu` VALUES ('10', '0');
INSERT INTO `#__modules_menu` VALUES ('12', '0');
INSERT INTO `#__modules_menu` VALUES ('13', '0');
INSERT INTO `#__modules_menu` VALUES ('14', '0');
INSERT INTO `#__modules_menu` VALUES ('15', '0');
INSERT INTO `#__modules_menu` VALUES ('16', '0');
INSERT INTO `#__modules_menu` VALUES ('79', '0');
INSERT INTO `#__modules_menu` VALUES ('86', '0');
INSERT INTO `#__modules_menu` VALUES ('88', '0');
INSERT INTO `#__modules_menu` VALUES ('89', '0');
INSERT INTO `#__modules_menu` VALUES ('91', '101');
INSERT INTO `#__modules_menu` VALUES ('92', '101');
INSERT INTO `#__modules_menu` VALUES ('93', '101');
INSERT INTO `#__modules_menu` VALUES ('94', '101');
INSERT INTO `#__modules_menu` VALUES ('95', '101');
INSERT INTO `#__modules_menu` VALUES ('96', '101');
INSERT INTO `#__modules_menu` VALUES ('97', '-195');
INSERT INTO `#__modules_menu` VALUES ('97', '-194');
INSERT INTO `#__modules_menu` VALUES ('97', '-159');
INSERT INTO `#__modules_menu` VALUES ('98', '0');
INSERT INTO `#__modules_menu` VALUES ('99', '-195');
INSERT INTO `#__modules_menu` VALUES ('99', '-194');
INSERT INTO `#__modules_menu` VALUES ('99', '-159');
INSERT INTO `#__modules_menu` VALUES ('100', '-195');
INSERT INTO `#__modules_menu` VALUES ('100', '-194');
INSERT INTO `#__modules_menu` VALUES ('100', '-159');
INSERT INTO `#__modules_menu` VALUES ('107', '101');
INSERT INTO `#__modules_menu` VALUES ('108', '-195');
INSERT INTO `#__modules_menu` VALUES ('110', '-195');
INSERT INTO `#__modules_menu` VALUES ('110', '-194');
INSERT INTO `#__modules_menu` VALUES ('110', '-159');
INSERT INTO `#__modules_menu` VALUES ('112', '0');
INSERT INTO `#__modules_menu` VALUES ('121', '225');
INSERT INTO `#__modules_menu` VALUES ('124', '201');
INSERT INTO `#__modules_menu` VALUES ('124', '209');
INSERT INTO `#__modules_menu` VALUES ('124', '213');
INSERT INTO `#__modules_menu` VALUES ('124', '218');
INSERT INTO `#__modules_menu` VALUES ('124', '221');
INSERT INTO `#__modules_menu` VALUES ('132', '0');

-- ----------------------------
-- Table structure for `#__newsfeeds`
-- ----------------------------
DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__newsfeeds
-- ----------------------------
INSERT INTO `#__newsfeeds` VALUES ('15', '1', 'Demo Feed', 'demo-feed', 'http://www.joomlavi.com/?format=feed', null, '1', '3', '3600', '0', '0000-00-00 00:00:00', '1', '0', '1', '*', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}', '2012-08-14 02:25:26', '204', '', '0000-00-00 00:00:00', '0', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- ----------------------------
-- Table structure for `#__overrider`
-- ----------------------------
DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__overrider
-- ----------------------------

-- ----------------------------
-- Table structure for `#__schemas`
-- ----------------------------
DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__schemas
-- ----------------------------
INSERT INTO `#__schemas` VALUES ('700', '2.5.7');

-- ----------------------------
-- Table structure for `#__template_styles`
-- ----------------------------
DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__template_styles
-- ----------------------------
INSERT INTO `#__template_styles` VALUES ('2', 'bluestork', '1', '0', 'Bluestork - Default', '{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}');
INSERT INTO `#__template_styles` VALUES ('3', 'atomic', '0', '0', 'Atomic - Default', '{}');
INSERT INTO `#__template_styles` VALUES ('4', 'beez_20', '0', '0', 'Beez2 - Default', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}');
INSERT INTO `#__template_styles` VALUES ('5', 'hathor', '1', '0', 'Hathor - Default', '{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}');
INSERT INTO `#__template_styles` VALUES ('6', 'beez5', '0', '0', 'Beez5 - Default', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"html5\":\"0\"}');
INSERT INTO `#__template_styles` VALUES ('7', 'jv-framework', '0', '1', 'JV-Framework', '{}');
INSERT INTO `#__template_styles` VALUES ('13', 'isis', '1', '1', 'isis - Default', '{\"templateColor\":\"\",\"logoFile\":\"\",\"admin_menus\":\"1\",\"displayHeader\":\"1\",\"statusFixed\":\"1\",\"stickyToolbar\":\"1\"}');

-- ----------------------------
-- Table structure for `#__update_sites`
-- ----------------------------
DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Update Sites';

-- ----------------------------
-- Records of #__update_sites
-- ----------------------------
INSERT INTO `#__update_sites` VALUES ('1', 'Joomla Core', 'collection', 'http://update.joomla.org/core/sts/list_sts.xml', '1', '0');
INSERT INTO `#__update_sites` VALUES ('2', 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', '1', '0');
INSERT INTO `#__update_sites` VALUES ('3', 'Accredited Joomla! Translations', 'collection', 'http://update.joomla.org/language/translationlist_3.xml', '1', '0');
INSERT INTO `#__update_sites` VALUES ('4', '', 'collection', 'http://update.joomlavi.com/list.xml', '1', '0');

-- ----------------------------
-- Table structure for `#__update_sites_extensions`
-- ----------------------------
DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

-- ----------------------------
-- Records of #__update_sites_extensions
-- ----------------------------
INSERT INTO `#__update_sites_extensions` VALUES ('1', '700');
INSERT INTO `#__update_sites_extensions` VALUES ('2', '700');
INSERT INTO `#__update_sites_extensions` VALUES ('3', '600');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10000');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10001');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10012');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10018');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10121');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10122');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10123');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10124');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10125');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10127');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10128');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10129');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10130');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10131');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10132');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10133');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10134');
INSERT INTO `#__update_sites_extensions` VALUES ('4', '10135');

-- ----------------------------
-- Table structure for `#__updates`
-- ----------------------------
DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Available Updates';

-- ----------------------------
-- Records of #__updates
-- ----------------------------

-- ----------------------------
-- Table structure for `#__user_notes`
-- ----------------------------
DROP TABLE IF EXISTS `#__user_notes`;
CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__user_notes
-- ----------------------------

-- ----------------------------
-- Table structure for `#__user_profiles`
-- ----------------------------
DROP TABLE IF EXISTS `#__user_profiles`;
CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';

-- ----------------------------
-- Records of #__user_profiles
-- ----------------------------

-- ----------------------------
-- Table structure for `#__user_usergroup_map`
-- ----------------------------
DROP TABLE IF EXISTS `#__user_usergroup_map`;
CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__user_usergroup_map
-- ----------------------------
INSERT INTO `#__user_usergroup_map` VALUES ('204', '8');

-- ----------------------------
-- Table structure for `#__usergroups`
-- ----------------------------
DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__usergroups
-- ----------------------------
INSERT INTO `#__usergroups` VALUES ('1', '0', '1', '18', 'Public');
INSERT INTO `#__usergroups` VALUES ('2', '1', '8', '15', 'Registered');
INSERT INTO `#__usergroups` VALUES ('3', '2', '9', '14', 'Author');
INSERT INTO `#__usergroups` VALUES ('4', '3', '10', '13', 'Editor');
INSERT INTO `#__usergroups` VALUES ('5', '4', '11', '12', 'Publisher');
INSERT INTO `#__usergroups` VALUES ('6', '1', '4', '7', 'Manager');
INSERT INTO `#__usergroups` VALUES ('7', '6', '5', '6', 'Administrator');
INSERT INTO `#__usergroups` VALUES ('8', '1', '16', '17', 'Super Users');
INSERT INTO `#__usergroups` VALUES ('9', '1', '2', '3', 'Guest');

-- ----------------------------
-- Table structure for `#__users`
-- ----------------------------
DROP TABLE IF EXISTS `#__users`;
CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=InnoDB AUTO_INCREMENT=205 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__users
-- ----------------------------
INSERT INTO `#__users` VALUES ('204', 'Super User', 'admin', 'info@joomlavi.com', '0d96f59d1c1c5a70abb2bd15d05c8fe8:gjePVbIeuXE8ysFQMTmsnFXo2Hhu1BsJ', '0', '1', '2012-10-12 04:12:09', '2012-11-02 10:07:06', '0', '', '0000-00-00 00:00:00', '0');

-- ----------------------------
-- Table structure for `#__viewlevels`
-- ----------------------------
DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__viewlevels
-- ----------------------------
INSERT INTO `#__viewlevels` VALUES ('1', 'Public', '0', '[1]');
INSERT INTO `#__viewlevels` VALUES ('2', 'Registered', '1', '[6,2,8]');
INSERT INTO `#__viewlevels` VALUES ('3', 'Special', '2', '[6,3,8]');

-- ----------------------------
-- Table structure for `#__weblinks`
-- ----------------------------
DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of #__weblinks
-- ----------------------------
INSERT INTO `#__weblinks` VALUES ('1', '11', '0', 'joomlavi.com', 'joomlavi', 'http://joomlavi.com', '<p>Joomla Template Club</p>', '0000-00-00 00:00:00', '3', '1', '0', '0000-00-00 00:00:00', '1', '0', '1', '1', '{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}', '*', '2012-07-30 03:55:14', '204', '', '2012-07-30 04:24:19', '92', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');
INSERT INTO `#__weblinks` VALUES ('2', '12', '0', 'webtop.vn', 'webtop', 'http://webtop.vn', '<p>Webdesign</p>', '0000-00-00 00:00:00', '0', '1', '0', '0000-00-00 00:00:00', '1', '0', '1', '1', '{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}', '*', '2012-07-30 03:55:14', '204', '', '2012-07-30 05:05:24', '92', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');
INSERT INTO `#__weblinks` VALUES ('3', '12', '0', 'Danh ba viet nam', 'danh-ba-viet-nam', 'http://aloo.vn/', '', '0000-00-00 00:00:00', '1', '1', '0', '0000-00-00 00:00:00', '2', '0', '1', '1', '', '*', '2012-09-17 03:29:49', '204', '', '0000-00-00 00:00:00', '0', '', '', '', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');
